--特殊球出现范围
function speColor()
	shootSpeBall = {}
	if retryLev >= rateLev.first and retryLev < rateLev.second then
		shootSpeBall = shootSpeBall1
	elseif retryLev >= rateLev.second and retryLev < rateLev.third then
		shootSpeBall = shootSpeBall2
	elseif retryLev >= rateLev.third and retryLev < rateLev.fourth then
		shootSpeBall = shootSpeBall3
    elseif retryLev >= rateLev.fourth and retryLev < rateLev.fifth then
		shootSpeBall = shootSpeBall4	
	elseif retryLev >= rateLev.fifth and retryLev < rateLev.six then
		shootSpeBall = shootSpeBall5
	elseif retryLev >= rateLev.six then
		shootSpeBall = shootSpeBall6
	end
end

function shootRandom()
	local ran = math.random(100 * srb1.num)
    local shootLen = #shootComBall
	local rateTable = {}
	local rateStr = nil
	if retryLev >= rateLev.first and retryLev < rateLev.second then
		rateStr = "shootRate1_"..shootLen
	elseif retryLev >= rateLev.second and retryLev < rateLev.third then
		rateStr = "shootRate2_"..shootLen
	elseif retryLev >= rateLev.third and retryLev < rateLev.fourth then
		rateStr = "shootRate3_"..shootLen
    elseif retryLev >= rateLev.fourth and retryLev < rateLev.fifth then
		rateStr = "shootRate4_"..shootLen	
	elseif retryLev >= rateLev.fifth and retryLev < rateLev.six then
		rateStr = "shootRate5_"..shootLen
	elseif retryLev >= rateLev.six then
		rateStr = "shootRate6_"..shootLen
	end
    rateTable = shootTableAlls[rateStr]
	if not rateTable then
		rateTable = shootTableAlls["shootRate1_2"]
	end
	local length = #rateTable
	--cclog("shoot-ran = "..ran..", length = "..length..",shootLen = "..shootLen..",rateStr = "..rateStr)	
	local posBB=nil
	for i = 1, length do
        --cclog("---ran = "..ran..", rate = "..rateTable[i]..", i = "..i)
		if ran < rateTable[i] then
			posBB = shootComBall[i]
			break
		end
	end
    if not posBB then
        posBB = 1
    end        
    --cclog("----------------color = "..posBB..",ran = "..ran)
	return posBB
end


function colorSame()
    shootComBall = searchEye_baseBubs()
    --cclog("------------#shootComBall = "..#shootComBall)
	if #shootComBall == 0 then
		table.insert(shootComBall, speBubs.mul)
	else
        --cclog("colorSame-shootComBall-before="..#shootComBall)
        for k = 1, #shootSpeBall do
            if not isBubKey(shootSpeBall[k]) then
                table.insert(shootComBall, shootSpeBall[k])
            end
        end
    end
	--cclog("colorSame-shootComBall-last="..#shootComBall)
end

function getShBub()
	local bubTmp = 0
	if shootTmps and not zeroShootFlag then
        for m = 1, #shootTmps do
			bubTmp = shootTmps[m]
			if bubTmp ~= 0 then
				shootTmps[m] = 0
				break
			end
			if m == #shootTmps then
				zeroShootFlag = true
			end
		end
	end
	
	if retryLev <= 3 then
		if bubTmp == 0 then
			bub1 = bub2
			local table1 = searchEye_baseBubs()
			if table1 and #table1 > 0 then
				bubTmp = table1[math.random(#table1)]
			else
				bubTmp = math.random(8)
			end
		end
	else
		if zeroShootFlag and not speShootFlag then		
			local ran = math.random(#shootSpeBall)
			bubTmp = shootSpeBall[ran]
			speShootFlag = true
		elseif zeroShootFlag and speShootFlag then
		   bubTmp = shootRandom() 
		end
		upRate(bubTmp)
    
		--强化后变颜色
		strChColor()	    
		changRate()
	end
	return bubTmp
end

function startReadyBubOneTime()
	initRate()
	bub1 = getShBub()
	bub2 = getShBub()
    
    --强化后变颜色
    strChColor()
end

function change2Bub()
    if zeroShootFlag then
        colorSame()
    end
    bub1 = bub2
	bub2 = getShBub()
end

--强化后变颜色
function strChColor()
    if bub1 == speBubs.bomb and isStrength(strengthSeq.bombRes) then
        bub1 = speBubs.bomb_s
    elseif bub1 == speBubs.bubV and isStrength(strengthSeq.vRes1) then
        bub1 = speBubs.bubV_s
    elseif bub1 == speBubs.steel and isStrength(strengthSeq.steelDis) then
        bub1 = speBubs.steel_s
    elseif bub1 == speBubs.ice and isStrength(strengthSeq.iceTime) then
        bub1 = speBubs.ice_s
    elseif bub1 == speBubs.wave and isStrength(strengthSeq.waveRes) then
        bub1 = speBubs.wave_s
    end

    if bub2 == speBubs.bomb and isStrength(strengthSeq.bombRes) then
        bub2 = speBubs.bomb_s
    elseif bub2 == speBubs.bubV and isStrength(strengthSeq.vRes1) then
        bub2 = speBubs.bubV_s
    elseif bub2 == speBubs.steel and isStrength(strengthSeq.steelDis) then
        bub2 = speBubs.steel_s
    elseif bub2 == speBubs.ice and isStrength(strengthSeq.iceTime) then
        bub2 = speBubs.ice_s
    elseif bub2 == speBubs.wave and isStrength(strengthSeq.waveRes) then
        bub2 = speBubs.wave_s
    end
end

function initRate()
	shootTableAlls = shootTableAlls_up1
	zeroShootFlag = false
	speShootFlag = false
	warnLineFlag = false
	upFlag = false
	--hujian
	shakyFlag = true
	lastUseTime = os.time()
	local shootBalls = allLevelData["serveballs"]["balls"]
	shootTmps = shootBalls
	speColor()
	colorSame()
end

function upRate(bubUp)
	if bubUp == speBubs.mul or isBomb(bubUp) then
		rateValue()
	end
end

function rateValue()
	local curUseTime = os.time()
	if curUseTime - lastUseTime > srb1.delay then
		shootTableAlls = shootTableAlls_up1
		lastUseTime = curUseTime
		upFlag = true
	else
		upFlag = false
	end
end

function changRate()
	if not upFlag and warnLineFlag and conNum >= rateLev.con1 then --and conNum <= rateLev.con2 then
		shootTableAlls = shootTableAlls_up1
	else
		shootTableAlls = shootTableAlls_up1
	end
end

------特殊球解锁概率---100%解锁--
function suc_lockSpe()
    --cclog("-1--suc_lockSpe--")
    local unlockFlag = false
    for i = 1, unlockNums do
        if retryLev >= speUnlockLev[i] then
            for j = i, unlockNums do
                local str = "x_unlock_bub"..speUnlockBub[j]
                if infoSours and infoSours[str] == 0 then 
                    infoSours[str] = 1
                    unlockFlag = true
                end
            end
            break
        end
    end
end
