local sharedScheduler = director:getScheduler()

function stopSchedule()
	sharedScheduler:unscheduleScriptEntry(runningBubHandleId)
	sharedScheduler:unscheduleScriptEntry(gameLayerHandleId)
	sharedScheduler:unscheduleScriptEntry(goldAutoCrackHandleId)
	sharedScheduler:unscheduleScriptEntry(levelStartHandleId)
	sharedScheduler:unscheduleScriptEntry(twoCurScoreHandleId)
	sharedScheduler:unscheduleScriptEntry(ranShakeBubHandleId)
    sharedScheduler:unscheduleScriptEntry(ranEmptyBubHandleId)
    sharedScheduler:unscheduleScriptEntry(introScheHandleId)
    sharedScheduler:unscheduleScriptEntry(smaLevHandleId)
    sharedScheduler:unscheduleScriptEntry(larLevHandleId)
    if ranDoorScheHandleId then 
        sharedScheduler:unscheduleScriptEntry(ranDoorScheHandleId)
    end
	if ranBossSepScheHandleId then
		sharedScheduler:unscheduleScriptEntry(ranBossSepScheHandleId)
	end
	if ranBossLarTimeScheHandleId then
		sharedScheduler:unscheduleScriptEntry(ranBossLarTimeScheHandleId)
	end	
	--sharedScheduler:unscheduleScriptEntry(achTipScheHandleId)
    if nearFailSoundScheHandleId then
        sharedScheduler:unscheduleScriptEntry(nearFailSoundScheHandleId)
    end
    --bubble1.4   hujian
    if hj_sucEffectID then
        sharedScheduler:unscheduleScriptEntry(hj_sucEffectID)
    end
end

function stopSepSche(id)
    if id then
        sharedScheduler:unscheduleScriptEntry(id)
    end
end

function controlShootByXYSchedule()
	stabFlag = false
	stabBub = {}
    scheFlag = true
end

function controlGameLayer()
    levelStartHandleId = sharedScheduler:scheduleScriptFunc(gameLayerStart, scheTime.controlScheTime, false)
    levelStartFlag = 1
end

function gameLayerStart()
  local _x,_y = shootLayer:getPosition()
  if _y >= 0 then
		sharedScheduler:unscheduleScriptEntry(levelStartHandleId)   
        startReadyBubOneTime()
        sprBallCur = getBubSprite(bub1, 2)
        jBjLayer:addChild(sprBallCur, 1, tagNums["jBjLayer"].bub1)
        changeBubFlag = false
        readyGoFlag = false		
		soundLevStart()
        local readyGoSpr = CCSprite:create(REPATHLT.."readyGo.png")
		readyGoSpr:setPosition(screenWidth / 2, screenHeight / 2)
		readyGoSpr:setScale(0.1)
        twoLayer:addChild(readyGoSpr)
        local arr = CCArray:create()
        arr:addObject(CCScaleTo:create(0.3, 1.6))
        arr:addObject(CCScaleTo:create(0.15, 1))
        arr:addObject(CCFadeOut:create(0.25))
        local seqCss = CCSequence:create(arr)
        readyGoSpr:runAction(seqCss)
        performWithDelay(0.8, afterGo_lt)
        table.insert(effectTwoTable, readyGoSpr)
  else
	  if isGameLayerPause then
			changeBubFlag = false
            _y = _y + speNums.gameLayerUp
            shootLayer:setPosition(_x,_y)
	  end
  end
end

function afterGo_lt()
    local readyGoSpr = CCSprite:create(REPATHLT.."readyGo1.png")
	readyGoSpr:setPosition(screenWidth / 2, screenHeight / 2)
	readyGoSpr:setScale(0.1)
    twoLayer:addChild(readyGoSpr)
    local arr = CCArray:create()
    arr:addObject(CCScaleTo:create(0.3, 2))
    arr:addObject(CCScaleTo:create(0.15, 1))
    arr:addObject(CCFadeOut:create(0.25))
    local seqCss = CCSequence:create(arr)
    readyGoSpr:runAction(seqCss)
    performWithDelay(1, afterReady_lt)
    table.insert(effectTwoTable, readyGoSpr)
end

function afterReady_lt()
    --getSpeed()
    --getdropSpeed()
    dSpeed = dropSpeeds["lev_"..retryLev]
    gameLayerMoveShce()
    goldAutoCrackSchedule()
    randomShakeSche()
    randomEmptySche()
	--tipAchSche()
    introSchedule()
    if isDoor() then randomDoorSche() end
	if isBoss() then randomBossSepSche() end
    levelStartFlag = 0
    local warnSprite = CCSprite:create(REPATH.."warnLine0.png")
    warnSprite:setPosition(screenWidth / 2, linePot.e)
    gameBgLayer:addChild(warnSprite, 1, tagNums["gameBgLayer"].wLine0)
     --         生命线上的光亮    --hujian
    local linelight = CCSprite:create(REPATH.."lightpoint.png")
    linelight:setPosition(50,linePot.e)    
    gameBgLayer:addChild(linelight,2,tagNums["gameBgLayer"].linelight)
    lightAction(linelight)
    performWithDelay(0.2, initTwoBalls)
    if isBoss() then
        aniBoss()
    end

    -- --bubble1.4    hujian
    -- if hj_curLev >= 6 and infoSours["hj_allLevs"..hj_curLev] == 0 then
    --     fileAll()
    --     -- performWithDelay(2,buyWave_Top)
    --     buyWave_Top()
    -- else
    -- end
end

function gameLayerMoveShce()
    gameLayerHandleId = sharedScheduler:scheduleScriptFunc(gameLayerMove, scheTime.runScheTime, false)
end

function gameLayerMove()
	if isGameLayerPause then
        if waveFlag then
            isFail()
            scanBossEye()
        end
        if isIceFlag then
            gameLayerX, gameLayerY = shootLayer:getPosition()
            shootLayer:setPosition(gameLayerX, gameLayerY - speNums.moveDis/2)
            startY = startY - speNums.moveDis/2
            if retryLev == 1 and waveFlag and infoSours["x_intro_key"] == 0 then
                scanKeyEye()
            end
        end
    end
    if isGameLayerPause and scheFlag then    
        if gLinked then
            gLinked = gLinked + 1
            if gLinked >= 1 then
                lastDelLinkBubs()
                gLinked = nil
            end
            return        
        elseif gBomb then
            gBomb = gBomb + 1
            if gBomb >= 1 then
                bombDelLinkBubs()
                gBomb = nil
            end
            return
        elseif gKey then
            gKey = gKey + 1
            if gKey >= 1 then
                keyDeal(gKeyBub)
                gKey = nil
            end
            return
        else
            shootAndLink()
        end          
    end   
end

function goldAutoCrackSchedule()
	goldAutoCrackHandleId = sharedScheduler:scheduleScriptFunc(goldAutoCrack, scheTime.goldScheTime, false)
end

function goldAutoCrack()
	if isGameLayerPause then
		goldBall()
	end
end

function controlTwoCurScore()
	twoCurScoreScheFlag = true
    twoCurScoreHandleId = sharedScheduler:scheduleScriptFunc(twoCurScoreSche, 0.01, false)
end

function twoCurScoreSche()
	if twoCurScoreScheFlag then
		if incAll <= 0 then
			twoCurScoreScheFlag = false			
		end
		mainScorePic(100)
        if not mainBestScoreFlag then
            mainBestScorePic(100)
        end
		incAll = incAll - 100
	else
		sharedScheduler:unscheduleScriptEntry(twoCurScoreHandleId)
	end
end

function randomShakeSche()
	ranShakeBubHandleId = sharedScheduler:scheduleScriptFunc(randShake, scheTime.shakeScheTime, false)
end

function randShake()
	if curBubLevel and isGameLayerPause and isIceFlag then
		local shakeSpr = getShakeTalbe()
		if shakeSpr then
            local xs,ys = new_hex(shakeSpr.seq)
			shakBubble(xs, ys, 3)
		end
	end
end

function getShakeTalbe()
    local disG = gStartY - startY
	local shakeTable = {}
	if curBubLevel then
		for i=#curBubLevel, 1, -1 do
			if curBubLevel[i] and curBubLevel[i] ~= 0 then
				local fixX, fixY = curBubLevel[i]:getPosition()
				fixY = fixY - disG
				if fixY < screenHeight then
					table.insert(shakeTable,curBubLevel[i])
				end
			end
		end
	end
	if #shakeTable > 0 then
		local shakePot = math.random(#shakeTable)
		return shakeTable[shakePot]
	end
	return nil
end

function randomEmptySche()
	ranEmptyBubHandleId = sharedScheduler:scheduleScriptFunc(EmptyChange, scheTime.changeScheTime, false)
end

function EmptyChange()
	if curBubLevel and isGameLayerPause then
		local emptySpr = getEmptyTalbe()
		if emptySpr and emptySpr ~= 0 then
            local xe,ye = emptySpr:getPosition()
            local eArr = CCArray:create()
            eArr:addObject(CCSkewBy:create(0.5,0,-20))
            eArr:addObject(CCSkewTo:create(0.5,0,0))
            local eSeq = CCSequence:create(eArr)
            emptySpr:runAction(eSeq)
		end
	end
end

function getEmptyTalbe()
    local disG = gStartY - startY
	local emptyTable = {}
	if curBubLevel then
		for i=#curBubLevel, 1, -1 do
			if curBubLevel[i] and curBubLevel[i] ~= 0 and curBubLevel[i].bubColor == speBubs.empty then
				local fixX, fixY = curBubLevel[i]:getPosition()
				fixY = fixY - disG
				if fixY < screenHeight then
					table.insert(emptyTable,curBubLevel[i])
				end
			end
		end
	end
	if #emptyTable > 0 then
		local emptyPot = math.random(#emptyTable)
		return emptyTable[emptyPot]
	end
	return nil
end

function randomDoorSche()
    ranDoorScheHandleId = sharedScheduler:scheduleScriptFunc(delDoor, scheTime.doorShceTime, false)
end

local stack = {}
local function push(handle)
    stack[#stack + 1] = handle
    return handle
end

function unschedule(handle)
    sharedScheduler:unscheduleScriptEntry(handle)
    for i = 1, #stack do
        if stack[i] == handle then
            table.remove(stack, i)
            return
        end
    end
end

function performWithDelay(time, listener)
    local handle
    handle = sharedScheduler:scheduleScriptFunc(function()
        unschedule(handle)
        listener()
    end, time, false)
    return push(handle)
end

function hpSchedule()
    hpScheHandleId = sharedScheduler:scheduleScriptFunc(hpImpl, scheTime.hpTimeSche, false)
end

function hpImpl()
    if infoSours["x_HP"] == infoSours["x_MAXHP"] then return end
    updateHp(hpNeedTimes.updHP, 'upd')
end
function hpRevTimeSchedule()
    hpRevTimeScheHandleId = sharedScheduler:scheduleScriptFunc(addHPBarTime, scheTime.hpRevTimeSche, false)
end

--启动定时器，依次消除
function seqDelSchedule()
    seq_count = 0
    seq_addScore = 0
    if not seqTable or #seqTable == 0 then
        return
    else
        seq_addScore = #seqTable
    end
    seq_count = #seqTable + 1
    sco_count = 0
	if seq_count >= 12 then
		soundGetMaxScoreOneClick()
	end
    seqScheHandleId = sharedScheduler:scheduleScriptFunc(seqImpl_sours, scheTime.seqTimeSche, false)
end

function seqImpl_sours()
    seq_count = seq_count - 1
    sco_count = sco_count + 1
    local bubSeq = seqTable[seq_count]    
    if seq_count == #seqTable then
        if seqTable[#seqTable] and seqTable[#seqTable] ~= 0 then
            link_xt, link_yt = seqTable[#seqTable]:getPosition()
        else
            link_xt, link_yt = 320, 640        
        end
        
        if seqTable[1] and seqTable[1] ~= 0 then
            link_xc, link_yc = seqTable[1]:getPosition()
        else
            link_xc, link_yc = 320, 480
        end
    end
    if bubSeq and bubSeq ~= 0 then
        bubSeq:stopAllActions()
        local a1, b1 = bubSeq:getPosition()
        local s = (sco_count - 2) * 100
        if s <= 0 then s = 100 end
        scoreAway(s, 0.7, a1, b1)
        particleEffect(a1, b1, bubSeq.bubColor)
		soundBubDel()
        shootLayer:removeChild(bubSeq)
    end
    if seq_count <= 0 then
        sharedScheduler:unscheduleScriptEntry(seqScheHandleId)
        local _len = #seqTable
        seqTable = {}
        local disG = gStartY - startY
        link_yc = link_yc - disG
        if conNum >= 2 then
			if conNum == 2 then 
				soundCon2()
			elseif conNum == 3 then
				soundCon3()
			elseif conNum == 4 then
				soundCon4()
			else
				soundCon5()
			end
            if conNum > 9 then conNum = 9 end
            local linkSpr = CCSprite:create(REPATHLT.."con"..conNum..".png")
            if link_yc > 800 then
                link_yc = math.random(600, 700) --link_yc - 200
            end
			if link_xc < screenWidth / 2 then
				link_xc = math.random(180, 320)*adrate
			elseif link_xc > screenWidth / 2 then
				link_xc = math.random(320, 460)*adrate
			end
            linkSpr:setPosition(link_xc, link_yc)
            twoLayer:addChild(linkSpr)
            table.insert(effectTwoTable, linkSpr)
            local arrLink = CCArray:create()
            linkSpr:setScale(0.2)
            arrLink:addObject(CCScaleTo:create(0.4, 2.5))
            arrLink:addObject(CCScaleTo:create(0.3, 1.5))
            arrLink:addObject(CCFadeOut:create(1.5))
            local seqLink = CCSequence:create(arrLink)
            linkSpr:runAction(seqLink)
            shootPotParticle(twoLayer,bubpos.x,bubpos.y)
            --    hujian 
            --local a2,b2 = runningBubble:getPosition()        
            --particleShrink(shootLayer,bombEff_x,bombEff_y)
            fireworks(shootLayer,bombEff_x,bombEff_y)

			--拉动
			local arr1 = CCArray:create()
			arr1:addObject(CCMoveBy:create(0.2, ccp(-2, 2)))
			arr1:addObject(CCMoveBy:create(0.2, ccp(2, 2)))
			local seqCss1 = CCSequence:create(arr1)
			local actionShake = CCRepeatForever:create(seqCss1)
			linkSpr:runAction(actionShake)
        end
        if scoreAddFlag then
            scoreAway_add(seq_addScore * speNums.addScore, 1, link_xt, link_yt)
        end
        if _len >= 4 then
            local linkSpr1 = CCSprite:create(REPATHLT.."link"..goodTips(_len)..".png")
			link_yt = link_yc - math.random(150, 300)*adrate
			if link_xt < screenWidth / 2 then
				link_xt = math.random(260, 320)*adrate
			elseif link_xt > screenWidth / 2 then
				link_xt = math.random(320, 380)*adrate
			end
            linkSpr1:setPosition(link_xt, link_yt)
            twoLayer:addChild(linkSpr1)
            table.insert(effectTwoTable, linkSpr1)
            local arrLink = CCArray:create()
            linkSpr1:setScale(0.2)
            arrLink:addObject(CCScaleTo:create(0.4, 2))
            arrLink:addObject(CCScaleTo:create(0.3, 1.5))
            arrLink:addObject(CCFadeOut:create(1.8))
            local seqLink = CCSequence:create(arrLink)
            linkSpr1:runAction(seqLink)
			--拉动
			local arr1 = CCArray:create()
			arr1:addObject(CCMoveBy:create(0.2, ccp(-2, 2)))
			arr1:addObject(CCMoveBy:create(0.2, ccp(2, 2)))
			local seqCss1 = CCSequence:create(arr1)
			local actionShake = CCRepeatForever:create(seqCss1)
			linkSpr1:runAction(actionShake)
            fireworks(twoLayer,link_xt,link_yt)
        end
    end
end

--一次性全部消除
function seqImpl()
    for i = 1, #seqTable do
        local bubSeq = seqTable[i]
        if bubSeq and bubSeq ~= 0 then
            bubSeq:stopAllActions()
            bubSeq:setVisible(false)
        end
    end
    delStabBubs()
end

function delStabBubs()    
    for i = #seqTable, 1, -1 do
        local tmp = seqTable[i]
        if tmp and tmp ~= 0 then
            local a1, b1 = tmp:getPosition()
            local s = (i - 2) * 100
            if s <= 0 then s = 100 end
            scoreAway(s, 0.2, a1, b1)
        end
    end
    if conNum >= 2 then
        if conNum > 9 then conNum = 9 end
        local linkSpr = CCSprite:create(REPATHLT.."con"..conNum..".png")
        if seqTable[1] and seqTable[1] ~= 0 then
            local link_x, link_y = seqTable[1]:getPosition()
            local disG = gStartY - startY
            linkSpr:setPosition(link_x, link_y - disG)
            twoLayer:addChild(linkSpr)
            table.insert(effectTwoTable, linkSpr)
            local arrLink = CCArray:create()
            linkSpr:setScale(0.2)
            arrLink:addObject(CCScaleTo:create(0.4, 2.5))
            arrLink:addObject(CCScaleTo:create(0.3, 1.5))
            arrLink:addObject(CCFadeOut:create(1.5))
            local seqLink = CCSequence:create(arrLink)
            linkSpr:runAction(seqLink)
        end
    end
    if #seqTable >= 4 and seqTable[#seqTable] and seqTable[#seqTable] ~= 0 then
        local linkSpr1 = CCSprite:create(REPATHLT.."link"..goodTips(#seqTable)..".png")
        local link_x, link_y = seqTable[#seqTable]:getPosition()
        local disG = gStartY - startY
        linkSpr1:setPosition(link_x, link_y - disG)
        twoLayer:addChild(linkSpr1)
        table.insert(effectTwoTable, linkSpr1)
        local arrLink = CCArray:create()
        linkSpr1:setScale(0.2)
        arrLink:addObject(CCScaleTo:create(0.4, 3))
        arrLink:addObject(CCScaleTo:create(0.3, 2))
        arrLink:addObject(CCFadeOut:create(1.8))
        local seqLink = CCSequence:create(arrLink)
        linkSpr1:runAction(seqLink)
    end
        
    for i = 1, #seqTable do
        local tmp = seqTable[i]
        if tmp and tmp ~= 0 then
            shootLayer:removeChild(tmp)
        end
    end
    seqTable = {}
end

function seqImpl_deepSeaBomb()
    for i = 1, #seqTable do
        local bubSeq = seqTable[i]
        if bubSeq and bubSeq ~= 0 then
            bubSeq:stopAllActions()
            bubSeq:setVisible(false)
        end
    end 
    for i = #seqTable, 1, -1 do
        local tmp = seqTable[i]
        if tmp and tmp ~= 0 then
            local a1, b1 = tmp:getPosition()
            local s = (i - 2) * 100
            if s <= 0 then s = 100 end
            scoreAway(s, 0.2, a1, b1)
        end
    end
    if conNum >= 2 then
        if conNum > 9 then conNum = 9 end
        local linkSpr = CCSprite:create(REPATHLT.."con"..conNum..".png")
        if seqTable[1] and seqTable[1] ~= 0 then
            local link_x, link_y = seqTable[1]:getPosition()
            local disG = gStartY - startY
            linkSpr:setPosition(link_x, link_y - disG)
            twoLayer:addChild(linkSpr)
            table.insert(effectTwoTable, linkSpr)
            local arrLink = CCArray:create()
            linkSpr:setScale(0.2)
            arrLink:addObject(CCScaleTo:create(0.4, 2.5))
            arrLink:addObject(CCScaleTo:create(0.3, 1.5))
            arrLink:addObject(CCFadeOut:create(1.5))
            local seqLink = CCSequence:create(arrLink)
            linkSpr:runAction(seqLink)
        end
    end
    if #seqTable >= 4 and seqTable[#seqTable] and seqTable[#seqTable] ~= 0 then
        local linkSpr1 = CCSprite:create(REPATHLT.."link"..goodTips(#seqTable)..".png")
        local link_x, link_y = seqTable[#seqTable]:getPosition()
        local disG = gStartY - startY
        linkSpr1:setPosition(link_x, link_y - disG)
        twoLayer:addChild(linkSpr1)
        table.insert(effectTwoTable, linkSpr1)
        local arrLink = CCArray:create()
        linkSpr1:setScale(0.2)
        arrLink:addObject(CCScaleTo:create(0.4, 3))
        arrLink:addObject(CCScaleTo:create(0.3, 2))
        arrLink:addObject(CCFadeOut:create(1.8))
        local seqLink = CCSequence:create(arrLink)
        linkSpr1:runAction(seqLink)
    end
    local deepSeaBomb_bossFlag = false
    local deepSeaBomb_bossBub = 0
    for i = 1, #seqTable do
        local tmp = seqTable[i]
        if tmp and tmp ~= 0 then
        	if isBubKey(tmp.bubColor) then
        		deepSeaBomb_bossFlag = true
        		deepSeaBomb_bossBub = tmp
        	else
            	shootLayer:removeChild(tmp)
            end
        end
    end
    seqTable = {}
    
    if deepSeaBomb_bossFlag and deepSeaBomb_bossBub ~= 0 then
    	if isBoss() then
            bossEntry()
        else
        	soundKey()
            keyDeal(deepSeaBomb_bossBub)
        end
        --[[
        if isBoss() then
            bossEntry()
        else
			soundKey()
            gKeyBub = disBubF
            gKey = 1
        end
        ]]
    end
end

--倒计时10s
function time10Schedule()
	if not limit_ios then
		return
	end
    time10ScheHandleId = sharedScheduler:scheduleScriptFunc(backToTimeSche, scheTime.backScheTime, false)
end

function backToTimeSche()
    speNums.backTime = speNums.backTime - 1
    if speNums.backTime < 0 then
        un10Sche()
    elseif speNums.backTime == 0 then
        --un10Sche()
        --performWithDelay(0.2, fail10Back)
        fail10Back()
        --return
    else
        updateBackTime()
    end    
end
function un10Sche()
    sharedScheduler:unscheduleScriptEntry(time10ScheHandleId)
end
--检测新泡泡
function introSchedule()
    introScheHandleId = sharedScheduler:scheduleScriptFunc(introImplSche, scheTime.introScheTime, false)
end
function introImplSche()
    if isGameLayerPause and isTwoLayer then
        local table1 = searchEye_introBubs()
        if table1 then
            for i = 1, #table1 do
                local color = table1[i]
                if color and color ~= 0 then
                    if isNeedIntro(color) then
                        introBubPop(color)
                        return
                    end
                end
            end
        end
    end
end
--大关卡
function larLevShakeSche()
    larLevHandleId = sharedScheduler:scheduleScriptFunc(larLevChange, scheTime.larLevShakeTime, false)
end
function larLevChange()
    if not noEnoughStarFlag then return end
    if not hpBuyFlag then return end
    if not hpBuyFlag_fail then return end
    if not tcFlag and sepIsFlag and playLayerFlag then
        return
    end
    local larSpr = nil
    for i = 12, 1, -1 do
        if isPassLargeLevParam(i) and tcFlag then
            larSpr = sucLayer:getChildByTag(tagNums["sucLayer"].torch + i)            
            break
        end
    end
    if sucLayer:getChildByTag(tagNums["sucLayer"].fire) then
        sucLayer:removeChildByTag(tagNums["sucLayer"].fire)
        if larSpr then
            --cclog("--11 larSpr--visi")
            larSpr:setVisible(true)
            --cclog("--22 larSpr--visi")
        end
    end    
	if larSpr and sucLayer and tcFlag and not sepIsFlag and not playLayerFlag then
        --cclog("--33 larSpr--visi")
        larSpr:setVisible(false)
        --cclog("--44 larSpr--visi")
        local xe, ye = larSpr:getPosition()
        -- stAmi(xe, ye)
    end
end
--小关卡
function smaLevShakeSche()
    smaLevHandleId = sharedScheduler:scheduleScriptFunc(smaLevChange, scheTime.smaLevShakeTime, false)
end
function smaLevChange()
    local smaSpr = nil
    local mostLev = largeToSmall["lar_"..largeLevel][1]
    for i = 1, mostLev do
        if infoSours["maxLev_"..largeLevel]["finishInfo"][i] == 0 then
            smaSpr = hdSecSpr:getChildByTag(tagNums["heSecSpr"].smaLev * largeLevel + i)
            break
        end
    end
	if smaSpr then
        local xe,ye = smaSpr:getPosition()
        local eArr = CCArray:create()
        eArr:addObject(CCScaleTo:create(0.7, 1.05))
        eArr:addObject(CCScaleTo:create(0.7, 1))
        local eSeq = CCSequence:create(eArr)
        smaSpr:runAction(eSeq)
    end
end
--boss关随机发球--小招
function randomBossSepSche()
    ranBossSepScheHandleId = sharedScheduler:scheduleScriptFunc(ranBossSep, bossSepTime["boss_"..largeLevel][1], false)
end
--boss关随机发球--大招--计时
function randomBossLarTimeSche()
	ranBossLarTimeScheHandleId = sharedScheduler:scheduleScriptFunc(ranBossLarCountTime, scheTime.larBossTimeSche, false)
end
--[[
--游戏中的成就提醒
function tipAchSche()
	achTipScheHandleId = sharedScheduler:scheduleScriptFunc(achTips, scheTime.achTipTime, false)
end
]]
--接近失败线音效
function nearFailLinesche()
    nearFailSoundScheHandleId = sharedScheduler:scheduleScriptFunc(soundRepeat, scheTime.nearFailSoundTime/2, false)
end
--泡泡抖动效果的实现     --hujian
function shakyRepeat()
    bubbleShaky()
end
function soundRepeat()
    if isGameLayerPause then 
        shakyRepeat()
        soundNearFailLine()
    end
end