function initAudioEngine()
	audioAll = SimpleAudioEngine:sharedEngine()
end
----------------------------------------------------------------

function pauseBackMusic()
	audioAll:pauseBackgroundMusic()
end

function resumeBackMusic()
	audioAll:resumeBackgroundMusic()
end

function stopBackMusic()
	audioAll:stopBackgroundMusic(false)
end

--Ϸʱ
function musicEnterGame()
	if musicFlag then
		stopBackMusic()
		audioAll:playBackgroundMusic(REPATHEF.."music_bground.mp3", true)
	end
end

--ͨؿʱ
function musicComLev()
	if musicFlag then
		stopBackMusic()
		audioAll:playBackgroundMusic(REPATHEF.."music_comgame.mp3", true)
	end
end

--bossʱ
function musicAfterBossAni()
	if musicFlag then
		stopBackMusic()
		audioAll:playBackgroundMusic(REPATHEF.."music_boss.mp3", true)
	end
end

------------------------------Ч----------------------------------
--ը-1
function soundBomb()
	if soundFlag then
        audioAll:playEffect(REPATHEF.."sound_bomb.mp3", false)
    end 
end
--bossС-2
function soundBossSep()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bossSmallSkill.mp3", false)
	end
end
--boss-3
function soundBossLar()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bossLarSkill.mp3", false)
	end
end
--boss-4
function soundBossCome()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bossCome.mp3", false)
	end
end
--bossܹ-5
function soundBossAttacked()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bossAttacked.mp3", false)
	end
end
--ͨײ-6
function soundComClack()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubComClack.mp3", false)
	end
end
---7
function soundBubDel()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubDel.mp3", false)
	end
end
---8
function soundBubShoot()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubComShoot.mp3", false)
	end
end
---9
function soundBubSplit()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeSplit.mp3", false)
	end
end
--Ⱦɫ-10
function soundBubDye()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeDye.mp3", false)
	end
end
---11
function soundBubEmpty()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeEmpty.mp3", false)
	end
end
---12
function soundBubEnergy()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeEnergy.mp3", false)
	end
end
---13
function soundBubSteelShoot()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeSteelShoot.mp3", false)
	end
end
---14
function soundBubSteelClack()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeSteelBombClack.mp3", false)
	end
end
--ľͷ-15
function soundBubWood()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeWood.mp3", false)
	end
end
--ʯͷ-16
function soundBubStone()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeStone.mp3", false)
	end
end
--ť1--17
function soundMenu1()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_menu1.mp3", false)
	end
end
--ť2--18
function soundMenu2()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_menu2.mp3", false)
	end
end
--ť3-19
function soundMenu3()
	if soundFlag then
		-- audioAll:playEffect(REPATHEF.."sound_menu3.mp3", false)
	end
end
--ť4-20
function soundMenu4()
	if soundFlag then
		-- audioAll:playEffect(REPATHEF.."sound_menu4.mp3", false)
	end
end
--ť5-21
function soundMenu5()
	if soundFlag then
		-- audioAll:playEffect(REPATHEF.."sound_menu5.mp3", false)
	end
end
--ť-22
function soundMenuUnable()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_menuUnable.mp3", false)
	end
end
--ѡ-23
function soundSelect()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_select.mp3", false)
	end
end
--ɹ-24
function soundSuccess()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_success.mp3", false)
	end
	musicEnterGame()
end
--ʧ-25
function soundFailure()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_failure.mp3", false)
	end
	musicEnterGame()
end
--һɾ-26
function soundAchieveOneAch()
	if soundFlag then
		-- audioAll:playEffect(REPATHEF.."sound_achieveOneAch.mp3", false)
	end
end
--ӷ-27
function soundAddScore()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_addScore.mp3", false)
	end
end
---28
function soundBubSpeBlack()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeBlack.mp3", false)
	end
end

--׹-29
function soundBubSpeDown()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeDown.mp3", false)
	end
end

---30
function soundBubSpeGold()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeGold.mp3", false)
	end
end

---31
function soundBubSpeWave()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubSpeWave.mp3", false)
	end
end

--ħ-32
function soundBubVCome()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bubVCome.mp3", false)
	end
end

--ýһ߱ʯ-33
function soundBuyGoldGems()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_buyGoldGems.mp3", false)
	end
end

--2 -34
function soundCon2()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_con2.mp3", false)
	end
end

--3 -35
function soundCon3()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_con3.mp3", false)
	end
end

--4 -36
function soundCon4()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_con4.mp3", false)
	end
end

--5 -37
function soundCon5()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_con5.mp3", false)
	end
end

--door-38
function soundDoorActive()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_doorActive.mp3", false)
	end
end

--һηõ߷-39
function soundGetMaxScoreOneClick()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_getMaxScoreOneClick.mp3", false)
	end
end

--ʱ-40
function soundGetStars()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_getStars.mp3", false)
	end
end

--ɾͻǿ-41
function soundHDAchStre()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_hdAchStre.mp3", false)
	end
end

---42
function soundIceCome()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_iceCome.mp3", false)
	end
end

--ȫ-43
function soundIceScreen()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_iceScreen.mp3", false)
	end
end

---44
function soundIceShoot()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_iceShoot.mp3", false)
	end
end

--Կ-45
function soundKey()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_key.mp3", false)
	end
end

--ؿʼreadygo-46
function soundLevStart()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_levStart.mp3", false)
	end
end

--ʤʱߵ÷-47
function soundMaxBestScore()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_maxBestScore.mp3", false)
	end
end

--ʧ-48
function soundNearFailLine()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_nearFailLine.mp3", false)
	end
end

--bub2bub1ʱ-49
function soundANextBubJump()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_nextBubJump.mp3", false)
	end
end

---50
function soundRebound()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_rebound.mp3", false)
	end
end

---51
function soundSteelCome()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_steelCome.mp3", false)
	end
end

--ը-52
function soundBombCome()
	if soundFlag then
		audioAll:playEffect(REPATHEF.."sound_bombCome.mp3", false)
	end
end

musicTable = 
{
	"music_bground.mp3","music_boss.mp3","music_comgame.mp3"
}

soundTable = 
{
	"sound_addScore.mp3","sound_bomb.mp3","sound_bombCome.mp3",
	"sound_bossAttacked.mp3","sound_bossCome.mp3","sound_bossLarSkill.mp3","sound_bossSmallSkill.mp3",
	"sound_bubComClack.mp3","sound_bubComShoot.mp3","sound_bubDel.mp3","sound_bubSpeBlack.mp3",
	"sound_bubSpeDown.mp3","sound_bubSpeDye.mp3","sound_bubSpeEmpty.mp3","sound_bubSpeEnergy.mp3",
	"sound_bubSpeGold.mp3","sound_bubSpeSplit.mp3","sound_bubSpeSteelBombClack.mp3","sound_bubSpeSteelShoot.mp3",
	"sound_bubSpeStone.mp3","sound_bubSpeWave.mp3","sound_bubSpeWood.mp3","sound_bubVCome.mp3",
	"sound_buyGoldGems.mp3","sound_con2.mp3","sound_con3.mp3","sound_con4.mp3","sound_con5.mp3",
	"sound_doorActive.mp3","sound_failure.mp3","sound_getMaxScoreOneClick.mp3","sound_getStars.mp3",
	"sound_hdAchStre.mp3","sound_iceCome.mp3","sound_iceScreen.mp3","sound_iceShoot.mp3","sound_key.mp3",
	"sound_levStart.mp3","sound_maxBestScore.mp3","sound_menu1.mp3","sound_menu2.mp3",
	"sound_menuUnable.mp3","sound_nearFailLine.mp3","sound_nextBubJump.mp3",
	"sound_rebound.mp3","sound_select.mp3","sound_steelCome.mp3","sound_success.mp3"
}



