--彩球处理
function mulBall(line, col)
	if isSplit(compareColor) then
		compareColor = getMulColorSplit(compareColor)
	end
    curBubLevel[pot].isFind = 1
	local k = line % 2
	if k == 0 then k = -1 end
	--先找到周围各球
	local mulBall1 = getOverBall(line-1, col - k)	
	if mulBall1 and isMulSpeFist(mulBall1.bubColor) then
		compareColor = getMulColorSplit(mulBall1.bubColor)
		recursionMul(line-1, col - k)
		if mulCount < 2 then
			resetMul(line-1, col - k)
			if mulBall1.bubColor == speBubs.mul then
				mulBall(line-1, col - k)
			end
		end
	end
	mulBall1 = getOverBall(line-1, col)
	if mulBall1 and isMulSpeFist(mulBall1.bubColor) then
		compareColor = getMulColorSplit(mulBall1.bubColor)
		recursionMul(line-1, col)
		if mulCount < 2 then
			resetMul(line-1, col)
			if mulBall1.bubColor == speBubs.mul then
				mulBall(line-1, col)
			end
		end
	end
	mulBall1 = getOverBall(line, col - 1)	
	if mulBall1 and isMulSpeFist(mulBall1.bubColor) then
		compareColor = getMulColorSplit(mulBall1.bubColor)
		recursionMul(line, col - 1)
		if mulCount < 2 then
			resetMul(line, col - 1)
			if mulBall1.bubColor == speBubs.mul then
				mulBall(line, col - 1)
			end
		end
	end
	mulBall1 = getOverBall(line, col + 1)
	if mulBall1 and isMulSpeFist(mulBall1.bubColor) then
		compareColor = getMulColorSplit(mulBall1.bubColor)	
		recursionMul(line, col + 1)
		if mulCount < 2 then
			resetMul(line, col + 1)
			if mulBall1.bubColor == speBubs.mul then
				mulBall(line, col + 1)
			end
		end
	end
	mulBall1 = getOverBall(line + 1, col - k)
	if mulBall1 and isMulSpeFist(mulBall1.bubColor) then
		compareColor = getMulColorSplit(mulBall1.bubColor)
		recursionMul(line + 1, col - k)
		if mulCount < 2 then
			resetMul(line + 1, col - k)
			if mulBall1.bubColor == speBubs.mul then
				mulBall(line + 1, col - k)
			end
		end
	end
	mulBall1 = getOverBall(line + 1, col)
	if mulBall1 and isMulSpeFist(mulBall1.bubColor) then
		compareColor = getMulColorSplit(mulBall1.bubColor)
		recursionMul(line + 1, col)
		if mulCount < 2 then
			resetMul(line + 1, col)
			if mulBall1.bubColor == speBubs.mul then
				mulBall(line + 1, col)
			end
		end
	end
end

--彩球处理
function mulBall_new(line, col)
	curBubLevel[pot].isFind = 1
    local table1 = getAroundSixByLC(line, col)
    if table1 then
        for i = 1, #table1 do
            local tmp1 = table1[i]
            mulCount = 0
            if tmp1 and tmp1 ~= 0  then
                compareColor = tmp1.bubColor
                local col1, line1 = new_hex(tmp1.seq)
                recursionMul(line1, col1)
                if mulCount < 2 then
                    resetMul(line1, col1)
                    if tmp1.bubColor == speBubs.mul then
                        mulBall(line1, col1)
                    end
                end
            end
        end
    end
end

--解决彩球打在中间不能消除问题
function mulBallAround6(line, col)
    local table1 = getAroundSixByLC(line, col)
    if table1 then
        for i = 1, #table1 do
            local countIJ = 1
            local tmpFlag = true
            local tmp = table1[i]
            if tmp and tmp ~= 0 and isMulSpeFist(tmp.bubColor) then
                if curBubLevel[tmp.seq].isFind == 1 then
                    tmpFlag = false
                end
                if isMulSpeFist(tmp.bubColor) then
                    curBubLevel[tmp.seq].isFind = 1
                end
                local color = tmp.bubColor
                for j = 1, #table1 do
                    local tmp2 = table1[j]
                    if tmp2 and tmp2 ~= 0 and i ~= j 
                        and (color == tmp2.bubColor or tmp2.bubColor == speBubs.mul)
                        and isMulSpeFist(tmp2.bubColor) then
                        countIJ = countIJ + 1
                        curBubLevel[tmp2.seq].isFind = 1
                    end
                end
                if countIJ == 1 and tmpFlag then
                    curBubLevel[tmp.seq].isFind = 0
                end
            end
        end
    end 
end

function recursionMul(line, col)
	if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line - 1) * colNum + col
	if curBubLevel[xy] and curBubLevel[xy] ~= 0  and curBubLevel[xy].isFind == 0 
		and canRemove(curBubLevel[xy].bubColor) and isMulSpe(compareColor) then
		curBubLevel[xy].isFind = 1
		mulCount = mulCount + 1
		local k = line % 2 
		if k == 0 then k = -1 end
		recursionMul(line - 1, col - k)
		recursionMul(line - 1, col)
		recursionMul(line, col - 1)
		recursionMul(line, col + 1)
		recursionMul(line + 1, col - k)
		recursionMul(line + 1, col)
	end
end

function isMulSpeFist(color)
    if color ~= speBubs.plate1 and not isDye(color) 
		and color ~= speBubs.plate2 and color ~= speBubs.ques 
        and color ~= speBubs.bubGold and color ~= speBubs.energy         
        and not isBubKey(color) and color ~= speBubs.black then
        return true
    end
    
    return false
end

function getMulColorSplit(color)
    if isSplit(color) then
        color = color - speNums.baseLast
    end
    return color
end

function isMulSpe(color)
    if color ~= speBubs.plate1 
		and color ~= speBubs.plate2 and color ~= speBubs.ques 
        and not isBubKey(color) and color ~= speBubs.black then
        return true
    end
    
    return false
end

function resetMul(line, col)
	if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line - 1) * colNum + col
	if curBubLevel[xy] and curBubLevel[xy] ~= 0  and curBubLevel[xy].isFind == 1 
		and curBubLevel[xy].bubColor == compareColor then
		curBubLevel[xy].isFind = 0
		local k = line % 2 
		if k == 0 then k = -1 end
		resetMul(line - 1, col - k)
		resetMul(line - 1, col)
		resetMul(line, col - 1)
		resetMul(line, col + 1)
		resetMul(line + 1, col - k)
		resetMul(line + 1, col)
	end
end

--炸弹
function bombBall(line, col)
    bomb_Key = false
    bombCount = getStrengthEveryData(strengthSeq.bombRes) + speNums.bombGe
    curBubLevel[pot].isFind = 1
    if bombCount == 2 then
        local table1 = getAroundSixByLC(line, col)
        if table1 then
            for i = 1, #table1 do
                local tmp = table1[i]
                if tmp and tmp ~= 0 then
                    curBubLevel[tmp.seq].isFind = 1
                    bombIsKey(tmp)
                end
            end
        end
    end
    if bombCount == 3 then
        local table1 = getAroundSixByLC(line, col)
        if table1 then
            for i = 1, #table1 do
                local tmp1 = table1[i]
                if tmp1 and tmp1 ~= 0 then
                    curBubLevel[tmp1.seq].isFind = 1
                    bombIsKey(tmp1)
                    local table2 = getAroundSixByPots(tmp1.seq)
                    if table2 then
                        for j = 1, #table2 do
                            local tmp2 = table2[j]
                            if tmp2 and tmp2 ~= 0 then
                                curBubLevel[tmp2.seq].isFind = 1
                                bombIsKey(tmp2)                    
                            end
                        end
                    end
                end
            end
        end
    end
     if bombCount == 4 then
        local table1 = getAroundSixByLC(line, col)
        if table1 then
            for i = 1, #table1 do
                local tmp1 = table1[i]
                if tmp1 and tmp1 ~= 0 then
                    curBubLevel[tmp1.seq].isFind = 1
                    bombIsKey(tmp1)
                    local table2 = getAroundSixByPots(tmp1.seq)
                    if table2 then
                        for j = 1, #table2 do
                            local tmp2 = table2[j]
                            if tmp2 and tmp2 ~= 0 then
                                curBubLevel[tmp2.seq].isFind = 1
                                bombIsKey(tmp2)                              
                                local table3 = getAroundSixByPots(tmp2.seq)
                                if table3 then
                                    for m = 1, #table3 do
                                        local tmp3 = table3[m]
                                        if tmp3 and tmp3 ~= 0 then
                                            curBubLevel[tmp3.seq].isFind = 1
                                            bombIsKey(tmp3)                    
                                        end
                                    end
                                end                                                                                 
                            end
                        end
                    end
                end
            end
        end
    end     
end

function bombIsKey(tmp)
    if isBubKey(tmp.bubColor) then
        disBubF = tmp
        bomb_Key = true
    end
end

--可以染色的球
function isDyeBall(xy)
    if curBubLevel[xy] and curBubLevel[xy] ~= 0 and 
        curBubLevel[xy].bubColor ~= speBubs.bubGold and 
        not isBubKey(curBubLevel[xy].bubColor) and  
        curBubLevel[xy].bubColor ~= speBubs.energy and  
        curBubLevel[xy].bubColor ~= speBubs.plate1 and  
        curBubLevel[xy].bubColor ~= speBubs.plate2 and  
        curBubLevel[xy].bubColor ~= speBubs.black and  
        curBubLevel[xy].bubColor ~= speBubs.down and  
        curBubLevel[xy].bubColor ~= speBubs.empty and  
        curBubLevel[xy].bubColor ~= speBubs.bubDoor then
        return true
    end
    return false
end

--染色泡泡
function dyeBall()
	if dyeColor and isDye(dyeColor) then
		soundBubDye()
		local dye_color = dyeColor - speNums.dyeFirst + 1
        for dye_i = 1, #dbTable do
            local xy = dbTable[dye_i]
            if isDyeBall(xy) then
                local dye_x, dye_y = curBubLevel[xy]:getPosition()
                shootLayer:removeChild(curBubLevel[xy])
                local tmpss = getBub(dye_color, dye_x, dye_y, xy)
                curBubLevel[xy] = tmpss
                sours[xy] = tmpss
                shootLayer:addChild(tmpss, 1, tagNums["shootLayer"].shoot + tmpss.seq)
                dye_flag = true           
            end
        end
        
        local table2 = getAroundExistByPots(curBubLevel[dbTable[1]].seq)
        local sc_xy = 18
        for i = 1, #table2 do
			local tmp = table2[i]
            if not tmp or tmp == 0 then break end
            tmp:stopAllActions()
            local dye_x, dye_y = tmp:getPosition()
            local moveX, moveY = dye_x, dye_y
            if dye_x < dyeBub_x then
                moveX = dye_x - sc_xy
            elseif dye_x > dyeBub_x then
                moveX = dye_x + sc_xy
            end
            if dye_y < dyeBub_y then
                moveY = dye_y - sc_xy
            elseif dye_y > dyeBub_y then
                moveY = dye_y + sc_xy
            end                
            local speArr = CCArray:create()
            speArr:addObject(CCMoveTo:create(0.15, ccp(moveX, moveY)))
            speArr:addObject(CCMoveTo:create(0.1, ccp(dye_x, dye_y)))
            local speSeq = CCSequence:create(speArr)
            tmp:runAction(speSeq)
		end        
	end
end

function searchDyeBall(line, col)
    dyeBub_x, dyeBub_y = 0, 0
    dyeColor = 0
	dbTable = {}
	local table1 = getAroundExistByPots(pot)
	for i = 1, #table1 do
        local tmp1 = table1[i]
        if isDye(tmp1.bubColor) then
            if not tmp1 or tmp1 == 0 then break end
            dyeBub_x, dyeBub_y = tmp1:getPosition()
            table.insert(dbTable, tmp1.seq)
            dyeColor = tmp1.bubColor
			
			local table2 = getAroundExistByPots(tmp1.seq)
			for j = 1, #table2 do
				local tmp2 = table2[j]
				if isDyeBall(tmp2.seq) then
					table.insert(dbTable, tmp2.seq)
				end
			end
            return
        end
    end   
end

--分裂泡泡
function splitBall()
	splitBallFlag = false
    local realColor = splitColor - speNums.splitFirst + 1
	if splitColor and isSplit(splitColor) then
		soundBubSplit()
        if not cur_splitBall or cur_splitBall == 0 then return end
        splitBub_x, splitBub_y = cur_splitBall:getPosition()
        for split_i = 1, #sbTables do
			local xyBub = sbTables[split_i]
            if curBubLevel[xyBub.seq] == 0 then
                curBubLevel[xyBub.seq] = xyBub
				sours[xyBub.seq] = xyBub
                shootLayer:addChild(xyBub, 1, xyBub.seq + tagNums["shootLayer"].shoot)
				splitBallFlag = true
			end
        end
        local sp_seq = cur_splitBall.seq        
		if cur_splitBall and curBubLevel[sp_seq] and  curBubLevel[sp_seq] ~= 0 then
            splitBub_x, splitBub_y=cur_splitBall:getPosition()
			local tmpss = getBub(realColor, splitBub_x, splitBub_y, sp_seq)
			if cur_splitBall then
				shootLayer:removeChild(cur_splitBall)
				cur_splitBall = nil
			end
			curBubLevel[tmpss.seq] = tmpss
			sours[tmpss.seq] = tmpss
			shootLayer:addChild(tmpss, 1, tmpss.seq)
		end
        local table2 = getAroundExistByPots(sp_seq)
        local sc_xy = 30
        for split_i = 1, #table2 do
            local xyBub = table2[split_i]
            if not xyBub or xyBub == 0 then break end
			local sp_x, sp_y = xyBub:getPosition()
            local moveX, moveY = sp_x, sp_y
            if sp_x < splitBub_x then
                moveX = sp_x + sc_xy
            else
                moveX = sp_x - sc_xy
            end
            if sp_y < splitBub_y then
                moveY = sp_y + sc_xy
            elseif sp_y > splitBub_y then
                moveY = sp_y - sc_xy
            end 
            local speArr = CCArray:create()
            speArr:addObject(CCMoveTo:create(0.13, ccp(moveX, moveY)))
            speArr:addObject(CCMoveTo:create(0.22, ccp(sp_x, sp_y)))
            local speSeq = CCSequence:create(speArr)
            xyBub:runAction(speSeq)
		end
	end
	return splitBallFlag
end

function searchSplitBall(line, col)
    splitColor = 0
	sbTables = {}
	cur_splitBall = nil
	local table1 = getAroundExistByPots(pot)
	for i = 1, #table1 do
        local tmp1 = table1[i]
        if isSplit(tmp1.bubColor) then
            splitColor = tmp1.bubColor
            local realColor = splitColor - speNums.splitFirst + 1
            cur_splitBall = tmp1            
            local table2 = getAroundNoExistByPots(tmp1.seq)
            for j = 1, #table2 do
                local pot2 = table2[j]
                local col1, line1 = new_hex(pot2)
                if isComLC(line1, col1) then
                    local lx1, ly1 = new_XY(line1, col1)
                    local tmp2 = getBub(realColor, lx1, ly1, pot2)
                    table.insert(sbTables, tmp2)
                end
            end
            return
        end
    end   
end

--问号
function quesBall(ballQQ)
	local qBall = ballQQ
	if qBall and qBall ~= 0 then
		local i = speBubs.empty
		local table1 = searchEye_baseBubs()
		if table1 and #table1 > 0 then 
			i = table1[math.random(#table1)]
		end
		local ques_x, ques_y = qBall:getPosition()		
		local tmpss = getBub(i, ques_x, ques_y, qBall.seq)
		compareColor = i
		curBubLevel[qBall.seq] = tmpss
		sours[qBall.seq] = tmpss
		if qBall then
			shootLayer:removeChild(qBall)
			qBall = nil
		end
		shootLayer:addChild(tmpss, 1, tmpss.seq)	
	end
end

--钢球
function steelBall()
    local lastSteelTop = speNums.steelTop + initsteelRows * bub_height
	if dy >= (startY - bub_height / 2)  or dy >= lastSteelTop  or not steelBossFlag then
		steelBossFlag = true
        removeRunningBubble()
		infoAll.sucShootNum = infoAll.sucShootNum + 1
		addScore(1, 'link', -2)
		--连击分数计算
		thisScore = 0	
		if steelNum then			
			addScore(steelNum, 'link', -2)
			getThisLinkScore(steelNum)
		end
		steelNum = 0
		recursionStart()
	else
		steelImpl()
	end
end
function steelImpl()
    if runningBubble then
        local yVisible = runningBubble:getPositionY()
        if yVisible >= screenHeight - bub_height * 2 then
            runningBubble:setVisible(false)
        end
    end
	local borderHeight = startY - bub_height / 2
	for i = #curBubLevel, 1, -1 do
		if curBubLevel[i] and curBubLevel[i] ~= 0 then
			local fixX, fixY1 = curBubLevel[i]:getPosition()
			fixY = gStartY - fixY1
			local nx, ny = dx, startY - dy
			if fixY + bub_height < ny then break end
			local distance = (fixX - nx) * (fixX - nx) + (fixY - ny) * (fixY - ny)
			if distance <= tBallDis then
				if isBubKey(curBubLevel[i].bubColor) then
					if isBoss() and infoSours["x_intro_boss"] == 0 then
						break
					end
                    if isBoss() and steelMulFlag then
                        steelMulFlag = false
                        recursionStart()
                        bossEntry()
                    else
                    	soundKey()
						keyDeal(curBubLevel[i])
                    end
                    break
				else
					soundBubSteelClack()
					steelNum = steelNum + 1
					local s = (steelNum - 2) * 100
					if s <= 0 then s = 100 end
					scoreAway(s, 0.7, fixX, fixY1)
					particleEffect(fixX, fixY1, curBubLevel[i].bubColor)
                    removeSteelBubs(curBubLevel[i], steelNum)
				end
				break
			elseif dy >= borderHeight then
				dy = borderHeight
				break
			end
		end
	end
end

function removeSteelBubs(goBub, m)
    if not goBub or goBub == 0 then return end
	sours[goBub.seq] = 0
	curBubLevel[goBub.seq] = 0
	conTimeChange()
	if goBub.bubColor == speBubs.bubGold then
        local gold_x, gold_y = goBub:getPosition()
        collGoldEff(gold_x, gold_y + startY - gStartY)
		goldAdd()
		isGold = true
	elseif goBub.bubColor == speBubs.energy then
        local gold_x, gold_y = goBub:getPosition()
        energyEffect(gold_x, gold_y)
		energyAdd()
		isEnergy = true
	end
    if goBub then
		shootLayer:removeChild(goBub)
		goBub = nil
	end
end

--冰球--降落停止4s--发射
function iceBall()
    clearIceEF()
    local table1 = getEyeBubs()
    tableIceEf = {}
    local ice_ipone = "ice_add_ef.png"
    if device == "iphone5" then ice_ipone = "ice_add_ef_ip5.png" end
	local iceAddSpr = CCSprite:create(REPATHXG..ice_ipone)
	iceAddSpr:setPosition(screenWidth/2, screenHeight/2)
	twoLayer:addChild(iceAddSpr, 1, tagNums["twoLayer"].iceAdd)
    local apic = "coldAir.png"
    if device == "iphone5" then apic = "coldAir_ip5.png" end
	local iceAir = CCSprite:create(REPATHXG..apic)
	iceAir:setPosition(screenWidth/2, screenHeight/2)
	jBjLayer:addChild(iceAir, 0, tagNums["jBjLayer"].iceAir)
	isIceFlag = false
	removeRunningBubble()
	local lastIceTime = speNums.iceTime + getStrengthEveryData(strengthSeq.iceTime)
	performWithDelay(lastIceTime, setIceFlag)
end

function setIceFlag()
    if isGameLayerPause then
        isIceFlag = true
        clearIceEF()
    end
end

function setIceFlagPause()
    if not isIceFlag then
        isIceFlag = true
        clearIceEF()
    end
end

--时间到后清理冰层
function clearIceEF()
    if twoLayer:getChildByTag(tagNums["twoLayer"].iceAdd) then
        twoLayer:removeChildByTag(tagNums["twoLayer"].iceAdd)
    end
    if jBjLayer:getChildByTag(tagNums["jBjLayer"].iceAir) then
        jBjLayer:removeChildByTag(tagNums["jBjLayer"].iceAir)
    end
end

function isCanIceBub(color)
	if color <= 42 and color ~= 26 and 
		color ~= 29 and color ~=30 and 
		color ~= 31 and color ~= 37 and
		color ~= 38 then
		return true
	end
	return false
end

--波浪球--向后推2格s--发射
function waveBallAni()
    if twoLayer:getChildByTag(tagNums["twoLayer"].seaWave2) then
        twoLayer:removeChildByTag(tagNums["twoLayer"].seaWave2)
    end
    if twoLayer:getChildByTag(tagNums["twoLayer"].fishWave2) then
        twoLayer:removeChildByTag(tagNums["twoLayer"].fishWave2)
    end
    local effectWave = getStrengthEveryData(strengthSeq.waveRes)
    speNums.moveDis = -5
    local time = scheTime.startScheTime * (speNums.waveLine * bub_height + effectWave) / -speNums.moveDis        
    performWithDelay(time, waveBallChangeSD)
    
    seaWaveAmi2(time)
end

function waveBallChangeSD()
    waveFlag = true
    if twoLayer:getChildByTag(tagNums["twoLayer"].seaWave1) then
        twoLayer:removeChildByTag(tagNums["twoLayer"].seaWave1)
    end
    shootReadyOk = true
end

function waveBall()
	soundBubSpeWave()
	waveFlag = false	
    seaWaveAmi1()
	performWithDelay(0.3, waveBallAni)
end

--连击上升
function conBall(h)
    waveFlag = false
    speNums.moveDis = -h / 10
    performWithDelay(0.5, conChangeSD)
end

function conChangeSD()
    waveFlag = true
    speNums.moveDis = dSpeed[1]
end

--下坠泡泡--下坠3格
function downBall()
    downFlag = false
    speNums.moveDis = 7
    local time = scheTime.startScheTime * 3 * bub_height / speNums.moveDis 
    performWithDelay(time, downBallChangeSD)

	if disBubF then
		local down_eff_y = disBubF:getPositionY()
		local downEffSpr = CCSprite:create(REPATHXG.."down_eff.png")
		downEffSpr:setPosition(screenWidth / 2, down_eff_y)
		shootLayer:addChild(downEffSpr, 1, tagNums["shootLayer"].down)
		downEffSpr:runAction(CCMoveTo:create(time, ccp(screenWidth / 2, down_eff_y - 400)))
		downEffSpr:runAction(CCFadeOut:create(time))
	end
end

function downBallChangeSD()
    downFlag = true
    if shootLayer:getChildByTag(tagNums["shootLayer"].down) then
        shootLayer:removeChildByTag(tagNums["shootLayer"].down)
    end
end

--黑木泡泡(可发射，不可消除，只能炸掉和钢球消掉)--发射
function blackBall()
	removeRunningBubble()
end

--空泡泡--碰到即碎，经过520px（即960-520=440）后6s自动消除
function emptyBall()
	local emptyNum = 0
	emptyRemove_flag = false
	local startTime = os.time()
	if not empty_start then empty_start = #sours end
	for ij = empty_start , 1, -1 do
		if sours[ij] and sours[ij] ~= 0  and sours[ij].bubColor == speBubs.empty then
			emptyNum = emptyNum + 1
			if emptyNum == 1 and ij < empty_start then
				empty_start = ij
			end
			local buttomX, buttomY = sours[ij]:getPosition()
			if gameLayerY then
				emptyDown = buttomY + gameLayerY
			else
				emptyDown = buttomY 
			end
			if emptyDown <= speNums.emptyTop then
				if not emptyTables[""..ij] then
					emptyTables[""..ij] = {}
					emptyTables[""..ij].emptyBall = sours[ij]
					emptyTables[""..ij].emptyTime = startTime
				else
					local endTime = os.time()
					if endTime - emptyTables[""..ij].emptyTime >= 6 and sours[ij] ~= 0 then
						local tmpBub = sours[ij]
						sours[ij] = 0
						curBubLevel[ij] = 0
                        shootLayer:removeChild(tmpBub)
						emptyRemove_flag = true
					end
				end
			end
		end
	end
	if emptyRemove_flag then
		resetSearch()
		recursionStart()
	end
end

function resetEmpty()
	emptyTables={}
	empty_start = #sours
end

--金币泡泡--超过662(960-662=298)自动破裂
function goldBall()
	local goldNum = 0
	goldRemove_flag = false
	local startTime = os.time()
	if not gold_start then gold_start = #sours end
	for ij = gold_start, 1, -1 do
		if sours[ij] and sours[ij] ~= 0  and sours[ij].bubColor == speBubs.bubGold then
			goldNum = goldNum + 1
			if goldNum == 1 and ij < gold_start then
				gold_start = ij
			end
			local buttomX, buttomY = sours[ij]:getPosition()
			if gameLayerY then
				goldDown = buttomY + gameLayerY
			else
				goldDown = buttomY 
			end
            -- bubble1.4    hujian
            if goldDown > speNums.goldTop and goldDown < speNums.goldBottom then
                goldShowHide(sours[ij])
            end

			if goldDown <= speNums.goldTop then
				local tmpBub = sours[ij]
				if tmpBub then
					sours[ij] = 0
					curBubLevel[ij] = 0    
			 		shootLayer:removeChild(tmpBub)
					tmpBub = nil
				end
				goldRemove_flag = true
				goldAdd()
			end
		end
	end
	if goldRemove_flag then
		resetSearch()
		recursionStart()
	end
end

function resetGold()
	goldTables={}
	gold_start = #sours
end

function bubVImpl()
    local disG = gStartY - startY
    local firstY = disBubF:getPositionY() - disG
    local v_height = firstY + bub_height * (speNums.bubVLine + getStrengthEveryData(strengthSeq.vRes1))
    if curBubLevel and vBallFirstColor and isBubVCanRemove(vBallFirstColor) and isBubV(compareColor) then
		for i = #curBubLevel, 1, -1 do
			if curBubLevel[i] and curBubLevel[i] ~= 0 and curBubLevel[i].isFind == 0 then
                if bubVScope(curBubLevel[i].bubColor, vBallFirstColor) or isBubV(curBubLevel[i].bubColor) then
                    local fixX, fixY = curBubLevel[i]:getPosition()
                    fixY = fixY - disG
                    if fixY < v_height then
                        curBubLevel[i].isFind = 1
                    else
                        break
                    end
                end
			end
		end
	end
end

--魔化球可消的球
function isBubVCanRemove(color)
    if (color >= 1 and color <= 16) or color == speBubs.plate1 
        or color == speBubs.plate2 or color == speBubs.ques 
        or color == speBubs.black then
        return true
    end
    return false
end

--魔化球进行比较
function bubVScope(color, sourColor)
    if isSplit(sourColor) then
        sourColor = sourColor - 8
    end
    if isSplit(color) then
        color = sourColor - 8
    end
    if color == sourColor then
        return true
    end
    return false
end

function inScoreAdd()
    addScore(1, 'inScore', 1)
end

function getOverBall(line, col)
	mulCount = 0
	if line <= 0 or line > lineNum or col <= 0 or col > colNum then return nil end
	local xy = (line - 1) * colNum + col
	if not curBubLevel[xy] or curBubLevel[xy] == 0 then return nil end
	if curBubLevel[xy].isFind == 1 then return nil end
	return curBubLevel[xy]
end

--深海炸弹
function bubDeepSeaBombImpl()
	local table1 = getEyeBubs()
	local linkDeepSea = {}
	if table1 and #table1 > 0 then
		for i = #table1, 1, -1 do
			if table1[i] and table1[i] ~= 0 then
				local seq = table1[i].seq
				if curBubLevel and curBubLevel[seq] and curBubLevel[seq] ~= 0 then
					--if not isBubKey(curBubLevel[seq].bubColor) then
						curBubLevel[seq].isFind = 1 
						table.insert(linkDeepSea, curBubLevel[seq])
					--end
				end
			end
		end
	end
	return linkDeepSea
end