--[[
strengthSeq = {mulRate = 1, goldSale = 2, bombRate = 3, bombRes = 4, iceRate = 5, steelDis = 6, vRes1 = 7, iceTime = 8, waveRes = 9, eneryRes = 10}
streBub_seq = {speBubs.mul, speBubs.bubGold, speBubs.bomb, speBubs.bomb_s, speBubs.bubV_s, speBubs.steel_s, speBubs.ice, speBubs.ice, speBubs.wave, speBubs.wave_s}
local effectZone = {1, 0.8, 1, 1, 2, 3, 1, 4, 90, 2}
local goldZone = {28, 8, 28, 58, 58, 58, 28, 58, 58, 58}
local diamZone = {6, 6, 6, 18, 18, 18, 18, 18, 18, 18}
local beforeZone = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
]]
strengthSeq = {mulRate = 1, bombRes = 2, steelDis = 3, iceTime = 4, vRes1 = 5, waveRes =6, eneryRes = 7, goldSale = 8, bombRate = 9, iceRate = 10}
streBub_seq = {speBubs.mul, speBubs.bomb_s, speBubs.steel_s, speBubs.ice,  speBubs.bubV_s, speBubs.wave_s, speBubs.bubGold, speBubs.bomb, speBubs.ice, speBubs.wave}
local effectZone = {1, 1, 3, 4, 2, 90, 0, 0, 0, 0}
local goldZone = {320, 480, 480, 480, 480, 480, 480, 480, 480, 480}
local diamZone = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
local beforeZone = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}

function calSaveLoadStre()
    saveStreSep()
    loadStre()
end

function loadStreFirst()
	saveStreFirst()
	loadStre()
end

function loadStre()
	local path = CCFileUtils:sharedFileUtils():getWriteablePath().."strength.txt"
	if io.exists(path) then
		infoStrength = loadFile(path)
	else
		infoStrength = {}
	end
end

function saveStreFirst()
	local writeName = CCFileUtils:sharedFileUtils():getWriteablePath().."strength.txt"
	if not io.exists(writeName) then
		local strengthTmp={}
		for i = 1, 10 do
            if not strengthTmp[""..i] then strengthTmp[""..i] = {} end
            if not strengthTmp[""..i]["con"] then strengthTmp[""..i]["con"]={}  end
            if not strengthTmp[""..i]["con"]["gold"] then strengthTmp[""..i]["con"]["gold"]=0  end
            if not strengthTmp[""..i]["con"]["diamond"] then strengthTmp[""..i]["con"]["diamond"]=0  end
            if not strengthTmp[""..i]["x_effect"] then strengthTmp[""..i]["x_effect"]=0 end
            if not strengthTmp[""..i]["x_active"] then strengthTmp[""..i]["x_active"]=0 end
            if not strengthTmp[""..i]["x_before"] then strengthTmp[""..i]["x_before"]=0 end
            strengthTmp[""..i]["con"]["gold"] = goldZone[i]
			strengthTmp[""..i]["con"]["diamond"] = diamZone[i]
            strengthTmp[""..i]["x_effect"] = effectZone[i]
            strengthTmp[""..i]["x_before"] = beforeZone[i]
		end
		io.writefile(writeName, gJSON:encode(strengthTmp))
    else
        infoStrength = loadFile(writeName)
        for i = 1, 10 do
            infoStrength[""..i]["con"]["gold"] = goldZone[i]
			infoStrength[""..i]["con"]["diamond"] = diamZone[i]
            infoStrength[""..i]["x_effect"] = effectZone[i]
            infoStrength[""..i]["x_before"] = beforeZone[i]
		end
		saveStreSep()
	end    
end

function updateStre(i)
    infoStrength[""..i].x_active = 1
    saveStreSep()
    --loadStre()
end

function isAllStreOver()
    for i = 1, 10 do
        if infoStrength[""..i].x_active == 0 then
            return true
        end
    end
    return false
end