local sourX, sourY = 0, 0

bossHp = 
{
    ["boss_1"]	= {2},
	["boss_2"]	= {2},
	["boss_3"]	= {3},
	["boss_4"]	= {3},
	["boss_5"]	= {4},
	["boss_6"]	= {3},
	["boss_7"]	= {3},
	["boss_8"]	= {3},
	["boss_9"]	= {4},
	["boss_10"] = {3},
	["boss_11"] = {3},
	["boss_12"] = {4}
}
bossSepTime = 
{
	["boss_1"]={9},		
	["boss_2"]={10},		
	["boss_3"]={9},		
	["boss_4"]={10},		
	["boss_5"]={9},		
	["boss_6"]={9},		
	["boss_7"]={8},		
	["boss_8"]={7},		
	["boss_9"]={9},		
	["boss_10"]={8},		
	["boss_11"]={9},		
	["boss_12"]={7}	
}
local bossSepNums = 
{
	["boss_1"]={1},		
	["boss_2"]={1},		
	["boss_3"]={2},		
	["boss_4"]={2},		
	["boss_5"]={2},		
	["boss_6"]={3},		
	["boss_7"]={2},		
	["boss_8"]={2},		
	["boss_9"]={2},		
	["boss_10"]={2},		
	["boss_11"]={3},		
	["boss_12"]={3}	
}
--boss技能-扔单个小球
local bossSepSkill = 
{
	["boss_1"] = {2, 3, 4, 5, 6},
	["boss_2"] = {2, 3, 4, 5, 6, 27},
	["boss_3"] = {2, 3, 4, 6, 8, 27},
	["boss_4"] = {3, 4, 5, 6, 8, 27, 28},
	["boss_5"] = {2, 3, 4, 5, 6, 27, 28, 32},
	["boss_6"] = {2, 3, 4, 5, 6, 27, 28, 32},
	["boss_7"] = {2, 3, 4, 5, 6,27, 28, 32},
	["boss_8"] = {2, 3, 4, 5, 6, 27, 28, 32, 41},
	["boss_9"] = {6, 3, 4, 5, 8, 27, 28, 32, 41},
	["boss_10"] = {2, 3, 4, 5, 6, 27, 28, 32, 41, 35},
	["boss_11"] = {2, 3, 4, 5, 6, 27, 28, 32, 41},
	["boss_12"] = {2, 3, 4, 5, 6, 27, 28, 32, 41, 35}
}
--Boss被击中后吐出的球的种类
local bossClackSkill = 
{
    ["boss_1"] = {6, 34},
    ["boss_2"] = {5, 6, 34, 34},
    ["boss_3"] = {2, 3, 4, 34, 34, 34},     
    ["boss_4"] = {3, 6, 8, 34, 34, 34},
    ["boss_5"] = {3, 4, 5, 6, 34, 34, 34, 34},
    ["boss_6"] = {3, 4, 5, 6, 34, 34, 34},
    ["boss_7"] = {2, 3, 4, 5, 6, 34, 34, 34, 34},
    ["boss_8"] = {2, 3, 4, 5, 6, 34, 34, 34, 34},
    ["boss_9"] = {6, 3, 4, 5, 8, 34, 34, 34},
    ["boss_10"] = {2, 3, 4, 5, 6, 34, 34, 34},
    ["boss_11"] = {2, 3, 4, 5, 6, 34, 34, 34},
    ["boss_12"] = {2, 3, 4, 5, 6, 34, 34, 34}
}
--Boss被击中后吐出的球的数量
local bossClackNum =
{
    ["boss_1"] ={3,5},
    ["boss_2"] ={4,5},
    ["boss_3"] ={4,5},
    ["boss_4"] ={4,6},
    ["boss_5"] ={4,6},
    ["boss_6"] ={4,6},
    ["boss_7"] ={4,7},
    ["boss_8"] ={4,7},
    ["boss_9"] ={4,7},
    ["boss_10"] ={5,8},
    ["boss_11"] ={5,8},
    ["boss_12"] ={5,8}
}



--boss技能-扔单个小球中每个小球的概率
local bossSepRate = 
{
	["boss_1"] = {0, 20, 40, 60, 80},
	["boss_2"] = {0, 19, 38, 57, 76, 95},
	["boss_3"] = {0, 19, 38, 57, 76, 95},
	["boss_4"] = {0, 18, 36, 54, 72, 90, 95},
	["boss_5"] = {0, 17, 34, 51, 68, 85, 90, 95},
	["boss_6"] = {0, 17, 34, 51, 68, 85, 90, 95},
	["boss_7"] = {0, 17, 34, 51, 68, 85, 90, 95},
	["boss_8"] = {0, 17, 34, 51, 68, 85, 89, 93, 97},
	["boss_9"] = {0, 17, 34, 51, 68, 85, 89, 93, 97},
	["boss_10"] = {0, 17, 34, 51, 68, 85, 88, 91, 94, 97},
	["boss_11"] = {0, 17, 34, 51, 68, 85, 89, 93, 97},
	["boss_12"] = {0, 17, 34, 51, 68, 85, 88, 91, 94, 97}
}
--boss大技能时间		
local bossLarTime= 		
{		
	["boss_1"] = {5, 5},		
	["boss_2"] = {5, 6},		
	["boss_3"] = {7, 8, 9},		
	["boss_4"] = {7, 9, 11},		
	["boss_5"] = {8, 10, 9, 10},		
	["boss_6"] = {9, 15, 14},		
	["boss_7"] = {8, 8, 10},		
	["boss_8"] = {9, 9, 10},		
	["boss_9"] = {8, 8, 9, 10},		
	["boss_10"] = {14, 12, 10},		
	["boss_11"] = {14, 12, 10},		
	["boss_12"] = {12, 11, 10, 9}
}
--boss大技能
local bossLarSkill = 
{
	["boss_1"] = {{2, 3, 4, 5, 6},{2, 3, 4, 5, 6}},
	["boss_2"] = {{2, 3, 5, 6},{2, 3, 4, 5, 27}},
	["boss_3"] = {{2, 3, 4},{2, 3, 12, 14},{2, 11, 12, 8}},
	["boss_4"] = {{3, 4, 6, 27, 28},{3, 4, 27, 28},{3, 4, 8, 27, 28}},
	["boss_5"] = {{2, 3, 4, 5},{3, 4, 5, 6, 27},{3, 4, 5, 6,27, 28},{2, 3, 5, 6, 27, 28}},
	["boss_6"] = {{10, 11, 12, 13, 27, 28},{10, 11, 13, 14, 27, 28},{10, 12, 13, 14, 27, 28}},
	["boss_7"] = {{41, 27, 2, 3},{41, 27, 28, 5, 6},{41, 28, 2, 3}},
	["boss_8"] = {{2, 3, 4, 5, 6, 27},{2, 3, 4, 5, 6, 27, 28},{2, 3, 4, 5, 6, 28}},            
	["boss_9"] = {{1, 3, 4, 5, 8,41},{1, 3, 4, 5, 8, 41},{41},{28, 27, 41}},
	["boss_10"] = {{5, 6, 27},{27, 28, 6},{2, 3, 4, 5, 6, 28}},
	["boss_11"] = {{41, 27},{10, 11, 27, 28, 41},{2, 6, 41, 28}},
	["boss_12"] = {{10, 5, 6, 41, 27, 28},{10, 11, 5, 6, 41, 28},{41, 27, 2, 3},{10, 11, 12, 14, 41, 28}}
}
--大技能扔出球数
local bossLarNums = 
{
	["boss_1"] = {3,3},
	["boss_2"] = {3,3},
	["boss_3"] = {3,3,2},
	["boss_4"] = {3,3,3},
	["boss_5"] = {4,3,2,3},
	["boss_6"] = {4,3,4},
	["boss_7"] = {4,5,4},
	["boss_8"] = {5,6,5},
	["boss_9"] = {6,3,3,5},
	["boss_10"] = {5,3,6},
	["boss_11"] = {5,6,5},
	["boss_12"] = {6,6,4,6}
}
--boss死亡后，产出金币
local bossOutput=
{
	["lar_1"]={1},
	["lar_2"]={2},
	["lar_3"]={3},
	["lar_4"]={4},
	["lar_5"]={5},
	["lar_6"]={6},
	["lar_7"]={7},
	["lar_8"]={8},
	["lar_9"]={9},
	["lar_10"]={10},
	["lar_11"]={11},
	["lar_12"]={12}
}

--是否是最后一个boss
local function isLastBoss(bossColor)
    if boss_hpNum == 0 then
        return true
    end
    return false
end

--更新血条
local function updateBossHp()
    boss_hpNum = boss_hpNum - 1
end

local function bossImpl()
	soundBossAttacked()
    local bossSpr = shootLayer:getChildByTag(tagNums["shootLayer"].shootKey)
    local bossColor = bossSpr.bubColor
    local bossSeq = bossSpr.seq
    sourX, sourY = bossSpr:getPosition()
    --更换bossHp
    updateBossHp()
	--更新血条
	addBossHpSpr()
    --发射球停止并停留
    if not isBomb(compareColor) and not dealRunFlag then
        dealRunBub()
    end
    --删除发射球
    sours[pot] = 0
    curBubLevel[pot] = 0
    if shootLayer:getChildByTag(tagNums["shootLayer"].shoot + pot) then   
        shootLayer:removeChildByTag(tagNums["shootLayer"].shoot + pot)
    end
	if shootLayer:getChildByTag(tagNums["shootLayer"].bossAni) then
		shootLayer:getChildByTag(tagNums["shootLayer"].bossAni):setVisible(false)
	end	
	--眼睛放大效果
	local eyeSpr = CCSprite:create(REPATHXG.."bossEye_"..largeLevel..".png")
	eyeSpr:setPosition(sourX, sourY)
	shootLayer:addChild(eyeSpr)
	table.insert(effectShootTable, eyeSpr)
	eyeSpr:runAction(CCScaleTo:create(0.5, 2))
	eyeSpr:runAction(CCFadeOut:create(1))
	performWithDelay(0.8, addBossAni)
    if isLastBoss(bossColor) then
		steelBossFlag = false
		stopSepSche(ranBossLarTimeScheHandleId)
		drop_Lar_Nums = 1
        if shootLayer:getChildByTag(tagNums["shootLayer"].bossAni) then
            shootLayer:removeChildByTag(tagNums["shootLayer"].bossAni)
        end
        gKeyBub = bossSpr
        gKey = 1

		local table1 = bossOutput["lar_"..largeLevel]
		local numGold = table1[1]
		genBossLarBlockBub(bossClackSkill["boss_"..largeLevel], bossClackNum["boss_"..largeLevel][1], bossClackNum["boss_"..largeLevel][2], bossSeq - 1, bossSeq +1, 1)


        return
    end
	--被动技能
	genBossLarBlockBub(bossClackSkill["boss_"..largeLevel], 4, 5, bossSeq - 1, bossSeq +1, 1)
	runFlyFlag = true
end
function addBossAni()
	if shootLayer:getChildByTag(tagNums["shootLayer"].bossAni) then
		shootLayer:getChildByTag(tagNums["shootLayer"].bossAni):setVisible(true)
	end
end

--判断是否是boss关
--DO 过关奖励
function isBoss()
    local mostLev = largeToSmall["lar_"..largeLevel][1]
    if cur_LevNum == mostLev then
        return true
    end
    return false
end
function isBoss_head()
	-- body
	local  mostLev = largeToSmall["lar_"..largeLevel][1] - 1
	if cur_LevNum == mostLev then
		return true
	end	
	return false
end
-------------------boss小招--------------------------
function ranBossSep()
	if not isGameLayerPause or not runFlyFlag or not isIceFlag then return end
	drop_Sep_Nums = math.random(bossSepNums["boss_"..largeLevel][1])
	dropBossSep()
end
function dropBossSep()
	if not isGameLayerPause or not runFlyFlag or not isIceFlag then return end
	drop_Sep_Nums = drop_Sep_Nums - 1
	if not isGameLayerPause then
        return
    end
    bossSepFirstFlag = false
    bossSepFirst = 0                    
    linkbossSepNum = 0
    bossSepLine = 0
    bossSepCol  = 0
	--选出不为空的球
    local sepTable = chooseBossSearch()
	if #sepTable < 3 then return end
    --判断相邻的球
    judgelinkBossSep(sepTable)
	if not bossSepFirstFlag then
        return
    end
    local boss_seq_1 = (bossSepLine - 1) * colNum + bossSepCol
    if curBubLevel[boss_seq_1] and curBubLevel[boss_seq_1] == 0 then
		addBossSepSpr()
    end
end
--选出不为空的球
function chooseBossSearch()
    local tableTmp = {}
    local choose_disG = gStartY - startY
    local minH = math.min(screenHeight, startY)
    local h_tmp = minH - bub_height * 2
	if curBubLevel then
		--解决突然下坠
		local len = searchLastNotZero_Pot() - 9
		if len <= 0 then return tableTmp end
		for i = len, 1, -1 do
			if curBubLevel[i] and curBubLevel[i] ~= 0 then
				local fixY = curBubLevel[i]:getPositionY()
                fixY = fixY - choose_disG
                if fixY > h_tmp then break end
				table.insert(tableTmp, curBubLevel[i])
			end
		end
	end
    return tableTmp
end
--必须与现有的球相连
function judgelinkBossSep(table1)
    linkbossSepNum = linkbossSepNum + 1
    if linkbossSepNum > 3 then 
        return
    end
    local ssBossSeq = table1[math.random(#table1)]
    local col, line = new_hex(ssBossSeq.seq)
    bossSeqRe(line, col)
    if not bossSepFirstFlag then
        judgelinkBossSep(table1)
    end
end

function bossSeqRe(line, col)
	if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line - 1) * colNum + col
    if curBubLevel[xy]  and curBubLevel[xy] ~= 0 then
        local k = line % 2 
		if k == 0 then k = -1 end
		if not bossSepFirstFlag then recursionBossSeq(line - 1, col - k) end
		if not bossSepFirstFlag then recursionBossSeq(line - 1, col) end
		if not bossSepFirstFlag then recursionBossSeq(line, col - 1) end
		if not bossSepFirstFlag then recursionBossSeq(line, col + 1) end
		if not bossSepFirstFlag then recursionBossSeq(line + 1, col - k) end
		if not bossSepFirstFlag then recursionBossSeq(line + 1, col) end
	end
end

function recursionBossSeq(line_1, col_1)
	if line_1 <= 0 or line_1 > lineNum or col_1 <= 0 or col_1 > colNum then
		return
	end
	local seq_xy = (line_1 - 1) * colNum + col_1
    if curBubLevel[seq_xy] and curBubLevel[seq_xy] == 0 then
        bossSepLine = line_1
        bossSepCol  = col_1
        bossSepFirst = seq_xy
		bossSepFirstFlag = true
	end
end

function addBossSepSpr()  
	bossSepSprite = nil    
    local spr_bossSepFirst = curBubLevel[bossSepFirst]
    if spr_bossSepFirst ~= 0 then return end
    
    boss_seq_1 = (bossSepLine - 1) * colNum + bossSepCol
    if shootLayer:getChildByTag(tagNums["shootLayer"].shoot + boss_seq_1) then
        bossSepFirstFlag = false
		bossSepFirst = 0                    
		linkbossSepNum = 0
		bossSepLine = 0
		bossSepCol  = 0
        return
    end
    
    if curBubLevel[boss_seq_1] and curBubLevel[boss_seq_1] ~= 0 then
        return
    end
    local bossSpr = shootLayer:getChildByTag(tagNums["shootLayer"].shootKey)
    if not bossSpr then return end
    local seqX, seqY = bossSpr:getPosition()
    
	local bossSeq_x1, bossSeq_y1 = getDoorXY(bossSepCol, bossSepLine)
	bossSeq_x1_ef, bossSeq_y1_ef = bossSeq_x1, bossSeq_y1
	local sepNum = getBossSepRate()
	local bubTmp = bossSepSkill["boss_"..largeLevel][sepNum]
	bossSepSprite = getBub(bubTmp, seqX, seqY, boss_seq_1)
	bossSepSprite:runAction(CCMoveTo:create(0.4, ccp(bossSeq_x1, bossSeq_y1)))
    shootLayer:addChild(bossSepSprite, 1, tagNums["shootLayer"].shoot + boss_seq_1)
    
    curBubLevel[boss_seq_1] = bossSepSprite
    sours[boss_seq_1] = bossSepSprite
    
    bossSepFirstFlag = false
	bossSepFirst = 0                    
	linkbossSepNum = 0
	bossSepLine = 0
	bossSepCol  = 0
	soundBossSep()
	if drop_Sep_Nums > 0 then
		performWithDelay(0.2, dropBossSep)
	end
	performWithDelay(0.4, bossSepDropEffect)
	performWithDelay(0.8, removeBossSepDrop)
end

--boss发单个球时的概率
function getBossSepRate()
	local rateTmp = bossSepRate["boss_"..largeLevel]
	local mathTmp = math.random(100)
	for i = #rateTmp, 1, -1 do
		if mathTmp >= rateTmp[i] then
			return i
		end
	end
end
-------------------boss大招--------------------------
--计时器
function ranBossLarCountTime()
	if not isGameLayerPause or not isIceFlag or not runFlyFlag then 
		return 
	end
	if drop_Lar_Nums > #bossLarTime["boss_"..largeLevel] then
		stopSepSche(ranBossLarTimeScheHandleId)
		drop_Lar_Nums = 1
		return
	end
	boss_xpNum = boss_xpNum + 1
	local timesAll = bossLarTime["boss_"..largeLevel][drop_Lar_Nums]
	bossBarPer = math.ceil(boss_xpNum / timesAll * 100)
	if bossBarPer <= 100 then
		changBossXpBarPer()
	end
end

function changBossXpBarPer()
	local to = CCProgressTo:create(1, bossBarPer)
	bossBarGo:runAction(to)
	to = nil
	if bossBarPer == 100 then
		performWithDelay(1, ran_boss_ran)
	end
end

function ran_boss_ran()
	if bossRedFlag then
		bossRedEffect()
	end
	ranBossLar()
    if twoLayer:getChildByTag(tagNums["twoLayer"].bossRed) then
        twoLayer:removeChildByTag(tagNums["twoLayer"].bossRed)
    end
	bossRedFlag = true
end

function ranBossLar()
	if drop_Lar_Nums <= #bossLarTime["boss_"..largeLevel] then
		dropBossLar()
	end
end	

function dropBossLar()	
	if not isGameLayerPause or not isIceFlag or not runFlyFlag then
		boss_xpNum = 0
        return
    end
	local bossSpr = shootLayer:getChildByTag(tagNums["shootLayer"].shootKey)
    local bossSeq = bossSpr.seq
	sourX_X, sourY_Y = bossSpr:getPosition()
	local col_start, col_end = 0, 0
	local mo_s, mo_e = 2, 8
    if bossSeq <= 4 then
        mo_s = 2
        mo_e = bossSeq + 3
    elseif bossSeq >= 6 then
        mo_s = bossSeq - 3
        mo_e = 8
    end
    local col1_1 = bossSeq - 1
    local col1_2 = bossSeq + 1
    local col2_1 = bossSeq - 2
    local col2_2 = bossSeq + 2

	local table1 = bossLarSkill["boss_"..largeLevel][drop_Lar_Nums]
	if not table1 then return end
	local lar_nums = bossLarNums["boss_"..largeLevel][drop_Lar_Nums]
	if #table1 >= 10 then
		col_start, col_end = mo_s, mo_e
	elseif #table1 < 4 then
		col_start, col_end = col1_1, col1_2
	else
		col_start, col_end = col2_1, col2_2
	end
	genBossLarBlockBub(table1, lar_nums, lar_nums, col_start, col_end, 2)
	drop_Lar_Nums = drop_Lar_Nums + 1
	boss_xpNum = 0
end

--生成阻碍球
function genBossLarBlockBub(table1, ran_start, ran_end, col_start, col_end, line_start)
    local seq_start = (line_start - 1) * colNum + 1
	local len1 = math.random(ran_start, ran_end)
    for i = 1, len1 do
        local genColor = table1[math.random(#table1)]
        for j = seq_start, #curBubLevel do
            local m_j = j % colNum
            if curBubLevel[j] == 0 and m_j >= col_start and m_j <= col_end then
                local col1, line1 = new_hex(j)
                local x1, y1 = new_XY(line1, col1)
				if not sourY_Y then
					sourY_Y = sourY
				end
                local spr1 = getBub(genColor, sourX_X, sourY_Y, j)
				spr1:stopAllActions()
				spr1:runAction(CCMoveTo:create(bossTime[math.random(#bossTime)], ccp(x1, y1)))
                sours[j] = spr1
                curBubLevel[j] = spr1
                shootLayer:addChild(spr1, 1, tagNums["shootLayer"].shoot + j)
				soundBossLar()
				bossSeq_x1_ef, bossSeq_y1_ef = x1, y1
				bossColLarEffect()
                break
            end
        end            
    end
end

function bossEntry()
    bossImpl()
end