function recursionStart()
	local last_pot = searchLastNotZero_Pot() - 15 * 9 - searchLastNotZero_Pot() % 9 + 1
	if last_pot < 1 then last_pot = 1 end
	--cclog("--- last_pot = "..last_pot)
    for i = last_pot, last_pot + 8 do 
		local colT, lineT = new_hex(i)
		if curBubLevel[i] and curBubLevel[i] ~= 0 then
			recursionDrop2(lineT, colT)
		end
	end
	local delSerBubs = {}
	for j = 1, #curBubLevel do
		if curBubLevel[j] and curBubLevel[j] ~= 0 and curBubLevel[j].isSearch == 0 then
			table.insert(delSerBubs, curBubLevel[j])
		end
	end
	resetSearch()
	if #delSerBubs > 0 then
		moveUtil(delSerBubs)
    else
        cclog("------------tmpsb 011---")
        tmpSB = {}
	end
end

function recursionDrop2(line, col)
	if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line-1)*colNum+col
	if curBubLevel[xy] and curBubLevel[xy] ~= 0  and curBubLevel[xy].isSearch == 0 then
        curBubLevel[xy].isSearch = 1
        local k = line % 2 
		if k == 0 then k = -1 end
		recursionDrop2(line-1, col)
		recursionDrop2(line-1, col - k)
		recursionDrop2(line, col-1)
		recursionDrop2(line, col+1)
		recursionDrop2(line+1, col)
		recursionDrop2(line+1, col - k)
	end
end

--消除掉落的球
function moveUtil(stabBub)
    cclog("------------tmpsb 000---")
    tmpSB = {}
    for m = 1, #stabBub do
		local bubTmp = stabBub[m]
		if bubTmp and bubTmp ~= 0 then
            local color = bubTmp.bubColor
            local x, y = bubTmp:getPosition()
            local seq = bubTmp.seq
            if bubTmp.bubColor == speBubs.energy then
                energyAdd()
                isEnergy = true
            end
            if bubTmp.bubColor == speBubs.bubDoor then
                --stabBub[m] = 0
                --shootLayer:removeChild(bubTmp)
                delDoorTwoSprites()
                cclog("------------tmpsb 010---")
                return
                --recursionStart()
            else
                local sprite = getBub(color, x, y, seq)
                if sprite and sprite ~= 0 then
                    table.insert(tmpSB, sprite)
                end
                shootLayer:removeChild(bubTmp)
            end
			sours[seq] = 0
			curBubLevel[seq] = 0
            addScore(1, 'drop', #stabBub)
		end
	end	
    dropEff()
end

function dropEff()
    for m = 1, #tmpSB do
        shootLayer:addChild(tmpSB[m])
    end
    for m = 1, #tmpSB do
        if tmpSB[m] and tmpSB[m] ~= 0 then
            if tmpSB[m].bubColor == speBubs.bubGold then
                local gold_x, gold_y = tmpSB[m]:getPosition()
                local gold_yL = gold_y + startY - gStartY
                collGoldEff(gold_x, gold_yL)
                goldAdd()
                isGold = true
                shootLayer:removeChild(tmpSB[m])
                tmpSB[m] = 0
            elseif tmpSB[m].bubColor == speBubs.energy then
                local ener_x, ener_y = tmpSB[m]:getPosition()
                energyEffect(ener_x, ener_y)
                energyAdd()
                shootLayer:removeChild(tmpSB[m])
                tmpSB[m] = 0
            else
                local cur_drop_x, cur_drop_y = tmpSB[m]:getPosition()
                tmpSB[m]:runAction(CCJumpTo:create(speNums.jumpTime, CCPoint(cur_drop_x, cur_drop_y), 20, 1))
                tmpSB[m]:runAction(CCFadeOut:create(speNums.jumpTime))
                local tmpScore = m * 100
                if not emptyRemove_flag and not goldRemove_flag then
                    scoreAway(tmpScore, 1.0, cur_drop_x, cur_drop_y)
                end
                table.insert(effectShootTable1, tmpSB[m])
            end
		end
	end
    cclog("------------tmpsb 001---")
    tmpSB = {}
    performWithDelay(speNums.jumpTime, removeShootLayerEffect1)
end

function removeShootLayerEffect1()
	for i = 1,#effectShootTable1 do
		if effectShootTable1[i] and effectShootTable1[i] ~= 0 then
            effectShootTable1[i]:stopAllActions()
			shootLayer:removeChild(effectShootTable1[i])
		end
	end
	effectShootTable1={}
end