local inBubs ={9, 17, 27, 28, 32, 35, 38, 41}
function initIntroBgLayer()
	introBgLayer =  CCLayer:create()
	local bg = CCSprite:create(REPATHBJ.."bgMain.jpg")
	bg:setPosition(screenWidth / 2 , screenHeight / 2)
	introBgLayer:addChild(bg)
	return introBgLayer
end

--分裂与染色
function introBubColor(color)
    if isSplit(color) then
        color = speNums.splitFirst
    elseif isDye(color) then
        color = speNums.dyeFirst
    end
    return color
end

--是否需要介绍
function isNeedIntro(color)
    for i = 1, #inBubs do
        if introBubColor(color) == inBubs[i] then
            if infoSours and infoSours["x_intro_bub"..color] and infoSours["x_intro_bub"..color] ~= 1 then
                infoSours["x_intro_bub"..color] = 1
                saveInfoSep()
                return true
            end
        end
    end
    
    return false
end

--介绍新泡泡
function introBubPop(intro_color)    
    local ch_new_tmp = ch_new
    local letter_tmp = letter_ttf
    if enviorLanguage == 1 then
        ch_new_tmp = ch_new_ch
        letter_tmp = head_ttf
    end
	local cont1 = ch_new_tmp["new_"..intro_color][1]
    local cont2 = ch_new_tmp["new_"..intro_color][2]
	intro_color = intro_color + intro_lar_bub
    isTwoLayer = false
    pauseBub()

    sfIntroLayer = CCLayer:create()    
    local pic_mh = "menghui.png"
    if device == "ipad" then 
        pic_mh = "menghui_ipad.png"
    elseif device == "iphone5" then 
        pic_mh = "menghui_ip5.png"
    end
	local sucBg = CCSprite:create(REPATHBJ..pic_mh)
	sucBg:setPosition(screenWidth / 2, screenHeight / 2)
    sfIntroLayer:addChild(sucBg)
	
	function resumeIntroBack()
        soundMenu2()
        isTwoLayer = true
		if sfIntroLayer then
			twoLayer:removeChild(sfIntroLayer)
			sfIntroLayer = nil
		end
		resumeBub()
    end
    introBg = CCSprite:create(REPATH_TMP.."newBubIntro_bj.png")
    introBg:setPosition(screenWidth / 2, screenHeight / 2)
    sfIntroLayer:addChild(introBg)
    --关闭后继续
    local tryAgain2= CCMenuItemImage:create(REPATHAN.."menu_ok_1.png",REPATHAN.."menu_ok_2.png")
    tryAgain2:registerScriptHandler(resumeIntroBack)
    local tryBack2 = CCMenu:createWithItem(tryAgain2)
    tryBack2:setPosition(440*adrate+20, 212*adrate+10)
    sfIntroLayer:addChild(tryBack2)
    local REPATH_TMP = REPATHBJ
    if enviorLanguage == 1 then
        REPATH_TMP = REPATHCH
    end    

	
    local introBub = CCSprite:createWithSpriteFrameName(intro_color..".png")
    introBub:setPosition(240, 250)
    introBg:addChild(introBub)
    	
    
    local jsSpr1 =CCLabelTTF:create(cont1, letter_tmp, 19)
    jsSpr1:setDimensions(CCSize(390, 250))
    jsSpr1:setHorizontalAlignment(UITextAlignmentLeft)
    jsSpr1:setColor(ccc3(255,255,255))  
    
    local jsSpr2 =CCLabelTTF:create(cont2, letter_tmp, 19)
    jsSpr2:setDimensions(CCSize(390, 250))
    jsSpr2:setHorizontalAlignment(UITextAlignmentLeft)
    jsSpr2:setColor(ccc3(255,255,255))
                
    if intro_color == speBubs.plate1 + intro_lar_bub then
        jsSpr1:setPosition(335*adrate, 100*adrate-40)        
        jsSpr2:setPosition(335*adrate, 50*adrate-40)
    elseif intro_color == speBubs.plate2 + intro_lar_bub then
        jsSpr1:setPosition(335*adrate, 100*adrate-40)
        jsSpr2:setPosition(335*adrate, 50*adrate-40)
    elseif intro_color == speBubs.down + intro_lar_bub then
        jsSpr1:setPosition(335*adrate, 100*adrate-40)
        jsSpr2:setPosition(335*adrate, 50*adrate-40)
    else
        jsSpr1:setPosition(335*adrate, 130*adrate-40)
    end    
    
    introBg:addChild(jsSpr1)    
    introBg:addChild(jsSpr2)
    twoLayer:addChild(sfIntroLayer)
end

--介绍key
function intro_key()
	isTwoLayer = false
    pauseBub()    
    introLayer_key = CCLayer:create()
	local pic_mh = "menghui.png"
    if device == "ipad" then 
        pic_mh = "menghui_ipad.png"
    elseif device == "iphone5" then 
        pic_mh = "menghui_ip5.png"
    end
	local sucBg = CCSprite:create(REPATHBJ..pic_mh)
	sucBg:setPosition(screenWidth / 2, screenHeight / 2)
    introLayer_key:addChild(sucBg)

    function resumeIntroBack()
        soundMenu2()
        isTwoLayer = true
		if introLayer_key then
			twoLayer:removeChild(introLayer_key)
			introLayer_key = nil

            --bubble1.4  hujian
             hj_isClickKeyWindows = true
            -- if largeLevel == 1 and cur_LevNum == 3 and infoSours["x_fresh_userSteel"] == 0  then
            if largeLevel == 1 and cur_LevNum == 1 and hj_isClickKeyWindows  then
                steelMenu_hide(true)
                infoSours["x_isClickSteelMenu"] = 1
                saveInfoSep()
                performWithDelay(0.01, intro_useSteel)
                steelMenuEffect(twoLayer,twoLayerUI["shop"].x-5 , twoLayerUI["shop"].y )
            end
            saveInfoSep()
			-- infoSours["x_intro_key"] = 1
			-- saveInfoSep()
		end
		-- resumeBub()
    end
    introBg = CCSprite:create(REPATHBJ.."newBubIntro_bj.png")
    introBg:setPosition(screenWidth / 2, screenHeight / 2)
    introLayer_key:addChild(introBg)
    --关闭后继续
    local tryAgain2= CCMenuItemImage:create(REPATHAN.."menu_ok_1.png",REPATHAN.."menu_ok_2.png")
    tryAgain2:registerScriptHandler(resumeIntroBack)
    local tryBack2 = CCMenu:createWithItem(tryAgain2)
    tryBack2:setPosition(240, 212*adrate+50)
    introLayer_key:addChild(tryBack2)
    local REPATH_TMP = REPATHBJ
    if enviorLanguage == 1 then
        REPATH_TMP = REPATHCH
    end
    
	local keyLar = speBubs.bubKey + intro_lar_bub
    local introBub = CCSprite:createWithSpriteFrameName(keyLar..".png")
    introBub:setPosition(220, 270)
    introBg:addChild(introBub)	
    local ch_other_tmp = ch_other
    local letter_tmp = letter_ttf
    if enviorLanguage == 1 then
        ch_other_tmp = ch_other_ch
        letter_tmp = head_ttf
    end
    local jqSpr1 =CCLabelTTF:create(ch_other_tmp["key"][1], letter_tmp, 20)
	jqSpr1:setDimensions(CCSize(380, 250))
	jqSpr1:setHorizontalAlignment(UITextAlignmentLeft)
	jqSpr1:setColor(ccc3(255,255,255))
    jqSpr1:setPosition(333*adrate+5, 250)
    introLayer_key:addChild(jqSpr1)
    
    local jqSpr2 =CCLabelTTF:create(ch_other_tmp["key"][2], letter_tmp, 20)
	jqSpr2:setDimensions(CCSize(380, 250))
	jqSpr2:setHorizontalAlignment(UITextAlignmentLeft)
	jqSpr2:setColor(ccc3(255,255,255))
    jqSpr2:setPosition(333*adrate+5, 210)
    introLayer_key:addChild(jqSpr2)
	
	twoLayer:addChild(introLayer_key)
end

function intro_useWave( )
    -- body
     -- body
    intro_useWave = CCSprite:create(REPATH.."steelGuide_bg.png")
    intro_useWave:setPosition(screenWidth/2,screenHeight/2)
    local ccs = CCSprite:create(REPATHLT.."steelGuide_char.png")
    ccs:setPosition(200,155)
    intro_useWave:addChild(ccs)
    twoLayer:addChild(intro_useWave,1)
    freshAni_useWave()
end


function intro_useSteel()
    -- body
    intro_usesteel = CCSprite:create(REPATH.."steelGuide_bg.png")
    intro_usesteel:setPosition(screenWidth/2,screenHeight/2)
    local ccs = CCSprite:create(REPATHLT.."steelGuide_char.png")
    ccs:setPosition(200,155)
    intro_usesteel:addChild(ccs)
    twoLayer:addChild(intro_usesteel,1)
    freshAni_useSteel()

end
--介绍boss
function intro_boss()
    isTwoLayer = false
    pauseBub()    
    introLayer_boss = CCLayer:create()
	local pic_mh = "menghui.png"
    if device == "ipad" then 
        pic_mh = "menghui_ipad.png"
    elseif device == "iphone5" then 
        pic_mh = "menghui_ip5.png"
    end
	local sucBg = CCSprite:create(REPATHBJ..pic_mh)
	sucBg:setPosition(screenWidth / 2, screenHeight / 2)
    introLayer_boss:addChild(sucBg)
    

    function resumeIntroBack()
        isTwoLayer = true

		if introLayer_boss then
			twoLayer:removeChild(introLayer_boss)
			introLayer_boss = nil             
			infoSours["x_intro_boss"] = 1
			saveInfoSep()
		end
        resumeBub()
        
    end
    introBg = CCSprite:create(REPATHBJ.."bossIntro_bj.png")
    introBg:setPosition(screenWidth / 2, screenHeight / 2 + 20*adrate)
    introLayer_boss:addChild(introBg)
    --关闭后继续
    local tryAgain2= CCMenuItemImage:create(REPATHAN.."menu_ok_1.png",REPATHAN.."menu_ok_1.png")
    tryAgain2:registerScriptHandler(resumeIntroBack)
    local tryBack2 = CCMenu:createWithItem(tryAgain2)
    tryBack2:setPosition(240, 230*adrate+50)
    introLayer_boss:addChild(tryBack2)
        

    local ch_other_tmp = ch_other
    local letter_tmp = letter_ttf
    if enviorLanguage == 1 then
        ch_other_tmp = ch_other_ch
        letter_tmp = head_ttf
    end
	local jqSpr1 =CCLabelTTF:create(ch_other_tmp["boss"][1], letter_tmp, 18)
	jqSpr1:setDimensions(CCSize(385, 253))
	jqSpr1:setHorizontalAlignment(UITextAlignmentLeft)
	jqSpr1:setColor(ccc3(255,255,255))
    jqSpr1:setPosition(310*adrate+10, 103*adrate-20)
    introBg:addChild(jqSpr1)

	local jqSpr2 =CCLabelTTF:create(ch_other_tmp["boss"][2], letter_tmp, 18)
	jqSpr2:setDimensions(CCSize(385, 253))
	jqSpr2:setHorizontalAlignment(UITextAlignmentLeft)
	jqSpr2:setColor(ccc3(255, 255, 255))
    jqSpr2:setPosition(310*adrate+10, -65*adrate-20)
    introBg:addChild(jqSpr2)

    twoLayer:addChild(introLayer_boss)
end

--初次介绍积分
function intro_score()
	tcFlag = false
    introLayer_score = CCLayer:create()	
    
    function resumeIntroBack()
        soundMenu2()
        tcFlag = true
		if introLayer_score then
			sucLayer:removeChild(introLayer_score)
			introLayer_score = nil
			infoSours["x_intro_score"] = 1
			saveInfoSep()
		end
    end
    
    --关闭后继续
    local tryAgain2= CCMenuItemImage:create(REPATHAN.."menu_ok_1.png",REPATHAN.."menu_ok_2.png")
    tryAgain2:registerScriptHandler(resumeIntroBack)
    local tryBack2 = CCMenu:createWithItem(tryAgain2)
    tryBack2:setPosition(440*adrate, 212*adrate)
    introLayer_score:addChild(tryBack2)
    local REPATH_TMP = REPATHBJ
    if enviorLanguage == 1 then
        REPATH_TMP = REPATHCH
    end    
    introBg = CCSprite:create(REPATH_TMP.."newBubIntro_bj.png")
	introBg:setPosition(screenWidth / 2, screenHeight / 2)
	introLayer_score:addChild(introBg)
	
	local bubAddSLar = speBubs.bubAddS + intro_lar_bub
	local introBub = CCSprite:createWithSpriteFrameName(bubAddSLar..".png")
    introBub:setPosition(160*adrate, 500*adrate)
    introBg:addChild(introBub)	
    local ch_other_tmp = ch_other
    local letter_tmp = letter_ttf
    if enviorLanguage == 1 then
        ch_other_tmp = ch_other_ch
        letter_tmp = head_ttf
    end
	local jqSpr1 =CCLabelTTF:create(ch_other_tmp["score"][1], letter_tmp, 20)
	jqSpr1:setDimensions(CCSize(250, 300))
	jqSpr1:setHorizontalAlignment(UITextAlignmentLeft)
	jqSpr1:setColor(ccc3(0, 0, 0))
    jqSpr1:setPosition(333*adrate, 110*adrate)
    introBg:addChild(jqSpr1)
    
    local jqSpr2 =CCLabelTTF:create(ch_other_tmp["score"][2], letter_tmp, 20)
	jqSpr2:setDimensions(CCSize(250, 300))
	jqSpr2:setHorizontalAlignment(UITextAlignmentLeft)
	jqSpr2:setColor(ccc3(0, 0, 0))
    jqSpr2:setPosition(333*adrate, 50*adrate)
    introBg:addChild(jqSpr2)
    
    sucLayer:addChild(introLayer_score)
end

--初次点击menu时提示
function intro_menu()
	isTwoLayer = false
    pauseBub()    
    introLayer_menu = CCLayer:create()
	local pic_mh = "menghui.png"
    if device == "ipad" then 
        pic_mh = "menghui_ipad.png"
    elseif device == "iphone5" then 
        pic_mh = "menghui_ip5.png"
    end
	local sucBg = CCSprite:create(REPATHBJ..pic_mh)
	sucBg:setPosition(screenWidth / 2, screenHeight / 2)
    introLayer_menu:addChild(sucBg)
    local REPATH_TMP = REPATHBJ
    if enviorLanguage == 1 then
        REPATH_TMP = REPATHCH
    end    
    introBg = CCSprite:create(REPATH_TMP.."menu_bj.png")
	introBg:setPosition(screenWidth / 2, screenHeight / 2 + 50)
	introLayer_menu:addChild(introBg)
    
    function resumeIntroBack()
        soundMenu1()
        if introLayer_menu then
			twoLayer:removeChild(introLayer_menu)
			introLayer_menu = nil
		end
		pausePrompt()
    end
    
    --关闭后继续
    local tryAgain2= CCMenuItemImage:create(REPATHAN.."cha1.png",REPATHAN.."cha2.png")
    tryAgain2:registerScriptHandler(resumeIntroBack)
    local tryBack2 = CCMenu:createWithItem(tryAgain2)
    tryBack2:setPosition(230, 315)
    introBg:addChild(tryBack2)

	function nextMenuBack()
        isTwoLayer = true
		if introLayer_menu then
			twoLayer:removeChild(introLayer_menu)
			introLayer_menu = nil
		end
		mainBack_pause()
    end
    
    --关闭后继续
    local tryAgain3= CCMenuItemImage:create(REPATHAN.."menu_exit_1.png",REPATHAN.."menu_exit_2.png")
    tryAgain3:registerScriptHandler(nextMenuBack)
    local tryBack3 = CCMenu:createWithItem(tryAgain3)
    tryBack3:setPosition(260, 95*adrate)
    introBg:addChild(tryBack3)

    twoLayer:addChild(introLayer_menu)
end

--初次点击menu时提示
function intro_menu_restart()
	isTwoLayer = false
    pauseBub()    
    introLayer_menu = CCLayer:create()
	local pic_mh = "menghui.png"
    if device == "ipad" then 
        pic_mh = "menghui_ipad.png"
    elseif device == "iphone5" then 
        pic_mh = "menghui_ip5.png"
    end
	local sucBg = CCSprite:create(REPATHBJ..pic_mh)
	sucBg:setPosition(screenWidth / 2, screenHeight / 2)
    introLayer_menu:addChild(sucBg)
    local REPATH_TMP = REPATHBJ
    if enviorLanguage == 1 then
        REPATH_TMP = REPATHCH
    end    
    introBg = CCSprite:create(REPATH_TMP.."menu_bj.png")
	introBg:setPosition(screenWidth / 2, screenHeight / 2 + 50)
	introLayer_menu:addChild(introBg)
    
    function resumeIntroBack()
        soundMenu1()
        if introLayer_menu then
			twoLayer:removeChild(introLayer_menu)
			introLayer_menu = nil
		end
		pausePrompt()
    end
    
    --关闭后继续
    local tryAgain2= CCMenuItemImage:create(REPATHAN.."cha1.png",REPATHAN.."cha2.png")
    tryAgain2:registerScriptHandler(resumeIntroBack)
    local tryBack2 = CCMenu:createWithItem(tryAgain2)
    tryBack2:setPosition(400, 300)
    introBg:addChild(tryBack2)

	function nextMenuBack()
        isTwoLayer = true
		if introLayer_menu then
			twoLayer:removeChild(introLayer_menu)
			introLayer_menu = nil
            if retryLev >= 3 and infoSours["hj_control_onlyone_2"..retryLev] == 0 then
                infoSours["hj_control_onlyone"..retryLev] = 0
                infoSours["hj_control_onlyone_2"..retryLev] = 1
                saveInfoSep()
            end
		end
		--mainBack_pause_restart()
        -- CCMessageBox(infoSours["hj_control_onlyone"..retryLev],"log:")
        gotoPlayUtil()
    end
    
    --关闭后继续
    local tryAgain3= CCMenuItemImage:create(REPATHAN.."menu_exit_1.png",REPATHAN.."menu_exit_2.png")
    tryAgain3:registerScriptHandler(nextMenuBack)
    local tryBack3 = CCMenu:createWithItem(tryAgain3)
    tryBack3:setPosition(220, 95*adrate)
    introBg:addChild(tryBack3)

    twoLayer:addChild(introLayer_menu)
end

--介绍剧情结束
function intro_allStory_end(content, key, pot_xyz)
	larEndFlag = false
    introLayer_com2 = CCLayer:create()
	local pic_mh = "menghui.png"
    if device == "ipad" then 
        pic_mh = "menghui_ipad.png"
    elseif device == "iphone5" then 
        pic_mh = "menghui_ip5.png"
    end
	local sucBg = CCSprite:create(REPATHBJ..pic_mh)
	sucBg:setPosition(screenWidth / 2, screenHeight / 2)
    introLayer_com2:addChild(sucBg)
    
    function resumeIntroBack()
        soundMenu2()
		larEndFlag = true
		if introLayer_com2 then
			layerUI:removeChild(introLayer_com2)
			introLayer_com2 = nil
			infoSours[key] = 1
			saveInfoSep()
		end
    end
    
    --关闭后继续
    local tryAgain2= CCMenuItemImage:create(REPATHAN.."menu_ok_1.png",REPATHAN.."menu_ok_2.png")
    tryAgain2:registerScriptHandler(resumeIntroBack)
    local tryBack2 = CCMenu:createWithItem(tryAgain2)
    tryBack2:setPosition(430*adrate+30, 265*adrate)
    introLayer_com2:addChild(tryBack2)

    --背景   
    introBg = CCSprite:create(REPATHBJ.."intro_story_bj.png")
	introBg:setPosition(screenWidth / 2+30, screenHeight / 2 + 20)
	introLayer_com2:addChild(introBg)
	--插画
	local huaBj = CCSprite:create(REPATHBJ.."intro_story_"..largeLevel..".jpg")
	huaBj:setPosition(25+15, 340*adrate)
	introBg:addChild(huaBj)
	--插画外框
	local huaOutBj = CCSprite:create(REPATHBJ.."intro_story_out.png")
	huaOutBj:setPosition(25+15, 340*adrate)
	introBg:addChild(huaOutBj)
	--标题
    --    hujian
	local titleSpr = CCSprite:create(REPATHLT.."bTitle_"..largeLevel..".png")
	titleSpr:setPosition(270*adrate, 560*adrate)
	introBg:addChild(titleSpr)
    local letter_tmp = letter_ttf
    if enviorLanguage == 1 then
        letter_tmp = head_ttf
    end
	--文字    
	local jqSpr1 =CCLabelTTF:create(content[1], letter_tmp, pot_xyz.size)
	jqSpr1:setDimensions(CCSize(130, 740))
	jqSpr1:setHorizontalAlignment(UITextAlignmentLeft)
	jqSpr1:setColor(ccc3(0, 0, 0))
    jqSpr1:setPosition(pot_xyz.x+15, pot_xyz.y)
    introBg:addChild(jqSpr1)

	local jqSpr2 =CCLabelTTF:create(content[2], letter_tmp, pot_xyz.size)
	jqSpr2:setDimensions(CCSize(130, 740))
	jqSpr2:setHorizontalAlignment(UITextAlignmentLeft)
	jqSpr2:setColor(ccc3(0, 0, 0))
    jqSpr2:setPosition(pot_xyz.x+15, pot_xyz.z)
    introBg:addChild(jqSpr2)

    layerUI:addChild(introLayer_com2, 1, 10)
end

--介绍特殊球解锁
function intro_speBubs_unlock(content, key, speColor)
	speColor = speColor + intro_lar_bub
    isTwoLayer = false
    pauseBub()    
    introLayer_boss = CCLayer:create()
	local pic_mh = "menghui.png"
    if device == "ipad" then 
        pic_mh = "menghui_ipad.png"
    elseif device == "iphone5" then 
        pic_mh = "menghui_ip5.png"
    end
	local sucBg = CCSprite:create(REPATHBJ..pic_mh)
	sucBg:setPosition(screenWidth / 2, screenHeight / 2)
    introLayer_boss:addChild(sucBg)

	function resumeIntroBack()
        soundMenu2()
        isTwoLayer = true
		if introLayer_boss then
			twoLayer:removeChild(introLayer_boss)
			introLayer_boss = nil
			infoSours[key] = 1
			saveInfoSep()
		end
		resumeBub()
		--sucPrompt()
        if isBoss_head() then
        --Donny过关奖励
        -- performWithDelay(1, passGift)
            passGift()
        else
           sucPrompt() 
    end
        
    end
    introBg = CCSprite:create(REPATHBJ.."newBubIntro_bj.png")
    introBg:setPosition(screenWidth / 2, screenHeight / 2)
    introLayer_boss:addChild(introBg)
    --关闭后继续
    local tryAgain2= CCMenuItemImage:create(REPATHAN.."menu_ok_1.png",REPATHAN.."menu_ok_2.png")
    tryAgain2:registerScriptHandler(resumeIntroBack)
    local tryBack2 = CCMenu:createWithItem(tryAgain2)
    tryBack2:setPosition(240, 212*adrate+50)
    introLayer_boss:addChild(tryBack2)
        


	local activeBub = CCSprite:createWithSpriteFrameName(speColor..".png")
	activeBub:setPosition(220, 270)
	introBg:addChild(activeBub)

	-- local activeLT = CCSprite:create(REPATHLT.."activationProps.png")
	-- activeLT:setPosition(423*adrate, 517*adrate)
	-- introBg:addChild(activeLT)
    local letter_tmp = letter_ttf
    if enviorLanguage == 1 then
        letter_tmp = head_ttf
    end
    local jqSpr1 =CCLabelTTF:create(content[1], letter_tmp, 18)
    jqSpr1:setDimensions(CCSize(380, 400))
    jqSpr1:setHorizontalAlignment(UITextAlignmentLeft)
    jqSpr1:setColor(ccc3(255,255,255))
    
    local jqSpr2 =CCLabelTTF:create(content[2], letter_tmp, 18)
    jqSpr2:setDimensions(CCSize(380, 400))
    jqSpr2:setHorizontalAlignment(UITextAlignmentLeft)
    jqSpr2:setColor(ccc3(255,255,255))
        
    local jqSpr3 =CCLabelTTF:create(content[3], letter_tmp, 18)
    jqSpr3:setDimensions(CCSize(380, 400))
    jqSpr3:setHorizontalAlignment(UITextAlignmentLeft)
    jqSpr3:setColor(ccc3(255,255,255))   
        
    if speColor == speBubs.mul + intro_lar_bub then        
        jqSpr1:setPosition(320*adrate, -20*adrate) 
        jqSpr2:setPosition(320*adrate, -48*adrate)       
        jqSpr3:setPosition(320*adrate, -115*adrate)
    elseif speColor == speBubs.bomb + intro_lar_bub then
        jqSpr1:setPosition(320*adrate, -20*adrate)
        jqSpr2:setPosition(320*adrate, -48*adrate)
        jqSpr3:setPosition(320*adrate, -115*adrate)
    elseif speColor == speBubs.steel + intro_lar_bub then
        jqSpr1:setPosition(320*adrate, -20*adrate)
        jqSpr2:setPosition(320*adrate, -48*adrate)
        jqSpr3:setPosition(320*adrate, -115*adrate)
    elseif speColor == speBubs.ice + intro_lar_bub then
        jqSpr1:setPosition(320*adrate, -20*adrate)
        jqSpr2:setPosition(320*adrate, -48*adrate)
        jqSpr3:setPosition(320*adrate, -115*adrate)
    elseif speColor == speBubs.energy + intro_lar_bub then
        jqSpr1:setPosition(320*adrate, -20*adrate)
        jqSpr2:setPosition(320*adrate, -48*adrate)
        jqSpr3:setPosition(320*adrate, -115*adrate)    
    elseif speColor == speBubs.bubV + intro_lar_bub then
        jqSpr1:setPosition(320*adrate, -20*adrate)
        jqSpr2:setPosition(320*adrate, -48*adrate)
        jqSpr3:setPosition(320*adrate, -115*adrate)
    else
        jqSpr1:setPosition(320*adrate, -20*adrate)
        jqSpr2:setPosition(320*adrate, -48*adrate)
        jqSpr3:setPosition(320*adrate, -115*adrate)
    end
    introBg:addChild(jqSpr1)    
    introBg:addChild(jqSpr2)    
    introBg:addChild(jqSpr3)    
    twoLayer:addChild(introLayer_boss)
end
--特殊球解锁入口
function introOnly_speBubs()
    local ch_speBubs_tmp = ch_speBubs
    if enviorLanguage == 1 then
        ch_speBubs_tmp = ch_speBubs_ch
    end
	if retryLev == 3 and infoSours["x_intro_mul"] == 0 then
		intro_speBubs_unlock(ch_speBubs_tmp["mul"], "x_intro_mul", speBubs.mul)
	elseif retryLev == 15 and infoSours["x_intro_bomb"] == 0 then
		intro_speBubs_unlock(ch_speBubs_tmp["bomb"], "x_intro_bomb", speBubs.bomb)
	elseif retryLev == 29 and infoSours["x_intro_steel"] == 0 then
		intro_speBubs_unlock(ch_speBubs_tmp["steel"], "x_intro_steel", speBubs.steel)
	elseif retryLev == 46 and infoSours["x_intro_ice"] == 0 then
		intro_speBubs_unlock(ch_speBubs_tmp["ice"], "x_intro_ice", speBubs.ice)
	elseif retryLev == 55 and infoSours["x_intro_energy"] == 0 then
		if limit_ios then
			intro_speBubs_unlock(ch_speBubs_tmp["energy"], "x_intro_energy", speBubs.energy)
		end
	elseif retryLev == 63 and infoSours["x_intro_bubV"] == 0 then
		intro_speBubs_unlock(ch_speBubs_tmp["bubV"], "x_intro_bubV", speBubs.bubV)
	else
		if isBoss_head() then
        --Donny过关奖励
        -- performWithDelay(1, passGift)
            passGift()
        else 
            sucPrompt()
      end
	end	
end
--剧情结束入口
function introOnly_storyEnd()
	local mostLev = largeToSmall["lar_"..largeLevel][1]
	local str = "x_intro_lar"..largeLevel
	--if cur_LevNum == mostLev and infoSours[str] == 0 then
	if infoSours[str] == 0 and largeLevel >= 2 then
		local tmpLar = largeLevel - 1
        local ch_end_tmp = ch_end
        if enviorLanguage == 1 then
            ch_end_tmp = ch_end_ch
        end
		-- intro_allStory_end(ch_end_tmp["story_"..tmpLar], str, ch_end_pot["story_"..tmpLar])
	end
end

--开始关卡剧情说明
ch_start = 
{
	"    Selina walked out of the palace and met lantern fishes in the coral fauna. Where will the lantern fishes lead Selina to?",
	"    The shining light of the sunken boat attracts Selina to swim towards it. Selina doesn't know what's behind the green light.",
	"    Selina follows her marine races to the high platform. She's puzzled because she has never seen her marine races being so crazy.",
	"    Selina finds the stones strange and begins to observe them. She finds some stone figures are playing tricks. How hateful they are!",
	"    Selina is frightened by the strong light of the submarine, but irritated by its deafening noise. May the trench gain its peace.",
	"    What's this? A benthic whirlpool? Selina is drawn in when she wants to get close to check out.",
	"    The overwhelming hot water makes Selina feel unwell. She knows it's the demon and she has to beat it.",
	"    Selina is attracted by the shining jewellery and treasures on the ground. It seems she's obsessed and ignoring the evil pirate in the darkness.",
	"    Selina meets a human in the reef. She wonders what the world above the ocean looks like?",
	"    Selina follows the human being to the shoal and breathes fresh air, but she soon discovers it's more horrible than the ocean. ",
	"    Selina is very happy because she thinks the trident is in front of her, but in fact it's the tongue of a sleeping giant fish. ",
	"    Hot water's running and magma is spouting, but Selina jumps into the deep of the sea with determination. Here's the place she has been looking for."
}
--关卡结束剧情说明
ch_end = 
{
	["story_1"] = {"    Selina have passed the test by lantern fishes and set out. Where to find the trident? ", 
			"    She's attracted by the shining light from a sunken boat far away. She swims towards the boat."},
	["story_2"] = {"    It turns out to be some sunken boat ghosts. Selina beat them but still doesn't know where to find the trident. ", 
			"    Suddenly she finds her marine races are swimming towards a high platform in front. What happened? She decided to check out."},
	["story_3"] = {"    It turns out to be an evil creature,but the hydra in the altar is beaten and the races become normal. ", 
			"    Where to go now? Selina finds she have got lost in the stones."},
	["story_4"] = {"    The stone figures are hateful and hard. Selina beats them down and walked out. ", 
			"    Deafening buzzing noise comes from the big ocean trench and she sees a big object she's never seen before. What's that?"},
	["story_5"] = {"    The trench becomes peaceful and Selina thinks she has beaten the strong opponent. ", 
			"    Without a clue of the trident, Selina swims along the trench."},
	["story_6"] = {"    What a  horrible big black hole it is! Selina thinks she's going to get fainted after jumping out of the whirlpool. ", 
			"    What's the fire in front? Selina feels strong heat in the face, the familiar heat of the demon."},
	["story_7"] = {"    The octopus is finally beaten down and Selina finds her weakness. The black bay in front looks quiet. ", 
			"    How can she miss any chance to find the trident?"},
	["story_8"] = {"    So many treasures! Selina thinks of her mission. She feels her body is becoming light and the water is desalted. ", 
			"    It seems she can see a vast area of light over her head."},
	["story_9"] = {"    The human being leaves the shoal and goes to the shore. ", 
			"    The mermaid princess decides to follow him."},
	["story_10"] = {"    Finally getting rid of air and dry earth, Selina feels at home in the ocean and swims happily among seaweeds. ", 
			"    What's that? The trident she has been looking for?"},
	["story_11"] = {"    The giant fish tells Selina everything, including the name of the demon. ", 
			"    The demon is living in the deep of the earth's core under the sea. Selina sets out bravely."},
	["story_12"] = {"    The Lava Spawn is not so easy to be beaten down. Selina beats it down finally and goes back to the palace with the trident. ", 
			"    The Atlantis ocean needs her."}
}
ch_end_pot = 
{
	["story_1"] = {x = 310*adrate, y = -10*adrate, z = -20, size = 18},
	["story_2"] = {x = 310*adrate, y = -15*adrate, z = -20, size = 18},
	["story_3"] = {x = 310*adrate, y = -10*adrate, z = -40, size = 18},
	["story_4"] = {x = 310*adrate, y = -10*adrate, z = 0, size = 18},
	["story_5"] = {x = 310*adrate, y = -10*adrate, z = -25, size = 18},
	["story_6"] = {x = 310*adrate, y = -15*adrate, z = -20, size = 18},
	["story_7"] = {x = 310*adrate, y = -15*adrate, z = -40, size = 18},
	["story_8"] = {x = 310*adrate, y = -15*adrate, z = -90, size = 18},
	["story_9"] = {x = 310*adrate, y = -15*adrate, z = -5, size = 18},
	["story_10"] = {x = 310*adrate, y = -10*adrate, z = -75, size = 18},
	["story_11"] = {x = 310*adrate, y = -10*adrate, z = -5, size = 18},
	["story_12"] = {x = 310*adrate, y = -15*adrate, z = 0, size = 18},
}
--关卡成功后介绍特殊球
ch_speBubs =
{
	["mul"] =    {"    You've unlocked a new props, the color ball. ",
			      "    Color balls can eliminate all balls with color. Color balls can appear and be used in the game. ", 
			      "    You can enhance its ability of appearing in function enhancement."},
	["bomb"] =   {"    You’ve unlocked a new props, the bomb. ",
			      "    The bomb can destroy most types of balls and gives you great help in critical moments. ", 
			      "    You can enhance its ability of appearing and destroying power in the function enhancement."},
	["steel"] =  {"    You've unlocked a new props, the steel ball. ",
			      "    It may be the most powerful props ball in the game. It can destroy all bubbles in the way. ",
			      "    You can enhance its ability of appearing and increase its destroying emitting distance in the function enhancement."},
	["ice"] =    {"    You've unlocked a new props, the ice ball. ",
			      "    The ice ball can freeze all bubbles in the game and prevent them from falling. ", 
			      "    You can increase its rate of appearing and freezing time in the function enhancement."},
	["energy"] = {"    You've unlocked a new props, energy. ",
			      "    The emitting wave will be able to emit waves after accumulating a certain number of energy balls. ", 
			      "    You can reduce the required number of energy balls for emitting waves in the function enhancement."},
	["bubV"] =   {"    You've unlocked a new props, the magic color ball. ",
			      "    It can eliminate all nearby bubbles of the same color upon touching, even the wood plate. ", 
			      "    You can enlarge its functional scope."}
}
--其它介绍弹窗
ch_other =
{
	["score"] = {"Point-Adding Ball: ", "    All bubbles will be added with 50 points when it's used in the game and being eliminated."},
	["boss"] =  {"    Boss: the final guard of the scene is disturbing you all the time. you need to shoot the BOSS for many times in order to pass the level. ", 
				 "    The BOSS will beat back when  being shot. The earlier you shoot the BOSS, the easier to pass the level."},
	["key"] =   {"Level Keys: ", 
                 "    Shooting the key to complete the level. You can only unlock the next level with the key."},
	["menu"] = {"    You will lose one hp when you quit."}
}
--[[
--成就
ch_ach = 
{
	["ach_12"] = {"Attaining 20 thousand points for a single shooting","INCREDIBLE"},
	["ach_9"] = {"Emitting bubbles for 500 times","ROAD TO GLORY"},
	["ach_10"] = {"Emitting bubbles for 2000 times","SHOOTING"},
	["ach_31"] = {"The total points reach 50  million","MULTIMILLION MASTER"},
	["ach_32"] = {"The total points reach 100 million","BILLION MASTER"},
	["ach_33"] = {"Emitting bubbles for 5000 times","SHOOTING"},
	["ach_34"] = {"Passing all boss levels","MASTER ADVANCEMENT"},
	["ach_13"] = {"Fail within 10 balls after starting","SAD"},
	["ach_4"] = {"No key bubble appears in sight when passing levels","SNIPER"},
	["ach_26"] = {"Levels are rated as or above two stars","MASTERS' SELF-DISCIPLINE"},
	["ach_27"] = {"Color bubbles appear for at least 20 times in a game","RAINBOW'S DREAM"},
	["ach_28"] = {"Bombs appear for at least 20 times in a game","BOMBARD TO THE END"},
	["ach_29"] = {"Steel balls appear for at least 10 times in a game","BOMBARD TO THE END"},
	["ach_5"] = {"The games time reaches 20 minutes","BUBBLES' FRIEND"},
	["ach_6"] = {"The games time reaches 50 minutes","BUBBLES' PRIDE"},
	["ach_7"] = {"The games time reaches 100 minutes","BUBBLE KNIGHT"},
	["ach_8"] = {"The games time reaches 1000 minutes","BUBBLE BUBBLe"},
	["ach_11"] = {"Purchasing one props","CHEAPSKATE?"},
	["ach_25"] = {"Consuming more than 100  gems on props","SHOPPING MASTER"},
	["ach_14"] = {"Beating down the lantern fishes in corals","CORAL ZONE"},
	["ach_15"] = {"Beating down the sunken boat ghosts","SUNKEN BOAT"},
	["ach_16"] = {"Beating down the hydra in the altar","ALTAR"},
	["ach_17"] = {"Beating down the stone figures","STONE CAMP"},
	["ach_18"] = {"Beating down the submarine in the trench","TRENCH"},
	["ach_19"] = {"Beating down the big black hole in the whirlpool","BLACK HOLE"},
	["ach_20"] = {"Beating down the octopus","VOLCANO"},
	["ach_21"] = {"Beating down the evil pirate","TREASURE BAY"},
	["ach_22"] = {"Beating down the human being","SHOAL"},
	["ach_23"] = {"Beating down the enchanting building","LAND"},
	["ach_24"] = {"Beating down the Lava Spawn","GEOCENTER"},
	["ach_30"] = {"All levels in a scene are rated three stars","PERFECTIONISM"},
	["ach_1"] = {"Beating down 2 bosses today","ROAD TO KING"},
	["ach_2"] = {"Attaining 2 million points today","I LOVE BUBBLE"},
	["ach_3"] = {"Consuming one time today","HABIT"}
}
]]
--增强
ch_stre = 
{
	["stre_1"]  = {"Enhance color balls' emitting ability",""},
	["stre_2"]  = {"Lower money requirement for activating abilities",""},
	["stre_3"]  = {"Enhance bombs' emitting ability","  Enhance bombs' emitting ability"},
	["stre_4"]  = {"Enhance bombs' power","  Enhance bombs' power"},
	["stre_5"]  = {"Enhance magic color balls' power","  Enhance magic color balls' power"},
	["stre_6"]  = {"Increase steel balls' emitting distance","  Increase steel balls' emitting distance"},
	["stre_7"]  = {"Enhance ice balls' emitting ability","  Enhance ice balls' emitting ability"},
	["stre_8"]  = {"Increase ice balls' function time","  Increase ice balls' function time"},
	["stre_9"]  = {"Enhance waves' pushing ability",""},
	["stre_10"] = {"Lower waves' requirement on the number of energy balls ","Lower waves' requirement on the number of energy balls"}
}
--介绍新球英文
ch_new =
{
	["new_9"]  = {"    New colorful bubbles will appear in nearby places when touched by emitting bubbles",""},
	["new_17"] = {"    The emitting bubbles will dye the common bubbles around with their own colors upon touching",""},
	["new_27"] = {"Hard plates: ", "    It can withstand various emitting bubbles, destroyed only by bombs."},
	["new_28"] = {"Super hard plates: ", "    It can withstand various emitting bubbles and bombs"},
	["new_32"] = {"    A kind of basic bubble will appear and takes function upon being touched",""},
	["new_35"] = {"    Doesn't belong to any basic color bubbles, and will not disappear no matter how many have been piled",""},
	["new_38"] = {"    Bubbles appear in couple, will transmit bubbles in the way to other places",""},
	["new_41"] = {"Dangerous bubbles: ", "    All bubbles will fall down rapidly upon being touched"}
}
--插画对应的介绍球
bossCHIntroBub = 
{
    ["lar_1"]  = {25,"You'll get the ball if you beat the boss"},
    ["lar_2"]  = {0," Surprise on the next level"},
    ["lar_3"]  = {31,"You'll get the ball if you beat the boss"},
    ["lar_4"]  = {0,"Surprise on the next level"},
    ["lar_5"]  = {30,"You'll get the ball if you beat the boss"},
    ["lar_6"]  = {0,"Surprise on the next level"},
    ["lar_7"]  = {29,"You'll get the ball if you beat the boss"},
    ["lar_8"]  = {36,"You'll get the ball if you beat the boss"},
    ["lar_9"]  = {26,"You'll get the ball if you beat the boss"},
    ["lar_10"] = {0,"Surprise on the next level"},
    ["lar_11"] = {0,"Surprise on the next level"},
    ["lar_12"] = {0,"Surprise on the next level"}
}

--开始关卡剧情说明
ch_start_ch = 
{   
"        这是一个遥远的北方牧场，常年冰雪覆盖着这片大地，此时此刻，冒险之旅就从这里开始！",
"        自然世界此刻是如此的美丽，到处放射着明媚的阳光，到处炫耀着五颜的色彩，雪原之歌令人陶醉！",
"        仰首望上去，湛蓝的天空下，阳光灿烂地做着背景，艾泽小溪蜿蜒曲折多么令人崇敬和赞叹！",
"        靓丽的风景线勾勒出高山那悬崖峭壁奇石怪垒的身架，更是把人们所有的向往和赞美都写在了高处。",
"        再没有比冰雪覆盖后的森林更迷人了，整个森林，都是魔法的世界，处处都是神秘都是无知。",
"        近了，看到的这一切都是遗失的世界，诺森大陆，这个让人们遗忘的天地，依旧那么和善可亲。",
"        雪中的景色壮丽无比，天地之间浑然一色，隐隐之中远古冰洞还是那么神出鬼没，神秘莫测。",
"        瓦兰瀑布，周身绕着白云，如同一群猛虎，突然惊醒，咆哮着冲下山岗，雄威响若雷奔走，猛涌波如雪卷颠。",
"        穿过瀑布，翻过山坡，远处一座童话城堡出现在眼前，是的，那就是传说中的冰封络丝城堡。？",
"        后半夜，月亮下去了，圣殿郊外，只剩下一片乌蓝的天；沉静的夜空，除了夜游的东西，什么都睡着。 ",
"        是的，这就是络丝城堡，仿佛带着清冽的微笑，单纯得令人神往，冰雪包裹着它，透出几分阴森。 ",
"        纯冰打造的宝座，大殿内寒气逼人，冰封女王络丝高坐在宝座上，冒险之路终将在这里结束。"
}
--关卡结束剧情说明
ch_end_ch = 
{
    ["story_1"] = {"        远远地眺望，草地上有团团白云在蠕动，原来这是牧场的羊群，一只只白生生的，肥壮可爱，使草原更加生机勃勃。", ""},
    ["story_2"] = {"        雪花覆盖的牧场，一片连绵不断的平原，在天空下伸展，没有山丘，像风平浪静的日子里的海一样平静！", ""},
    ["story_3"] = {"        艾泽有一条迷人的小溪，它是那么的美，像一条五彩缤纷的绸带，又像一位婀娜多姿的漂亮姑娘。", ""},
    ["story_4"] = {"        悬崖峭壁之上，云轻拂过身体，像被神仙水净化了一遍，鹰在天空盘旋，真让人羡慕；鹰在天空自在飞翔……", ""},
    ["story_5"] = {"        大森林的枝枝杈杈，挂着一层厚厚的雪花，阳光映照下，像一束束白色的珊瑚，玉洁冰清，玲珑剔透。", ""},
    ["story_6"] = {"        让心灵如湖中之水,深邃方得宁静,宁静方能致远,追寻属于自己的精神世界!这就是传说中的诺森大陆。", ""},
    ["story_7"] = {"        抹抹蓝天反衬着太阳，波光粼粼，小小的光束穿过绿色的重围，点点射出，五光十色，远古冰洞依然这么神秘莫测 ", ""},
    ["story_8"] = {"        沿着水潭往上看，只见一条银白色的链子从天边落下，啊，这不是链子，这是一条银色的瀑布呀！。", ""},
    ["story_9"] = {"        郊外的风景如此美妙啊!远处的城堡，忽而喜,忽而怒，忽而风满天,忽而平静得纹丝不动.", ""},
    ["story_10"] = {"        夜阑人静，月洒清辉，如盘的月影静静地躺在溪底，洁白如玉，晶莹如镜，周围的云彩似乎放射着银色的光芒。", ""},
    ["story_11"] = {"        冰冷的络丝城堡，此时却开满了白色的蔷薇，风中的蔷薇花还带着清冽的微笑，细腻如丝的白色那么轻盈....", ""},
    ["story_12"] = {"        女王络丝终究离开了城堡，冰封的世界开始融化，春天的脚步近了，大地唱着清脆悦耳的歌，向前奔流…… ！", ""}
}
--关卡成功后介绍特殊球
ch_speBubs_ch = 
{
    ["mul"] = {" 你激活了新道具:彩球。", 
            "彩球可以消除所有颜色的球。彩球可以在游戏中发射使用了。 ", 
            "你也可以在增强功能中提高它出现的几率。"},
    ["bomb"] = {" 你激活了新道具:炸弹。", 
            "炸弹可炸毁游戏中大部分类型的球。炸弹可在游戏中发射使用了。", 
            "你也可以在增强功能中提高它出现的几率，和炸毁的威力。"},
    ["steel"] = {" 你解锁了新道具:钢球。", 
            "钢球可以摧毁途经上的所有泡泡，非常强力。您可以通过购买获得。 ", 
            "你也可以在增强功能中提高它摧毁的射程。"},
    ["ice"] = {" 你解锁了新道具:冰球。", 
            "冰球可以冻结游戏中的所有泡泡使之不在下落，冰球可以在游戏中发射使用了。", 
            "你也可以在增强功能中提高它出现的几率和冻结的时间。"},
    ["energy"] = {" 你解锁了新道具:能量。 ", 
            "能量球可以为发射波浪充能，积累6个能量后可以使用一次波浪。 ", 
            "你也可以在增强功能中减少发射波浪所需的能量数。"},
    ["bubV"] = {" 你解锁了新道具:魔化彩球。", 
            "魔法彩球能消除碰触到泡泡的所有同颜色泡泡和木板，您可以通过购买获得。 ", 
            "你也可以在增强功能中提高它的作用范围。"}
}
--其它介绍弹窗
ch_other_ch = 
{
    ["score"] = {"加分球：", "使用后游戏中的每个泡泡消除时额外获得50分数，用来提高你获得的星星数。"},
    ["boss"] = {" BOSS：场景的最终守护者，需要射击多次才可以通过，每次射击到BOSS时，BOSS会做适当的防卫哦。你可以通过观察BOSS上方的HP标识来识别还需要射击到几次。",
                "  "},
    ["key"] = {"关卡钥匙：", "射击到钥匙后即完成关卡，只有获得钥匙才能开启下一个关卡哦。"},
    ["menu"] = {"如果现在退出将会失去1点体力！"}
}
--增强
ch_stre_ch = 
{
    ["stre_1"]  = {"提高彩球的发射出现几率：出现几率翻倍",""},
    ["stre_2"]  = {"提高炸弹的威力：+1圈","提高炸弹的威力：+1圈"},
    ["stre_3"]  = {"提高钢球的摧毁射程：3行","提高钢球的摧毁射程：3行"},
    ["stre_4"]  = {"提高冰球的作用时间：冰冻的时间翻倍","提高冰球的作用时间：冰冻的时间翻倍"},
    ["stre_5"]  = {"提高魔法彩球的威力：+2行","提高魔法彩球的威力：+2行"},
    ["stre_6"]  = {"提高彩虹的推动距离：2行","提高彩虹的推动距离：2行"},
    ["stre_7"]  = {"提高冰球的发射出现几率：出现几率翻倍","提高冰球的发射出现几率：出现几率翻倍"},
    ["stre_8"]  = {"降低本页面所有增强所需要的金币/宝石需求",""},
    ["stre_9"]  = {"提高炸弹的发射出现几率：出现几率翻倍","提高炸弹的发射出现几率：出现几率翻倍"},  
    ["stre_10"] = {"降低彩虹所需要的能量球数：-2个 ","降低彩虹所需要的能量球数：-2个"}
}
--介绍新球英文
ch_new_ch =
{
    ["new_9"]  = {" 被发射的泡泡碰触后，会在周围的空位置上出现带颜色的泡泡。", ""},
    ["new_17"] = {" 被发射的泡泡碰触后，会将周围的普通泡泡染成自己的颜色。", ""},
    ["new_27"] = {" 坚硬的挡板：", "能抵挡住各种发射泡泡，需要炸弹才能击碎它。 "},
    ["new_28"] = {" 无比坚硬的挡板：", "能抵挡各种发射泡泡，炸弹也不能击碎它。"},
    ["new_32"] = {" 被碰触后将随机变身为一种普通泡泡。", ""},
    ["new_35"] = {" 不属于任何一种泡泡，且堆多少都不会消除，只能用道具球销毁掉。", ""},
    ["new_38"] = {" 随机并成对出现的一种泡泡，将途经的发射泡泡传送到另一个位置。", ""},
    ["new_41"] = {" 很危险的泡泡：", "被碰触后将使整个游戏中的泡泡快速下落一段距离。"}
}
--插画对应的介绍球
bossCHIntroBub_ch = 
{
    ["lar_1"]  = {25,"击败场景Boss将激活该道具球 彩球"},
    ["lar_2"]  = {0," Surprise on the next level"},
    ["lar_3"]  = {31,"击败场景Boss将激活该道具球 炸弹"},
    ["lar_4"]  = {0,"Surprise on the next level"},
    ["lar_5"]  = {30,"击败场景Boss将激活该道具球 钢球"},
    ["lar_6"]  = {0,"Surprise on the next level"},
    ["lar_7"]  = {29,"击败场景Boss将激活该道具球 冰球"},
    ["lar_8"]  = {36,"击败场景Boss将获得该道具球 能量"},
    ["lar_9"]  = {26,"击败场景Boss将激活该道具球 魔法彩球"},
    ["lar_10"] = {0,"Surprise on the next level"},
    ["lar_11"] = {0,"Surprise on the next level"},
    ["lar_12"] = {0,"Surprise on the next level"}
}

