--隐藏或显示处理
local function hideOrShowIslands(flag)
    for i = 1, 12 do
        local island = sucLayer:getChildByTag(tagNums["sucLayer"].torch + i)
        if island then
            island:setVisible(flag)
        end
    end
end

--单击选关时的控制按钮
local function isCanTouchSep()
	if sepIsFlag and sepLevTouchFlag and larEndFlag then
		return true
	end
	return false
end

--滑动覆盖层
local function addHDGai()
    local pic = "bgMain4.png"
    if device == "ipad" then pic = "bgMain4_ipad.png"
    elseif device == "iphone5" then pic = "bgMain4_ip5.png"
        end
    local bjSec = CCSprite:create(REPATHBJ..pic)
    bjSec:setPosition(screenWidth / 2, 168)
    sepIsLayer:addChild(bjSec,2)
end

--关卡自动向左滑动效果
local function hdSecSprAct()
    local hd_x, hd_y = hdSecLayer:getPosition()
    hdSecLayer:setPosition(hd_x+ 480, hd_y)
    --cclog("--visi  he--11--")
    hdSecSpr:setVisible(true)
    --cclog("--visi  he--22--")
    -- bubble1.4   当前关默认左边第三个位置 hujian
    local levNums = largeToSmall["lar_"..largeLevel][1]
    local smaSpr = nil
    local tmp = hd_x
    for i = 1, levNums do
        if infoSours["maxLev_"..largeLevel]["finishInfo"][i] == 0 then
            -- CCMessageBox(i,"log:")
            if i >= 4 and i <= levNums then
                
                if i == levNums then
                    tmp = tmp - 105
                else
                    tmp = tmp - (i-3)*105
                end
            end
            smaSpr = hdSecSpr:getChildByTag(tagNums["heSecSpr"].smaLev * largeLevel + i)
            break
        end
    end

    if  infoSours["initGift"] == 1 then
        hdSecLayer:runAction(CCMoveTo:create(0, ccp(tmp, hd_y)))
    else
        hdSecLayer:runAction(CCMoveTo:create(0.5, ccp(tmp, hd_y)))   
    end
    --end

	performWithDelay(0.5, introOnly_storyEnd)

	if largeLevel == 1 and infoSours["maxLev_1"]["finishInfo"][1] == 0 
		and infoSours["x_fresh_every"] == 0 then 
		performWithDelay(0.5, freshAni_everyLev)
        --performWithDelay(0, touchSecSma(366,472))--472
	end
end

--增加背景层
local function addSepLarBJLayer()
    --直接弹出大礼包框
    --myGift()
    sepIsLayer = CCLayer:create()
    local pngbj = "bgMain.jpg"
    if device == "ipad" then pngbj = "bgMain_ipad.jpg"
        elseif device == "iphone5" then pngbj = "bgMain_ip5.jpg"
    end
    local ab = CCSprite:create(REPATHBJ..pngbj)
    ab:setPosition(screenWidth / 2, screenHeight / 2)
    sepIsLayer:addChild(ab)
    --automyGift(sepIsLayer)    
    -- bjSecFG = CCSprite:create(REPATHBJ.."tc_31.png")
    -- bjSecFG:setPosition(screenWidth / 2, screenHeight / 2)
    -- sepIsLayer:addChild(bjSecFG)
    
	sucLayer:addChild(sepIsLayer)
    
end

--增加滑动层
local function addHDSecLevLayer()
    if smaLevHandleId then
        stopSepSche(smaLevHandleId)
    end
    hdSecLayer = CCLayer:create()
    --hdSecSpr = CCSprite:createWithSpriteFrameName("tm.png")
    --hdSecSpr:setPosition(screenWidth / 2, screenHeight / 2)
    hdSecSpr = CCLayer:create()
	hdSecLayer:addChild(hdSecSpr)
    sepIsLayer:addChild(hdSecLayer,1)
    local mostLev = largeToSmall["lar_"..largeLevel][1]
    local pic_pp_Flag = false
    local i_h = 0
    for i = 1, mostLev do
        local pic_pp = "bubble.png"
        if not pic_pp_Flag then
            if infoSours["maxLev_"..largeLevel]["finishInfo"][i] == 0 then
                pic_pp = "bubble.png"
                pic_pp_Flag = true
                i_h = i
            end
        end
        local spr = CCSprite:create(REPATHAN..pic_pp)
        --    hujian
        spr:setPosition(smaPots["bub"..i].x+15, smaPots["bub"..i].y+30)
        hdSecSpr:addChild(spr, 1, tagNums["heSecSpr"].smaLev * largeLevel + i)
		if i > 1 and infoSours["maxLev_"..largeLevel]["finishInfo"][i - 1] == 0 then
			--增加锁
			local lockSpr = CCSprite:create(REPATH.."propLock.png")
			lockSpr:setPosition(120*adrate-42, 30*adrate+20)
			-- lockSpr:setRotation(-75)
			spr:addChild(lockSpr,0,tagNums["heSecSpr"].lock+i)
		end

        --增加关卡数
        local levTmp = getCurLev(i)
        if levTmp > 0 and levTmp < 10 then
            --    hujian
            local ccs1 = CCSprite:createWithSpriteFrameName("sz1_"..levTmp..".png")
            if i_h == i then 
                ccs1:setScale(1)
            end
            ccs1:setScale(1.3)
            ccs1:setPosition(76*adrate-10, 76*adrate-65)
            spr:addChild(ccs1)
        elseif levTmp >= 10 and levTmp < 100 then
            local levTmp1 = scoresPicAll("sz1_", levTmp)
            local xLev = 16*adrate
            for m = 1, #levTmp1 do
                local pic = levTmp1[m]
                local ccs = CCSprite:createWithSpriteFrameName(pic)
                if i_h == i then 
                    ccs:setScale(1)
                end
                ccs:setScale(1.3)
                xLev = xLev + 35*adrate
                ccs:setPosition(xLev-10, 76*adrate-65)
                spr:addChild(ccs)
            end
        else
            local levTmp1 = scoresPicAll("sz1_", levTmp)
            local xLev = -20*adrate
            for m = 1, #levTmp1 do
                local pic = levTmp1[m]
                local ccs = CCSprite:createWithSpriteFrameName(pic)
                if i_h == i then 
                    ccs:setScale(1)
                end
                ccs:setScale(1.3)
                xLev = xLev + 48*adrate
                ccs:setPosition(xLev-10, 76*adrate-65)
                spr:addChild(ccs)
            end            
        end
        local kStarTmp = 0
        if infoSours and infoSours["maxLev_"..largeLevel] and infoSours["maxLev_"..largeLevel]["starNum"] 
            and infoSours["maxLev_"..largeLevel]["starNum"][i] then
            kStarTmp = infoSours["maxLev_"..largeLevel]["starNum"][i]
        end
        
        local starBar = CCSprite:create(REPATHLT.."ct.png")
        starBar:setPosition(smaPots["bub"..i].x, smaPots["bub"..i].y - 80*adrate)
        hdSecSpr:addChild(starBar, 1, tagNums["heSecSpr"].levStar + getCurLev(i))
        --增加星星
        for j = 1, 3 do
            local picStar = "star2.png"
            if kStarTmp >= j then
                picStar = "star1.png"
            end
            local starLast = CCSprite:create(REPATH..picStar)
           
            if j%2 ~= 0 then
                starLast:setPosition(35*adrate + j * 25*adrate+27, 13*adrate+74)
            else
                starLast:setPosition(35*adrate + j * 25*adrate+27, 13*adrate+104)
            end
            local tmp = spr:getChildByTag(tagNums["heSecSpr"].lock+i)
            if tmp then
            else
                starBar:addChild(starLast)
            end
            
        end
    end
    smaLevShakeSche()    
    bottomHD = largeToSmall["lar_"..largeLevel][1] * 110 * adrate
end   

--单一大关卡的可变元素
local function addLAS()
	--文字    --hujian
    local dsSpr = CCSprite:create(REPATHLT.."bTitle_"..largeLevel..".png")
    dsSpr:setPosition(225*adrate+65, 800*adrate-20)
    sepMainUI:addChild(dsSpr)
    
    --插画
    local chSpr = CCSprite:create(REPATHBJ.."chahua_"..largeLevel..".png")
    chSpr:setPosition(215*adrate+65, 560*adrate-10)
    sepMainUI:addChild(chSpr)
    
	-- --boss头像底层
 --    local bossSprDC = CCSprite:createWithSpriteFrameName("boss_ch.png")
 --    bossSprDC:setPosition(larSepPots["boss"..largeLevel].x, larSepPots["boss"..largeLevel].y)
 --    sepMainUI:addChild(bossSprDC)

    -- --boss头像
    -- local bossSpr = CCSprite:createWithSpriteFrameName("boss_"..largeLevel..".png")
    -- bossSpr:setPosition(larSepPots["boss"..largeLevel].x, larSepPots["boss"..largeLevel].y + 15)
    -- sepMainUI:addChild(bossSpr)
    
    local ch_start_tmp = ch_start
    local bossCHIntroBub_tmp = bossCHIntroBub
    local letter_tmp = letter_ttf
    if enviorLanguage == 1 then
        ch_start_tmp = ch_start_ch
        bossCHIntroBub_tmp = bossCHIntroBub_ch
        letter_tmp = head_ttf
    end
    --剧情
    local dialog = CCSprite:create(REPATHAN.."dialog.png")
    dialog:setPosition(215*adrate+65, 560*adrate-195)
    sepMainUI:addChild(dialog)
    local jqSpr =CCLabelTTF:create(ch_start_tmp[largeLevel], letter_tmp, 18)
	local dimenCol = 145
	local label_y = 250
	if bossCHIntroBub_tmp["lar_"..largeLevel][1] == 0 then
		dimenCol = 171
		label_y = 250
	end
	jqSpr:setDimensions(CCSize(390, dimenCol))
    --jqSpr:setHorizontalAlignment(UITextAlignmentLeft)
    --  hujian
    jqSpr:setColor(ccc3(255,255,255))
    -- jqSpr:setPosition(220*adrate, label_y*adrate)
    jqSpr:setPosition(190, 15)
    dialog:addChild(jqSpr)
    
    --球的介绍
	-- local iPicNum = bossCHIntroBub_tmp["lar_"..largeLevel][1]
	-- if iPicNum > 0 then
	-- 	local jsSpr = CCSprite:createWithSpriteFrameName(iPicNum..".png")
	-- 	jsSpr:setScale(0.6)
	-- 	jsSpr:setPosition(115*adrate, 190*adrate)
	-- 	sepMainUI:addChild(jsSpr)
	-- 	local iPicNum = bossCHIntroBub_tmp["lar_"..largeLevel][2]
	-- 	local jsSprCon =CCLabelTTF:create(iPicNum, letter_tmp, 13)
	-- 	jsSprCon:setDimensions(CCSize(104, 37))
	-- 	jsSprCon:setHorizontalAlignment(UITextAlignmentLeft)
 --        --   hujian
	-- 	jsSprCon:setColor(ccc3(52,82,209))
	-- 	jsSprCon:setPosition(207*adrate+10, 190*adrate)
	-- 	sepMainUI:addChild(jsSprCon)
	-- end
    --增加星星比例
    local allStars = getSepLargeAllStars()
    local tmp = scoresPicAll("sz4_", allStars)
    local x = 240*adrate
    if allStars >= 0 and allStars <= 9 then
        x = x + 15*adrate
    end
    for i = 1, #tmp do
        local pic = tmp[i]
        local ccs = CCSprite:createWithSpriteFrameName(pic)
        --local ccs = CCSprite:create(pic)
        x = x + 24*adrate
        ccs:setPosition(x, 760*adrate-40)
        sepMainUI:addChild(ccs)
    end
    
    local xieGang = CCSprite:createWithSpriteFrameName("sz4_xiexian.png")
    xieGang:setPosition(430*adrate-80, 760*adrate-40)
    sepMainUI:addChild(xieGang)
    
    local mostLev = largeToSmall["lar_"..largeLevel][1]
    local tmp1 = scoresPicAll("sz4_", mostLev * 3)
    local x1 = 430*adrate
    if mostLev * 3 >= 0 and mostLev * 3 <= 9 then
        x1 = x1 + 15*adrate
    end
    for i = 1, #tmp1 do
        local pic = tmp1[i]
        local ccs = CCSprite:createWithSpriteFrameName(pic)
        --local ccs = CCSprite:create(pic)
        x1 = x1 + 24*adrate
        ccs:setPosition(x1-80, 760*adrate-40)
        sepMainUI:addChild(ccs)
    end

    local star = CCSprite:create(REPATH.."star1.png")
    star:setPosition(430*adrate-25, 760*adrate-40)
    sepMainUI:addChild(star)
end
 
--处理
local function addSepUI() 
    local bossCHIntroBub_tmp = bossCHIntroBub
    if enviorLanguage == 1 then
        bossCHIntroBub_tmp = bossCHIntroBub_ch
    end
	local pic_tc = "tc_21_1.png"
	if bossCHIntroBub_tmp["lar_"..largeLevel][1] == 0 then
		pic_tc = "tc_21_1.png"
	end
    local gray = CCSprite:create(REPATHBJ.."menghui.png")
    gray:setPosition(screenWidth/2,screenHeight/2)
    sepIsLayer:addChild(gray)
    sepMainUI = CCSprite:create(REPATHBJ..pic_tc)
    sepMainUI:setPosition(screenWidth / 2, screenHeight / 2)
    sepIsLayer:addChild(sepMainUI)
    --单一大关卡的可变元素
    addLAS()        
    local sepLevBack= CCMenuItemImage:create(REPATHAN.."cha1.png", REPATHAN.."cha2.png")
	sepLevBack:registerScriptHandler(jumpToIsland12Layer)
	local sepLevMenuBack = CCMenu:createWithItem(sepLevBack)
	sepLevMenuBack:setPosition(586*adrate+5, 785*adrate-20)
    sepMainUI:addChild(sepLevMenuBack)
end

function gotoPlayMidFB()
    fb_sep_time = os.time()
    local flag = true
    while flag do
        cclog("--gotoPlayMidFB--fb_friend_head_start = "..fb_friend_head_start..", fb_friend_head_end = "..fb_friend_head_end.." = "..os.time())
        if fb_friend_head_start == fb_friend_head_end or (os.time() - fb_sep_time) > 15 then
            flag = false
            if fb_friend_head_start >= 3 then
                performWithDelay(2, gotoPlayMid)
            else
                performWithDelay(0.5, gotoPlayMid)
            end
        end
    end
end

function gotoPlayMid()
    --cclog("------11---")
    showLoading(false)
    sepLevTouchFlag = true
    gotoPlay(cur_LevNum)
    --cclog("------22---")
    if largeLevel == 4 and cur_LevNum == 5 and infoSours["x_intro_score"] == 0 and isPassSmallLev(cur_LevNum) then
		performWithDelay(0.3, intro_score)
	end
end

--单击选择小关卡
function touchSecSma(x, y)
    local xt = x
    local yt = y
    local suc_x, suc_y = hdSecLayer:getPosition()
    local mostLev = largeToSmall["lar_"..largeLevel][1]
	for i = 1, mostLev do
        local i1_xa = suc_x + smaPots["bub"..i].x - smaPots.touch_x
		local i1_xb = suc_x + smaPots["bub"..i].x + smaPots.touch_x
		local i1_ya = suc_y + smaPots["bub"..i].y + smaPots.touch_y
		local i1_yb = suc_y + smaPots["bub"..i].y - smaPots.touch_y
        --cclog("xt  = "..xt..",yt="..yt..",i1_xa="..i1_xa..",i1_xb="..i1_xb..",i1_ya="..i1_ya..",i1_yb="..i1_yb..",i="..i)
		if (xt >= i1_xa and xt <= i1_xb) and (yt <= i1_ya and yt >= i1_yb) and sepIsFlag and larEndFlag then
            local j_umeng_sublevelclick = json_umeng_sublevelClick(largeLevel,i)
            umengEntry(gJSON:encode(j_umeng_sublevelclick))
            if not isCanTouchSep() then
                soundMenuUnable()
            end
            
            if infoSours["x_facebook_flag"] == 1 then
                headFriends = {}
                sortSepLevScore(i, "sep")
            end
			if largeLevel == 1 and i == 1 and infoSours["x_fresh_every"] == 0 then
				infoSours["x_fresh_every"] = 1
                if hdSecSpr:getChildByTag(tagNums["hdSecSpr"].fresh_every) then
                    hdSecSpr:removeChildByTag(tagNums["hdSecSpr"].fresh_every)
                    local j_umeng_freshclick2 = json_umeng_freshclick2(largeLevel,cur_LevNum)
                     umengEntry(gJSON:encode(j_umeng_freshclick2))
                end
				saveInfoSep()
			end
			sepLevTouchFlag = false
            stopSepSche(smaLevHandleId)
            cur_LevNum = i
			local smaSpr = hdSecSpr:getChildByTag(tagNums["heSecSpr"].smaLev * largeLevel + i)
            if smaSpr then
                local arr = CCArray:create()
                arr:addObject(CCScaleTo:create(0.2, 1.5))
                arr:addObject(CCScaleTo:create(0.15, 1))
                local seq = CCSequence:create(arr)
                smaSpr:runAction(seq)
            end
            if infoSours["x_facebook_flag"] == 1 then
                showLoading(true)
                performWithDelay(2, gotoPlayMidFB)
            else
                performWithDelay(0.3, gotoPlayMid)
            end
		end
	end
	return false
end

--缩小按钮
function jumpToIsland12Layer()
    if sepIsLayer and tcFlag then
        soundMenu1()
        sepIsLayer:stopAllActions()
        sucLayer:removeChild(sepIsLayer)
        --sepIsLayer = nil
        sepIsFlag = false
        tcFlag = true
        resetIsFlag()
        larLevShakeSche()
        stopSepSche(smaLevHandleId)
	else
		soundMenuUnable()
    end
end

--进入选定的关卡
function gotoPlay(k)
    stopSepSche(larLevHandleId)
    stopSepSche(smaLevHandleId)
    if isPassSmallLev(k) and tcFlag then
        soundMenu1()
        local mostLev = largeToSmall["lar_"..largeLevel][1]
        local re_tmp = getCurLev(k)
        cur_LevNum = k
        retryLev = re_tmp
        if sepIsLayer then
            --cclog("------11 visible-----")
            sepIsLayer:setVisible(false)
            --cclog("------22 visible-----")
        end
        sepIsFlag = false

        initLevMenu()

    else
        soundMenuUnable()
    end
end

--获得当前的retryLev
function getCurLev(k)
    local re_tmp = 0
    for i = 1, largeLevel - 1 do
        re_tmp = re_tmp + largeToSmall["lar_"..i][1]
    end
    re_tmp = re_tmp + k
    
    return re_tmp
end

--下一关入口
function islandSepEntry()
    larLevTouchFlag = true
    sepIsFlag = true
    clearMemory()
    if sucLayer and sepIsLayer then
        sucLayer:removeChild(sepIsLayer)
        sepIsLayer = nil
    end
    addSepLarBJLayer()   
    addSepUI()    
    addHDSecLevLayer()  --滑动层
    addHDGai()

    secTouch_single()
    
    if not menuFlag then
        sepMainUI:setScale(0.5)
        -- bjSecFG:setScale(0.5)
        sepMainUI:runAction(CCScaleTo:create(0.3, 1))
        -- bjSecFG:runAction(CCScaleTo:create(0.3, 1))
        if hdSecSpr then
             --cclog("--visi  he--33--")
            hdSecSpr:setVisible(false)
             --cclog("--visi  he--44--")
        end
        performWithDelay(0.3, hdSecSprAct)
    end
end
