--------------------------------------------------------------------------
-- 版权所有:    (C)2012, Soul Game

-- 文件名称:    Network.lua
-- 文件标识:   
-- 内容摘要:    网络
-- 其它说明:
-- 当前版本:    0.1
-- 作    者:    AlohaWu
-- 完成日期:    10:54 2012-8-14
------------------------------------------
--local json = require("json")
local network={count=1,netrecv={}}
local networkDebug = true
function GameNetworkRecv(status,tag,data)
    cclog("----status = "..status..",tag = "..tag..",data = "..data)
    --cclogtab({status=status,tag=tag,data=data})
    --cclog("GameNetworkRecv"..data or "")
    --local f = io.open("debug.log","a+")
    --f:write(string.format("%s",data))
    --f:write("\n")
    --f:flush()
    --f:close()
	local t
	for k,v in ipairs(network.netrecv) do
        if v.tag == tag then
            t = table.remove(network.netrecv,k)
            break
        end
    end
    if status ~= 200 then
        --CCMessageBox("无网络连接"..status,"网络错误")
        --return
    end
    --错误信息
    local idex = string.find(data,"err=")
    if idex then
        local txt = string.sub(data,string.len("err=")+1,-1)
        Tips(nil,txt) 
        return 
    end
    -- 更新客户端脚本
    local function onComplete()
        -- status judge
        if loadingProcessTimer then
            loadingProcessTimer= nil
        end
        local idex = string.find(data,"lua=")
        if idex then
            local luaStr = string.sub(data,string.len("lua=")+1,-1)
            loadstring(luaStr)()
            return 
        end
          
        --正常返回
        if t then
            t.callback(data)
        else
            cclog("network error,tag:"..tag)
        end    
    end
    local args={
        time= 1,
        onComplete=onComplete
    }
    if loadingProcessTimer then cclog("loading ActionCallback")
        ActionCallback(loadingProcessTimer,CCProgressTo:create(1, 100),args)
    else
        onComplete()
    end
    if networkDebug then
        for k,v in ipairs(network.netrecv) do
            --cclog("networkdeug :"..k)
--            cclogtab(v)
        end
    end
end

function NetTag(callback)
    local count = network.count+1
    network.count = count
    local tag = "tag"..count
    table.insert(network.netrecv,{tag=tag,callback=callback})
    return tag
end

local function HttpRawLua(url,method,data,tag,isui, fb_id)
    if not isui then --不应有界面情况
        local winSize = CCDirector:sharedDirector():getWinSize()--DirectorGetWinSize()
        local networkScene = CCDirector:sharedDirector():getRunningScene()
        local isLoad = true
        if not networkScene then
            isLoad = false
            networkScene = CCScene:create()
        end
        networkLayer = CCLayer:create() --全局目的关卡中去掉该层播放战斗过程
        local networkbg = CCSprite:create(RESPATH.."UI/networkbg1.png")
        loadingProcessTimer = CCProgressTimer:create(CCSprite:create(RESPATH.."UI/loading.png"))
        loadingProcessTimer:setType(kCCProgressTimerTypeBar);
    	loadingProcessTimer:setMidpoint(CCPoint(0, 1));
    	loadingProcessTimer:setBarChangeRate(CCPoint(1, 0));
        loadingProcessTimer:setPercentage(0);
        networkbg:setPosition(winSize.width/2,winSize.height/2)
        loadingProcessTimer:setPosition(winSize.width/2,100)
        networkLayer:addChild(networkbg)
        networkLayer:addChild(loadingProcessTimer)
        networkScene:addChild(networkLayer)
        if not isLoad then
            RunWithScene(networkScene)
        end
        ActionCallback(loadingProcessTimer,CCProgressTo:create(0.5, 30),{
            time = 0.5,
            onComplete=function()
                if loadingProcessTimer then
                    loadingProcessTimer:setPercentage(30)
                end
            end
        })
    end
    HttpRaw(url,method,data,GameNetworkRecv,tag,fb_id)
end

function HttpGet(url,callback,isui, fb_id)
    local tag = NetTag(callback)
	HttpRawLua(url,"GET",nil,tag,isui, fb_id)
end

function HttpPost(url,data,callback,isui)
    local tag = NetTag(callback)
	HttpRawLua(url,"POST",data,tag,isui,"")
end

---why--2013.01.22--
local function HttpRawLua_why(url, method, data, tag, fb_id, sgFlag, type)	
    if sgFlag == "save" then
        HttpSaveAll(url, method, data, GameNetworkRecv, tag, fb_id, type)
    elseif sgFlag == "get" then
        HttpGetAll(url, method, data, GameNetworkRecv, tag, fb_id, type)
    elseif sgFlag == "down" then
        HttpRaw(url, method, data, GameNetworkRecv, tag, fb_id, type)
    end
end

function HttpGet_why(url, callback, fb_id, sgFlag, type)
    local tag = NetTag(callback)
	HttpRawLua_why(url, "GET", nil, tag, fb_id, sgFlag, type)
end

function HttpPost_why(url, data, callback, sgFlag)
    local tag = NetTag(callback)
	HttpRawLua_why(url, "POST", data, tag, "", sgFlag, "")
end


