local m = getStrengthEveryData(strengthSeq.mulRate)
local b = getStrengthEveryData(strengthSeq.bombRate)
local s = getStrengthEveryData(strengthSeq.iceRate)

srb1 = 
{
    ["base1"] = {85 - m, 90 - m, 91 - m, 92 - m, 94 - m}, 
    ["mul1"]  = {15 + m, 10 + m, 9 + m, 8 + m, 6 + m}, 

    ["base2"] = {86 - m - b, 90 - m - b, 91 - m - b, 92 - m - b, 93 - m - b}, 
    ["mul2"]  = {14 + m,     8 + m,      7 + m,      6 + m,      5 + m}, 
    ["bomb2"] = {0 + b,      2 + b,      2 + b,      2 + b,      2 + b}, 

    ["base3"] = {86 - m - b - s, 90 - m - b - s, 90.8 - m - b - s, 91.8 - m - b - s, 91.8 - m - b - s}, 
    ["mul3"]  = {14 + m,         8 + m,          6 + m,            5 + m,            5 + m}, 
    ["bomb3"] = {0 + b,          2 + b,          2 + b,            2 + b,            2 + b}, 
    ["steel3"] = {0 + s,         0 + s,          1.2 + s,          1.2 + s,          1.2 + s}, 

    ["base4"] = {90 - m - b - s, 90 - m - b - s, 90.5 - m - b - s, 91.5 - m - b - s, 91.5 - m - b - s}, 
    ["mul4"]  = {10 + m,         8 + m,          5 + m,            4 + m,            4 + m}, 
    ["bomb4"] = {0 + b,          2 + b,          2 + b,            2 + b,            2 + b}, 
    ["steel4"] = {0 + s,         0 + s,          1.2 + s,          1.2 + s,          1.2 + s}, 
    ["ice4"] = {0,               0,   	         1.3,              1.3,              1.3}, 

    ["base5"] = {84 - m - b - s, 85 - m - b - s, 84 - m - b - s, 85 - m - b - s, 86 - m - b - s}, 
    ["mul5"] = {10 + m,          7 + m,          5 + m,          4 + m,          3 + m}, 
    ["bomb5"] = {0 + b,          2 + b,          2 + b,          2 + b,          2 + b}, 
    ["steel5"] = {0 + s,         0 + s,          1.2 + s,        1.2 + s,        1.2 + s}, 
    ["ice5"] = {0,               0,              1.5,            1.3,            1.3}, 
    ["blank5"] = {6,             6,              6.5,            6.5,            6.5}, 

    ["base6"] = {85 - m - b - s, 86 - m - b - s, 83 - m - b - s, 84 - m - b - s, 85 - m - b - s}, 
    ["mul6"] = {10 + m,          7 + m,          5 + m,          4 + m,           3 + m}, 
    ["bomb6"] = {0 + b,          2 + b,          2 + b,          2 + b,           2 + b}, 
    ["steel6"] = {0 + s,         0 + s,          1.2 + s,        1.2 + s,         1.2 + s}, 
    ["ice6"] = {0,               0,              1.3,            1.3,             1.3},  	
    ["blank6"] = {5,             5,              6.5,            6.5,             6.5}, 
    ["v6"] = {0,                 0,              1,              1,               1}, 
    num = 100, 
    delay = 50
}

srb2 = 
{
    ["base1"] = {85 - m, 90 - m, 91 - m, 92 - m, 80 - m}, 
    ["mul1"]  = {15 + m, 10 + m, 9 + m, 8 + m, 20 + m}, 

    ["base2"] = {86 - m - b, 90 - m - b, 92 - m - b, 82 - m - b, 80 - m - b}, 
    ["mul2"]  = {14 + m,     8 + m,      6 + m,      12 + m,     14 + m}, 
    ["bomb2"] = {0 + b,      2 + b,      2 + b,      6 + b,      6 + b}, 

    ["base3"] = {86 - m - b - s, 90 - m - b - s, 91 - m - b - s, 92 - m - b - s, 92 - m - b - s}, 
    ["mul3"]  = {14 + m,         8 + m,          6 + m,          5 + m,          5 + m}, 
    ["bomb3"] = {0 + b,          2 + b,          2 + b,          2 + b,          2 + b}, 
    ["steel3"] = {0 + s,         0 + s,          1 + s,          1 + s,          1 + s}, 

    ["base4"] = {90 - m - b - s, 90 - m - b - s, 91 - m - b - s, 92 - m - b - s, 92 - m - b - s}, 
    ["mul4"]  = {10 + m,         8 + m,          5 + m,          4 + m,          4 + m}, 
    ["bomb4"] = {0 + b,          2 + b,          2 + b,          2 + b,          2 + b}, 
    ["steel4"] = {0 + s,         0 + s,          1 + s,          1 + s,          1 + s}, 
    ["ice4"] = {0,               0,              1,              1,              1}, 

    ["base5"] = {84 - m - b - s, 85 - m - b - s, 85 - m - b - s, 85 - m - b - s, 86 - m - b - s}, 
    ["mul5"] = {10 + m,          7 + m,          5 + m,          4 + m,          3 + m}, 
    ["bomb5"] = {0 + b,          2 + b,          2 + b,          2 + b,          2 + b}, 
    ["steel5"] = {0 + s,         0 + s,          1 + s,          1 + s,          1 + s}, 
    ["ice5"] = {0,               0,              0,              1,              1}, 
    ["blank5"] = {6,             6,              7,              7,              7}, 

    ["base6"] = {84 - m - b - s, 85 - m - b - s, 84 - m - b - s, 84 - m - b - s, 84 - m - b - s}, 
    ["mul6"] = {10 + m,          7 + m,          5 + m,          4 + m,          4 + m}, 
    ["bomb6"] = {0 + b,          2 + b,          2 + b,          2 + b,          2 + b}, 
    ["steel6"] = {0 + s,         0 + s,          1 + s,          1 + s,          1 + s}, 
    ["ice6"] = {0,               0,              0,              1,              1}, 
    ["blank6"] = {6,             6,              7,              7,              7}, 
    ["v6"] = {0,                 0,              1,              1,              1}, 
    num = 100, 
    delay = 50
}


srb3 = 
{
    ["base1"] = {85 - m, 90 - m, 91 - m, 82 - m, 80 - m}, 
    ["mul1"]  = {15 + m, 10 + m, 9 + m, 18 + m, 20 + m}, 

    ["base2"] = {86 - m - b, 90 - m - b, 91 - m - b, 82 - m - b, 80 - m - b}, 
    ["mul2"]  = {14 + m, 8 + m, 6 + m, 12 + m, 12 + m}, 
    ["bomb2"] = {0 + b, 2 + b, 3 + b, 6 + b, 8 + b}, 

    ["base3"] = {86 - m - b - s, 90 - m - b - s, 91 - m - b - s, 80 - m - b - s, 80 - m - b - s}, 
    ["mul3"]  = {14 + m,         8 + m,          6 + m,          12 + m,         11 + m}, 
    ["bomb3"] = {0 + b,          2 + b,          2 + b,          6 + b,          6 + b}, 
    ["steel3"] = {0 + s,         0 + s,          1 + s,          2 + s,          3 + s}, 

    ["base4"] = {90 - m - b - s, 90 - m - b - s, 91 - m - b - s, 82 - m - b - s, 80 - m - b - s}, 
    ["mul4"]  = {10 + m,         8 + m,          5 + m,          9 + m,          10 + m}, 
    ["bomb4"] = {0 + b,          2 + b,          2 + b,          5 + b,          5 + b}, 
    ["steel4"] = {0 + s,         0 + s,          1 + s,          2 + s,          3 + s}, 
    ["ice4"] = {0,               0,              1,              2,              2}, 

    ["base5"] = {84 - m - b - s, 85 - m - b - s, 77 - m - b - s, 74 - m - b - s, 73 - m - b - s}, 
    ["mul5"] = {10 + m,          7 + m,          9 + m,          10 + m,         10 + m}, 
    ["bomb5"] = {0 + b,          2 + b,          5 + b,          5 + b,          5 + b}, 
    ["steel5"] = {0 + s,         0 + s,          2 + s,          2 + s,          3 + s}, 
    ["ice5"] = {0,               0,              0,              2,              2}, 
    ["blank5"] = {6,             6,              7,              7,              7}, 

    ["base6"] = {84 - m - b - s, 85 - m - b - s, 76 - m - b - s, 73 - m - b - s, 73 - m - b - s}, 
    ["mul6"] = {10 + m,          7 + m,          8 + m,          9 + m,          9 + m}, 
    ["bomb6"] = {0 + b,          2 + b,          5 + b,          5 + b,          5 + b}, 
    ["steel6"] = {0 + s,         0 + s,          2 + s,          2 + s,          2 + s}, 
    ["ice6"] = {0,               0,              1,              2,              2}, 
    ["blank6"] = {6,             6,              7,              7,              7}, 
    ["v6"] = {0,                 0,              1,              2,              2}, 
    num = 100, 
    delay = 50
}

shootComBall = {}
shootSpeBall = {}
shootSpeBall1 = {25}
shootSpeBall2 = {25, 31}
shootSpeBall3 = {25, 31, 25}
shootSpeBall4 = {25, 31, 25, 29}
shootSpeBall5 = {25, 31, 25, 29, 35}
shootSpeBall6 = {25, 31, 25, 29, 35, 25}

shootTableAlls_up1 = {
["shootRate1_2"] = {
                    srb1["base1"][1] * srb1.num, 
                    (srb1["base1"][1]  +  srb1["mul1"][1]) * srb1.num
                 }, 
["shootRate1_3"] = {
                    srb1["base1"][2] / 2 * srb1.num, 
                    srb1["base1"][2] * srb1.num, 
                    (srb1["base1"][2]  +  srb1["mul1"][2]) * srb1.num
                 }, 
["shootRate1_4"] = {
                    srb1["base1"][3] / 3 * srb1.num, 
                    srb1["base1"][3] * 2 / 3 * srb1.num, 
                    srb1["base1"][3] * srb1.num, 
                    (srb1["base1"][3]  +  srb1["mul1"][3]) * srb1.num
                 }, 
["shootRate1_5"] = {
                    srb1["base1"][4] / 4 * srb1.num, 
                    srb1["base1"][4] * 2 / 4 * srb1.num, 
                    srb1["base1"][4] * 3 / 4 * srb1.num, 
                    srb1["base1"][4] * srb1.num, 
                    (srb1["base1"][4]  +  srb1["mul1"][4]) * srb1.num
                 }, 
["shootRate1_6"] = {
                    srb1["base1"][5] / 5 * srb1.num, 
                    srb1["base1"][5] * 2 / 5 * srb1.num, 
                    srb1["base1"][5] * 3 / 5 * srb1.num, 
                    srb1["base1"][5] * 4 / 5 * srb1.num, 
                    srb1["base1"][5] * srb1.num, 
                    (srb1["base1"][5]  +  srb1["mul1"][5]) * srb1.num
                 }, 
["shootRate2_3"] = {
                    srb1["base2"][1] * srb1.num, 
                    (srb1["base2"][1]  +  srb1["mul2"][1]) * srb1.num, 
                    (srb1["base2"][1]  +  srb1["mul2"][1]  +  srb1["bomb2"][1]) * srb1.num
                 }, 
["shootRate2_4"] = {
                    srb1["base2"][2] / 2 * srb1.num, 
                    srb1["base2"][2] * srb1.num, 
                    (srb1["base2"][2]  +  srb1["mul2"][2]) * srb1.num, 
                    (srb1["base2"][2]  +  srb1["mul2"][2]  +  srb1["bomb2"][2]) * srb1.num
                 }, 
["shootRate2_5"] = {
                    srb1["base2"][3] / 3 * srb1.num, 
                    srb1["base2"][3] * 2 / 3 * srb1.num, 
                    srb1["base2"][3] * srb1.num, 
                    (srb1["base2"][3]  +  srb1["mul2"][3]) * srb1.num, 
                    (srb1["base2"][3]  +  srb1["mul2"][3]  +  srb1["bomb2"][3]) * srb1.num
                 }, 
["shootRate2_6"] = {
                    srb1["base2"][4] / 4 * srb1.num, 
                    srb1["base2"][4] * 2 / 4 * srb1.num, 
                    srb1["base2"][4] * 3 / 4 * srb1.num, 
                    srb1["base2"][4] * srb1.num, 
                    (srb1["base2"][4]  +  srb1["mul2"][4]) * srb1.num, 
                    (srb1["base2"][4]  +  srb1["mul2"][4]  +  srb1["bomb2"][4]) * srb1.num
                 }, 
["shootRate2_7"] = {
                    srb1["base2"][5] / 5 * srb1.num, 
                    srb1["base2"][5] * 2 / 5 * srb1.num, 
                    srb1["base2"][5] * 3 / 5 * srb1.num, 
                    srb1["base2"][5] * 4 / 5 * srb1.num, 
                    srb1["base2"][5] * srb1.num, 
                    (srb1["base2"][5]  +  srb1["mul2"][5]) * srb1.num, 
                    (srb1["base2"][5]  +  srb1["mul2"][5]  +  srb1["bomb2"][5]) * srb1.num
                 }, 
["shootRate3_4"] = {
                    srb1["base3"][1] * srb1.num, 
                    (srb1["base3"][1]  +  srb1["mul3"][1]) * srb1.num, 
                    (srb1["base3"][1]  +  srb1["mul3"][1]  +  srb1["bomb3"][1]) * srb1.num, 
                    (srb1["base3"][1]  +  srb1["mul3"][1]  +  srb1["bomb3"][1]  +  srb1["steel3"][1]) * srb1.num
                 }, 
["shootRate3_5"] = {
                    srb1["base3"][2] / 2 * srb1.num, 
                    srb1["base3"][2] * srb1.num, 
                    (srb1["base3"][2]  +  srb1["mul3"][2]) * srb1.num, 
                    (srb1["base3"][2]  +  srb1["mul3"][2]  +  srb1["bomb3"][2]) * srb1.num, 
                    (srb1["base3"][2]  +  srb1["mul3"][2]  +  srb1["bomb3"][2]  +  srb1["steel3"][2]) * srb1.num
                 }, 
["shootRate3_6"] = {
                    srb1["base3"][3] / 3 * srb1.num, 
                    srb1["base3"][3] * 2 / 3 * srb1.num, 
                    srb1["base3"][3] * srb1.num, 
                    (srb1["base3"][3]  +  srb1["mul3"][3]) * srb1.num, 
                    (srb1["base3"][3]  +  srb1["mul3"][3]  +  srb1["bomb3"][3]) * srb1.num, 
                    (srb1["base3"][3]  +  srb1["mul3"][3]  +  srb1["bomb3"][3]  +  srb1["steel3"][3]) * srb1.num
                 }, 
["shootRate3_7"] = {
                    srb1["base3"][4] / 4 * srb1.num, 
                    srb1["base3"][4] * 2 / 4 * srb1.num, 
                    srb1["base3"][4] * 3 / 4 * srb1.num, 
                    srb1["base3"][4] * srb1.num, 
                    (srb1["base3"][4]  +  srb1["mul3"][4]) * srb1.num, 
                    (srb1["base3"][4]  +  srb1["mul3"][4]  +  srb1["bomb3"][4]) * srb1.num, 
                    (srb1["base3"][4]  +  srb1["mul3"][4]  +  srb1["bomb3"][4]  +  srb1["steel3"][4]) * srb1.num
                 }, 
["shootRate3_8"] = {
                    srb1["base3"][5] / 5 * srb1.num, 
                    srb1["base3"][5] * 2 / 5 * srb1.num, 
                    srb1["base3"][5] * 3 / 5 * srb1.num, 
                    srb1["base3"][5] * 4 / 5 * srb1.num, 
                    srb1["base3"][5] * srb1.num, 
                    (srb1["base3"][5]  +  srb1["mul3"][5]) * srb1.num, 
                    (srb1["base3"][5]  +  srb1["mul3"][5]  +  srb1["bomb3"][5]) * srb1.num, 
                    (srb1["base3"][5]  +  srb1["mul3"][5]  +  srb1["bomb3"][5]  +  srb1["steel3"][5]) * srb1.num
                 }, 
["shootRate4_5"] = {
                    srb1["base4"][1] * srb1.num, 
                    (srb1["base4"][1]  +  srb1["mul4"][1]) * srb1.num, 
                    (srb1["base4"][1]  +  srb1["mul4"][1]  +  srb1["bomb4"][1]) * srb1.num, 
                    (srb1["base4"][1]  +  srb1["mul4"][1]  +  srb1["bomb4"][1]  +  srb1["steel4"][1]) * srb1.num, 
                    (srb1["base4"][1]  +  srb1["mul4"][1]  +  srb1["bomb4"][1]  +  srb1["steel4"][1]  +  srb1["ice4"][1]) * srb1.num
                 }, 
["shootRate4_6"] = {
                    srb1["base4"][2] / 2 * srb1.num, 
                    srb1["base4"][2] * srb1.num, 
                    (srb1["base4"][2]  +  srb1["mul4"][2]) * srb1.num, 
                    (srb1["base4"][2]  +  srb1["mul4"][2]  +  srb1["bomb4"][2]) * srb1.num, 
                    (srb1["base4"][2]  +  srb1["mul4"][2]  +  srb1["bomb4"][2]  +  srb1["steel4"][2]) * srb1.num, 
                    (srb1["base4"][2]  +  srb1["mul4"][2]  +  srb1["bomb4"][2]  +  srb1["steel4"][2]  +  srb1["ice4"][2]) * srb1.num
                 }, 
["shootRate4_7"] = {
                    srb1["base4"][3] / 3 * srb1.num, 
                    srb1["base4"][3] * 2 / 3 * srb1.num, 
                    srb1["base4"][3] * srb1.num, 
                    (srb1["base4"][3]  +  srb1["mul4"][3]) * srb1.num, 
                    (srb1["base4"][3]  +  srb1["mul4"][3]  +  srb1["bomb4"][3]) * srb1.num, 
                    (srb1["base4"][3]  +  srb1["mul4"][3]  +  srb1["bomb4"][3]  +  srb1["steel4"][3]) * srb1.num, 
                    (srb1["base4"][3]  +  srb1["mul4"][3]  +  srb1["bomb4"][3]  +  srb1["steel4"][3]  +  srb1["ice4"][3]) * srb1.num
                 }, 
["shootRate4_8"] = {
                    srb1["base4"][4] / 4 * srb1.num, 
                    srb1["base4"][4] * 2 / 4 * srb1.num, 
                    srb1["base4"][4] * 3 / 4 * srb1.num, 
                    srb1["base4"][4] * srb1.num, 
                    (srb1["base4"][4]  +  srb1["mul4"][4]) * srb1.num, 
                    (srb1["base4"][4]  +  srb1["mul4"][4]  +  srb1["bomb4"][4]) * srb1.num, 
                    (srb1["base4"][4]  +  srb1["mul4"][4]  +  srb1["bomb4"][4]  +  srb1["steel4"][4]) * srb1.num, 
                    (srb1["base4"][4]  +  srb1["mul4"][4]  +  srb1["bomb4"][4]  +  srb1["steel4"][4]  +  srb1["ice4"][4]) * srb1.num
                 }, 
["shootRate4_9"] = {
                    srb1["base4"][5] / 5 * srb1.num, 
                    srb1["base4"][5] * 2 / 5 * srb1.num, 
                    srb1["base4"][5] * 3 / 5 * srb1.num, 
                    srb1["base4"][5] * 4 / 5 * srb1.num, 
                    srb1["base4"][5] * srb1.num, 
                    (srb1["base4"][5]  +  srb1["mul4"][5]) * srb1.num, 
                    (srb1["base4"][5]  +  srb1["mul4"][5]  +  srb1["bomb4"][5]) * srb1.num, 
                    (srb1["base4"][5]  +  srb1["mul4"][5]  +  srb1["bomb4"][5]  +  srb1["steel4"][5]) * srb1.num, 
                    (srb1["base4"][5]  +  srb1["mul4"][5]  +  srb1["bomb4"][5]  +  srb1["steel4"][5]  +  srb1["ice4"][4]) * srb1.num
                 }, 
["shootRate5_6"] = {
                    srb1["base5"][1] * srb1.num, 
                    (srb1["base5"][1]  +  srb1["mul5"][1]) * srb1.num, 
                    (srb1["base5"][1]  +  srb1["mul5"][1]  +  srb1["bomb5"][1]) * srb1.num, 
                    (srb1["base5"][1]  +  srb1["mul5"][1]  +  srb1["bomb5"][1]  +  srb1["steel5"][1]) * srb1.num, 
                    (srb1["base5"][1]  +  srb1["mul5"][1]  +  srb1["bomb5"][1]  +  srb1["steel5"][1]  +  srb1["ice5"][1]) * srb1.num, 
                    (srb1["base5"][1]  +  srb1["mul5"][1]  +  srb1["bomb5"][1]  +  srb1["steel5"][1]  +  srb1["ice5"][1]  +  srb1["blank5"][1]) * srb1.num
                 }, 
["shootRate5_7"] = {
                    srb1["base5"][2] / 2 * srb1.num, 
                    srb1["base5"][2] * srb1.num, 
                    (srb1["base5"][2]  +  srb1["mul5"][2]) * srb1.num, 
                    (srb1["base5"][2]  +  srb1["mul5"][2]  +  srb1["bomb5"][2]) * srb1.num, 
                    (srb1["base5"][2]  +  srb1["mul5"][2]  +  srb1["bomb5"][2]  +  srb1["steel5"][2]) * srb1.num, 
                    (srb1["base5"][2]  +  srb1["mul5"][2]  +  srb1["bomb5"][2]  +  srb1["steel5"][2]  +  srb1["ice5"][2]) * srb1.num, 
                    (srb1["base5"][2]  +  srb1["mul5"][2]  +  srb1["bomb5"][2]  +  srb1["steel5"][2]  +  srb1["ice5"][2]  +  srb1["blank5"][2]) * srb1.num
                 }, 
["shootRate5_8"] = {
                    srb1["base5"][3] / 3 * srb1.num, 
                    srb1["base5"][3] * 2 / 3 * srb1.num, 
                    srb1["base5"][3] * srb1.num, 
                    (srb1["base5"][3]  +  srb1["mul5"][3]) * srb1.num, 
                    (srb1["base5"][3]  +  srb1["mul5"][3]  +  srb1["bomb5"][3]) * srb1.num, 
                    (srb1["base5"][3]  +  srb1["mul5"][3]  +  srb1["bomb5"][3]  +  srb1["steel5"][3]) * srb1.num, 
                    (srb1["base5"][3]  +  srb1["mul5"][3]  +  srb1["bomb5"][3]  +  srb1["steel5"][3]  +  srb1["ice5"][3]) * srb1.num, 
                    (srb1["base5"][3]  +  srb1["mul5"][3]  +  srb1["bomb5"][3]  +  srb1["steel5"][3]  +  srb1["ice5"][3]  +  srb1["blank5"][3]) * srb1.num
                 }, 
["shootRate5_9"] = {
                    srb1["base5"][4] / 4 * srb1.num, 
                    srb1["base5"][4] * 2 / 4 * srb1.num, 
                    srb1["base5"][4] * 3 / 4 * srb1.num, 
                    srb1["base5"][4] * srb1.num, 
                    (srb1["base5"][4]  +  srb1["mul5"][4]) * srb1.num, 
                    (srb1["base5"][4]  +  srb1["mul5"][4]  +  srb1["bomb5"][4]) * srb1.num, 
                    (srb1["base5"][4]  +  srb1["mul5"][4]  +  srb1["bomb5"][4]  +  srb1["steel5"][4]) * srb1.num, 
                    (srb1["base5"][4]  +  srb1["mul5"][4]  +  srb1["bomb5"][4]  +  srb1["steel5"][4]  +  srb1["ice5"][4]) * srb1.num, 
                    (srb1["base5"][4]  +  srb1["mul5"][4]  +  srb1["bomb5"][4]  +  srb1["steel5"][4]  +  srb1["ice5"][4]  +  srb1["blank5"][4]) * srb1.num
                 }, 
["shootRate5_10"] = {
                    srb1["base5"][5] / 5 * srb1.num, 
                    srb1["base5"][5] * 2 / 5 * srb1.num, 
                    srb1["base5"][5] * 3 / 5 * srb1.num, 
                    srb1["base5"][5] * 4 / 5 * srb1.num, 
                    srb1["base5"][5] * srb1.num, 
                    (srb1["base5"][5]  +  srb1["mul5"][5]) * srb1.num, 
                    (srb1["base5"][5]  +  srb1["mul5"][5]  +  srb1["bomb5"][5]) * srb1.num, 
                    (srb1["base5"][5]  +  srb1["mul5"][5]  +  srb1["bomb5"][5]  +  srb1["steel5"][5]) * srb1.num, 
                    (srb1["base5"][5]  +  srb1["mul5"][5]  +  srb1["bomb5"][5]  +  srb1["steel5"][5]  +  srb1["ice5"][5]) * srb1.num, 
                    (srb1["base5"][5]  +  srb1["mul5"][5]  +  srb1["bomb5"][5]  +  srb1["steel5"][5]  +  srb1["ice5"][5]  +  srb1["blank5"][5]) * srb1.num
                 }, 

["shootRate6_7"] = {
                    srb1["base6"][1] * srb1.num, 
                    (srb1["base6"][1]  +  srb1["mul6"][1]) * srb1.num, 
                    (srb1["base6"][1]  +  srb1["mul6"][1]  +  srb1["bomb6"][1]) * srb1.num, 
                    (srb1["base6"][1]  +  srb1["mul6"][1]  +  srb1["bomb6"][1]  +  srb1["steel6"][1]) * srb1.num, 
                    (srb1["base6"][1]  +  srb1["mul6"][1]  +  srb1["bomb6"][1]  +  srb1["steel6"][1]  +  srb1["ice6"][1]) * srb1.num, 
                    (srb1["base6"][1]  +  srb1["mul6"][1]  +  srb1["bomb6"][1]  +  srb1["steel6"][1]  +  srb1["ice6"][1]  +  srb1["blank6"][1]) * srb1.num, 
                    (srb1["base6"][1]  +  srb1["mul6"][1]  +  srb1["bomb6"][1]  +  srb1["steel6"][1]  +  srb1["ice6"][1]  +  srb1["blank6"][1]  +  srb1["v6"][1]) * srb1.num
                 }, 
["shootRate6_8"] = {
                    srb1["base6"][2] / 2 * srb1.num, 
                    srb1["base6"][2] * srb1.num, 
                    (srb1["base6"][2]  +  srb1["mul6"][2]) * srb1.num, 
                    (srb1["base6"][2]  +  srb1["mul6"][2]  +  srb1["bomb6"][2]) * srb1.num, 
                    (srb1["base6"][2]  +  srb1["mul6"][2]  +  srb1["bomb6"][2]  +  srb1["steel6"][2]) * srb1.num, 
                    (srb1["base6"][2]  +  srb1["mul6"][2]  +  srb1["bomb6"][2]  +  srb1["steel6"][2]  +  srb1["ice6"][2]) * srb1.num, 
                    (srb1["base6"][2]  +  srb1["mul6"][2]  +  srb1["bomb6"][2]  +  srb1["steel6"][2]  +  srb1["ice6"][2]  +  srb1["blank6"][2]) * srb1.num, 
                    (srb1["base6"][2]  +  srb1["mul6"][2]  +  srb1["bomb6"][2]  +  srb1["steel6"][2]  +  srb1["ice6"][2]  +  srb1["blank6"][2]  +  srb1["v6"][2]) * srb1.num
                 }, 
["shootRate6_9"] = {
                    srb1["base6"][3] / 3 * srb1.num, 
                    srb1["base6"][3] * 2 / 3 * srb1.num, 
                    srb1["base6"][3] * srb1.num, 
                    (srb1["base6"][3]  +  srb1["mul6"][3]) * srb1.num, 
                    (srb1["base6"][3]  +  srb1["mul6"][3]  +  srb1["bomb6"][3]) * srb1.num, 
                    (srb1["base6"][3]  +  srb1["mul6"][3]  +  srb1["bomb6"][3]  +  srb1["steel6"][3]) * srb1.num, 
                    (srb1["base6"][3]  +  srb1["mul6"][3]  +  srb1["bomb6"][3]  +  srb1["steel6"][3]  +  srb1["ice6"][3]) * srb1.num, 
                    (srb1["base6"][3]  +  srb1["mul6"][3]  +  srb1["bomb6"][3]  +  srb1["steel6"][3]  +  srb1["ice6"][3]  +  srb1["blank6"][3]) * srb1.num, 
                    (srb1["base6"][3]  +  srb1["mul6"][3]  +  srb1["bomb6"][3]  +  srb1["steel6"][3]  +  srb1["ice6"][3]  +  srb1["blank6"][3]  +  srb1["v6"][3]) * srb1.num
                 }, 
["shootRate6_10"] = {
                    srb1["base6"][4] / 4 * srb1.num, 
                    srb1["base6"][4] * 2 / 4 * srb1.num, 
                    srb1["base6"][4] * 3 / 4 * srb1.num, 
                    srb1["base6"][4] * srb1.num, 
                    (srb1["base6"][4]  +  srb1["mul6"][4]) * srb1.num, 
                    (srb1["base6"][4]  +  srb1["mul6"][4]  +  srb1["bomb6"][4]) * srb1.num, 
                    (srb1["base6"][4]  +  srb1["mul6"][4]  +  srb1["bomb6"][4]  +  srb1["steel6"][4]) * srb1.num, 
                    (srb1["base6"][4]  +  srb1["mul6"][4]  +  srb1["bomb6"][4]  +  srb1["steel6"][4]  +  srb1["ice6"][4]) * srb1.num, 
                    (srb1["base6"][4]  +  srb1["mul6"][4]  +  srb1["bomb6"][4]  +  srb1["steel6"][4]  +  srb1["ice6"][4]  +  srb1["blank6"][4]) * srb1.num, 
                    (srb1["base6"][4]  +  srb1["mul6"][4]  +  srb1["bomb6"][4]  +  srb1["steel6"][4]  +  srb1["ice6"][4]  +  srb1["blank6"][4]  +  srb1["v6"][4]) * srb1.num
                 }, 
["shootRate6_11"] = {
                    srb1["base6"][5] / 5 * srb1.num, 
                    srb1["base6"][5] * 2 / 5 * srb1.num, 
                    srb1["base6"][5] * 3 / 5 * srb1.num, 
                    srb1["base6"][5] * 4 / 5 * srb1.num, 
                    srb1["base6"][5] * srb1.num, 
                    (srb1["base6"][5]  +  srb1["mul6"][5]) * srb1.num, 
                    (srb1["base6"][5]  +  srb1["mul6"][5]  +  srb1["bomb6"][5]) * srb1.num, 
                    (srb1["base6"][5]  +  srb1["mul6"][5]  +  srb1["bomb6"][5]  +  srb1["steel6"][5]) * srb1.num, 
                    (srb1["base6"][5]  +  srb1["mul6"][5]  +  srb1["bomb6"][5]  +  srb1["steel6"][5]  +  srb1["ice6"][5]) * srb1.num, 
                    (srb1["base6"][5]  +  srb1["mul6"][5]  +  srb1["bomb6"][5]  +  srb1["steel6"][5]  +  srb1["ice6"][5]  +  srb1["blank6"][5]) * srb1.num, 
                    (srb1["base6"][5]  +  srb1["mul6"][5]  +  srb1["bomb6"][5]  +  srb1["steel6"][5]  +  srb1["ice6"][5]  +  srb1["blank6"][5]  +  srb1["v6"][5]) * srb1.num
                 }, 
}

shootTableAlls_up2 = {
["shootRate1_2"] = {
                    srb2["base1"][1] * srb2.num, 
                    (srb2["base1"][1]  +  srb2["mul1"][1]) * srb2.num
                 }, 
["shootRate1_3"] = {
                    srb2["base1"][2] / 2 * srb2.num, 
                    srb2["base1"][2] * srb2.num, 
                    (srb2["base1"][2]  +  srb2["mul1"][2]) * srb2.num
                 }, 
["shootRate1_4"] = {
                    srb2["base1"][3] / 3 * srb2.num, 
                    srb2["base1"][3] * 2 / 3 * srb2.num, 
                    srb2["base1"][3] * srb2.num, 
                    (srb2["base1"][3]  +  srb2["mul1"][3]) * srb2.num
                 }, 
["shootRate1_5"] = {
                    srb2["base1"][4] / 4 * srb2.num, 
                    srb2["base1"][4] * 2 / 4 * srb2.num, 
                    srb2["base1"][4] * 3 / 4 * srb2.num, 
                    srb2["base1"][4] * srb2.num, 
                    (srb2["base1"][4]  +  srb2["mul1"][4]) * srb2.num
                 }, 
["shootRate1_6"] = {
                    srb2["base1"][5] / 5 * srb2.num, 
                    srb2["base1"][5] * 2 / 5 * srb2.num, 
                    srb2["base1"][5] * 3 / 5 * srb2.num, 
                    srb2["base1"][5] * 4 / 5 * srb2.num, 
                    srb2["base1"][5] * srb2.num, 
                    (srb2["base1"][5]  +  srb2["mul1"][5]) * srb2.num
                 }, 
["shootRate2_3"] = {
                    srb2["base2"][1] * srb2.num, 
                    (srb2["base2"][1]  +  srb2["mul2"][1]) * srb2.num, 
                    (srb2["base2"][1]  +  srb2["mul2"][1]  +  srb2["bomb2"][1]) * srb2.num
                 }, 
["shootRate2_4"] = {
                    srb2["base2"][2] / 2 * srb2.num, 
                    srb2["base2"][2] * srb2.num, 
                    (srb2["base2"][2]  +  srb2["mul2"][2]) * srb2.num, 
                    (srb2["base2"][2]  +  srb2["mul2"][2]  +  srb2["bomb2"][2]) * srb2.num
                 }, 
["shootRate2_5"] = {
                    srb2["base2"][3] / 3 * srb2.num, 
                    srb2["base2"][3] * 2 / 3 * srb2.num, 
                    srb2["base2"][3] * srb2.num, 
                    (srb2["base2"][3]  +  srb2["mul2"][3]) * srb2.num, 
                    (srb2["base2"][3]  +  srb2["mul2"][3]  +  srb2["bomb2"][3]) * srb2.num
                 }, 
["shootRate2_6"] = {
                    srb2["base2"][4] / 4 * srb2.num, 
                    srb2["base2"][4] * 2 / 4 * srb2.num, 
                    srb2["base2"][4] * 3 / 4 * srb2.num, 
                    srb2["base2"][4] * srb2.num, 
                    (srb2["base2"][4]  +  srb2["mul2"][4]) * srb2.num, 
                    (srb2["base2"][4]  +  srb2["mul2"][4]  +  srb2["bomb2"][4]) * srb2.num
                 }, 
["shootRate2_7"] = {
                    srb2["base2"][5] / 5 * srb2.num, 
                    srb2["base2"][5] * 2 / 5 * srb2.num, 
                    srb2["base2"][5] * 3 / 5 * srb2.num, 
                    srb2["base2"][5] * 4 / 5 * srb2.num, 
                    srb2["base2"][5] * srb2.num, 
                    (srb2["base2"][5]  +  srb2["mul2"][5]) * srb2.num, 
                    (srb2["base2"][5]  +  srb2["mul2"][5]  +  srb2["bomb2"][5]) * srb2.num
                 }, 
["shootRate3_4"] = {
                    srb2["base3"][1] * srb2.num, 
                    (srb2["base3"][1]  +  srb2["mul3"][1]) * srb2.num, 
                    (srb2["base3"][1]  +  srb2["mul3"][1]  +  srb2["bomb3"][1]) * srb2.num, 
                    (srb2["base3"][1]  +  srb2["mul3"][1]  +  srb2["bomb3"][1]  +  srb2["steel3"][1]) * srb2.num
                 }, 
["shootRate3_5"] = {
                    srb2["base3"][2] / 2 * srb2.num, 
                    srb2["base3"][2] * srb2.num, 
                    (srb2["base3"][2]  +  srb2["mul3"][2]) * srb2.num, 
                    (srb2["base3"][2]  +  srb2["mul3"][2]  +  srb2["bomb3"][2]) * srb2.num, 
                    (srb2["base3"][2]  +  srb2["mul3"][2]  +  srb2["bomb3"][2]  +  srb2["steel3"][2]) * srb2.num
                 }, 
["shootRate3_6"] = {
                    srb2["base3"][3] / 3 * srb2.num, 
                    srb2["base3"][3] * 2 / 3 * srb2.num, 
                    srb2["base3"][3] * srb2.num, 
                    (srb2["base3"][3]  +  srb2["mul3"][3]) * srb2.num, 
                    (srb2["base3"][3]  +  srb2["mul3"][3]  +  srb2["bomb3"][3]) * srb2.num, 
                    (srb2["base3"][3]  +  srb2["mul3"][3]  +  srb2["bomb3"][3]  +  srb2["steel3"][3]) * srb2.num
                 }, 
["shootRate3_7"] = {
                    srb2["base3"][4] / 4 * srb2.num, 
                    srb2["base3"][4] * 2 / 4 * srb2.num, 
                    srb2["base3"][4] * 3 / 4 * srb2.num, 
                    srb2["base3"][4] * srb2.num, 
                    (srb2["base3"][4]  +  srb2["mul3"][4]) * srb2.num, 
                    (srb2["base3"][4]  +  srb2["mul3"][4]  +  srb2["bomb3"][4]) * srb2.num, 
                    (srb2["base3"][4]  +  srb2["mul3"][4]  +  srb2["bomb3"][4]  +  srb2["steel3"][4]) * srb2.num
                 }, 
["shootRate3_8"] = {
                    srb2["base3"][5] / 5 * srb2.num, 
                    srb2["base3"][5] * 2 / 5 * srb2.num, 
                    srb2["base3"][5] * 3 / 5 * srb2.num, 
                    srb2["base3"][5] * 4 / 5 * srb2.num, 
                    srb2["base3"][5] * srb2.num, 
                    (srb2["base3"][5]  +  srb2["mul3"][5]) * srb2.num, 
                    (srb2["base3"][5]  +  srb2["mul3"][5]  +  srb2["bomb3"][5]) * srb2.num, 
                    (srb2["base3"][5]  +  srb2["mul3"][5]  +  srb2["bomb3"][5]  +  srb2["steel3"][5]) * srb2.num
                 }, 
["shootRate4_5"] = {
                    srb2["base4"][1] * srb2.num, 
                    (srb2["base4"][1]  +  srb2["mul4"][1]) * srb2.num, 
                    (srb2["base4"][1]  +  srb2["mul4"][1]  +  srb2["bomb4"][1]) * srb2.num, 
                    (srb2["base4"][1]  +  srb2["mul4"][1]  +  srb2["bomb4"][1]  +  srb2["steel4"][1]) * srb2.num, 
                    (srb2["base4"][1]  +  srb2["mul4"][1]  +  srb2["bomb4"][1]  +  srb2["steel4"][1]  +  srb2["ice4"][1]) * srb2.num
                 }, 
["shootRate4_6"] = {
                    srb2["base4"][2] / 2 * srb2.num, 
                    srb2["base4"][2] * srb2.num, 
                    (srb2["base4"][2]  +  srb2["mul4"][2]) * srb2.num, 
                    (srb2["base4"][2]  +  srb2["mul4"][2]  +  srb2["bomb4"][2]) * srb2.num, 
                    (srb2["base4"][2]  +  srb2["mul4"][2]  +  srb2["bomb4"][2]  +  srb2["steel4"][2]) * srb2.num, 
                    (srb2["base4"][2]  +  srb2["mul4"][2]  +  srb2["bomb4"][2]  +  srb2["steel4"][2]  +  srb2["ice4"][2]) * srb2.num
                 }, 
["shootRate4_7"] = {
                    srb2["base4"][3] / 3 * srb2.num, 
                    srb2["base4"][3] * 2 / 3 * srb2.num, 
                    srb2["base4"][3] * srb2.num, 
                    (srb2["base4"][3]  +  srb2["mul4"][3]) * srb2.num, 
                    (srb2["base4"][3]  +  srb2["mul4"][3]  +  srb2["bomb4"][3]) * srb2.num, 
                    (srb2["base4"][3]  +  srb2["mul4"][3]  +  srb2["bomb4"][3]  +  srb2["steel4"][3]) * srb2.num, 
                    (srb2["base4"][3]  +  srb2["mul4"][3]  +  srb2["bomb4"][3]  +  srb2["steel4"][3]  +  srb2["ice4"][3]) * srb2.num
                 }, 
["shootRate4_8"] = {
                    srb2["base4"][4] / 4 * srb2.num, 
                    srb2["base4"][4] * 2 / 4 * srb2.num, 
                    srb2["base4"][4] * 3 / 4 * srb2.num, 
                    srb2["base4"][4] * srb2.num, 
                    (srb2["base4"][4]  +  srb2["mul4"][4]) * srb2.num, 
                    (srb2["base4"][4]  +  srb2["mul4"][4]  +  srb2["bomb4"][4]) * srb2.num, 
                    (srb2["base4"][4]  +  srb2["mul4"][4]  +  srb2["bomb4"][4]  +  srb2["steel4"][4]) * srb2.num, 
                    (srb2["base4"][4]  +  srb2["mul4"][4]  +  srb2["bomb4"][4]  +  srb2["steel4"][4]  +  srb2["ice4"][4]) * srb2.num
                 }, 
["shootRate4_9"] = {
                    srb2["base4"][5] / 5 * srb2.num, 
                    srb2["base4"][5] * 2 / 5 * srb2.num, 
                    srb2["base4"][5] * 3 / 5 * srb2.num, 
                    srb2["base4"][5] * 4 / 5 * srb2.num, 
                    srb2["base4"][5] * srb2.num, 
                    (srb2["base4"][5]  +  srb2["mul4"][5]) * srb2.num, 
                    (srb2["base4"][5]  +  srb2["mul4"][5]  +  srb2["bomb4"][5]) * srb2.num, 
                    (srb2["base4"][5]  +  srb2["mul4"][5]  +  srb2["bomb4"][5]  +  srb2["steel4"][5]) * srb2.num, 
                    (srb2["base4"][5]  +  srb2["mul4"][5]  +  srb2["bomb4"][5]  +  srb2["steel4"][5]  +  srb2["ice4"][4]) * srb2.num
                 }, 
["shootRate5_6"] = {
                    srb2["base5"][1] * srb2.num, 
                    (srb2["base5"][1]  +  srb2["mul5"][1]) * srb2.num, 
                    (srb2["base5"][1]  +  srb2["mul5"][1]  +  srb2["bomb5"][1]) * srb2.num, 
                    (srb2["base5"][1]  +  srb2["mul5"][1]  +  srb2["bomb5"][1]  +  srb2["steel5"][1]) * srb2.num, 
                    (srb2["base5"][1]  +  srb2["mul5"][1]  +  srb2["bomb5"][1]  +  srb2["steel5"][1]  +  srb2["ice5"][1]) * srb2.num, 
                    (srb2["base5"][1]  +  srb2["mul5"][1]  +  srb2["bomb5"][1]  +  srb2["steel5"][1]  +  srb2["ice5"][1]  +  srb2["blank5"][1]) * srb2.num
                 }, 
["shootRate5_7"] = {
                    srb2["base5"][2] / 2 * srb2.num, 
                    srb2["base5"][2] * srb2.num, 
                    (srb2["base5"][2]  +  srb2["mul5"][2]) * srb2.num, 
                    (srb2["base5"][2]  +  srb2["mul5"][2]  +  srb2["bomb5"][2]) * srb2.num, 
                    (srb2["base5"][2]  +  srb2["mul5"][2]  +  srb2["bomb5"][2]  +  srb2["steel5"][2]) * srb2.num, 
                    (srb2["base5"][2]  +  srb2["mul5"][2]  +  srb2["bomb5"][2]  +  srb2["steel5"][2]  +  srb2["ice5"][2]) * srb2.num, 
                    (srb2["base5"][2]  +  srb2["mul5"][2]  +  srb2["bomb5"][2]  +  srb2["steel5"][2]  +  srb2["ice5"][2]  +  srb2["blank5"][2]) * srb2.num
                 }, 
["shootRate5_8"] = {
                    srb2["base5"][3] / 3 * srb2.num, 
                    srb2["base5"][3] * 2 / 3 * srb2.num, 
                    srb2["base5"][3] * srb2.num, 
                    (srb2["base5"][3]  +  srb2["mul5"][3]) * srb2.num, 
                    (srb2["base5"][3]  +  srb2["mul5"][3]  +  srb2["bomb5"][3]) * srb2.num, 
                    (srb2["base5"][3]  +  srb2["mul5"][3]  +  srb2["bomb5"][3]  +  srb2["steel5"][3]) * srb2.num, 
                    (srb2["base5"][3]  +  srb2["mul5"][3]  +  srb2["bomb5"][3]  +  srb2["steel5"][3]  +  srb2["ice5"][3]) * srb2.num, 
                    (srb2["base5"][3]  +  srb2["mul5"][3]  +  srb2["bomb5"][3]  +  srb2["steel5"][3]  +  srb2["ice5"][3]  +  srb2["blank5"][3]) * srb2.num
                 }, 
["shootRate5_9"] = {
                    srb2["base5"][4] / 4 * srb2.num, 
                    srb2["base5"][4] * 2 / 4 * srb2.num, 
                    srb2["base5"][4] * 3 / 4 * srb2.num, 
                    srb2["base5"][4] * srb2.num, 
                    (srb2["base5"][4]  +  srb2["mul5"][4]) * srb2.num, 
                    (srb2["base5"][4]  +  srb2["mul5"][4]  +  srb2["bomb5"][4]) * srb2.num, 
                    (srb2["base5"][4]  +  srb2["mul5"][4]  +  srb2["bomb5"][4]  +  srb2["steel5"][4]) * srb2.num, 
                    (srb2["base5"][4]  +  srb2["mul5"][4]  +  srb2["bomb5"][4]  +  srb2["steel5"][4]  +  srb2["ice5"][4]) * srb2.num, 
                    (srb2["base5"][4]  +  srb2["mul5"][4]  +  srb2["bomb5"][4]  +  srb2["steel5"][4]  +  srb2["ice5"][4]  +  srb2["blank5"][4]) * srb2.num
                 }, 
["shootRate5_10"] = {
                    srb2["base5"][5] / 5 * srb2.num, 
                    srb2["base5"][5] * 2 / 5 * srb2.num, 
                    srb2["base5"][5] * 3 / 5 * srb2.num, 
                    srb2["base5"][5] * 4 / 5 * srb2.num, 
                    srb2["base5"][5] * srb2.num, 
                    (srb2["base5"][5]  +  srb2["mul5"][5]) * srb2.num, 
                    (srb2["base5"][5]  +  srb2["mul5"][5]  +  srb2["bomb5"][5]) * srb2.num, 
                    (srb2["base5"][5]  +  srb2["mul5"][5]  +  srb2["bomb5"][5]  +  srb2["steel5"][5]) * srb2.num, 
                    (srb2["base5"][5]  +  srb2["mul5"][5]  +  srb2["bomb5"][5]  +  srb2["steel5"][5]  +  srb2["ice5"][5]) * srb2.num, 
                    (srb2["base5"][5]  +  srb2["mul5"][5]  +  srb2["bomb5"][5]  +  srb2["steel5"][5]  +  srb2["ice5"][5]  +  srb2["blank5"][5]) * srb2.num
                 }, 

["shootRate6_7"] = {
                    srb2["base6"][1] * srb2.num, 
                    (srb2["base6"][1]  +  srb2["mul6"][1]) * srb2.num, 
                    (srb2["base6"][1]  +  srb2["mul6"][1]  +  srb2["bomb6"][1]) * srb2.num, 
                    (srb2["base6"][1]  +  srb2["mul6"][1]  +  srb2["bomb6"][1]  +  srb2["steel6"][1]) * srb2.num, 
                    (srb2["base6"][1]  +  srb2["mul6"][1]  +  srb2["bomb6"][1]  +  srb2["steel6"][1]  +  srb2["ice6"][1]) * srb2.num, 
                    (srb2["base6"][1]  +  srb2["mul6"][1]  +  srb2["bomb6"][1]  +  srb2["steel6"][1]  +  srb2["ice6"][1]  +  srb2["blank6"][1]) * srb2.num, 
                    (srb2["base6"][1]  +  srb2["mul6"][1]  +  srb2["bomb6"][1]  +  srb2["steel6"][1]  +  srb2["ice6"][1]  +  srb2["blank6"][1]  +  srb2["v6"][1]) * srb2.num
                 }, 
["shootRate6_8"] = {
                    srb2["base6"][2] / 2 * srb2.num, 
                    srb2["base6"][2] * srb2.num, 
                    (srb2["base6"][2]  +  srb2["mul6"][2]) * srb2.num, 
                    (srb2["base6"][2]  +  srb2["mul6"][2]  +  srb2["bomb6"][2]) * srb2.num, 
                    (srb2["base6"][2]  +  srb2["mul6"][2]  +  srb2["bomb6"][2]  +  srb2["steel6"][2]) * srb2.num, 
                    (srb2["base6"][2]  +  srb2["mul6"][2]  +  srb2["bomb6"][2]  +  srb2["steel6"][2]  +  srb2["ice6"][2]) * srb2.num, 
                    (srb2["base6"][2]  +  srb2["mul6"][2]  +  srb2["bomb6"][2]  +  srb2["steel6"][2]  +  srb2["ice6"][2]  +  srb2["blank6"][2]) * srb2.num, 
                    (srb2["base6"][2]  +  srb2["mul6"][2]  +  srb2["bomb6"][2]  +  srb2["steel6"][2]  +  srb2["ice6"][2]  +  srb2["blank6"][2]  +  srb2["v6"][2]) * srb2.num
                 }, 
["shootRate6_9"] = {
                    srb2["base6"][3] / 3 * srb2.num, 
                    srb2["base6"][3] * 2 / 3 * srb2.num, 
                    srb2["base6"][3] * srb2.num, 
                    (srb2["base6"][3]  +  srb2["mul6"][3]) * srb2.num, 
                    (srb2["base6"][3]  +  srb2["mul6"][3]  +  srb2["bomb6"][3]) * srb2.num, 
                    (srb2["base6"][3]  +  srb2["mul6"][3]  +  srb2["bomb6"][3]  +  srb2["steel6"][3]) * srb2.num, 
                    (srb2["base6"][3]  +  srb2["mul6"][3]  +  srb2["bomb6"][3]  +  srb2["steel6"][3]  +  srb2["ice6"][3]) * srb2.num, 
                    (srb2["base6"][3]  +  srb2["mul6"][3]  +  srb2["bomb6"][3]  +  srb2["steel6"][3]  +  srb2["ice6"][3]  +  srb2["blank6"][3]) * srb2.num, 
                    (srb2["base6"][3]  +  srb2["mul6"][3]  +  srb2["bomb6"][3]  +  srb2["steel6"][3]  +  srb2["ice6"][3]  +  srb2["blank6"][3]  +  srb2["v6"][3]) * srb2.num
                 }, 
["shootRate6_10"] = {
                    srb2["base6"][4] / 4 * srb2.num, 
                    srb2["base6"][4] * 2 / 4 * srb2.num, 
                    srb2["base6"][4] * 3 / 4 * srb2.num, 
                    srb2["base6"][4] * srb2.num, 
                    (srb2["base6"][4]  +  srb2["mul6"][4]) * srb2.num, 
                    (srb2["base6"][4]  +  srb2["mul6"][4]  +  srb2["bomb6"][4]) * srb2.num, 
                    (srb2["base6"][4]  +  srb2["mul6"][4]  +  srb2["bomb6"][4]  +  srb2["steel6"][4]) * srb2.num, 
                    (srb2["base6"][4]  +  srb2["mul6"][4]  +  srb2["bomb6"][4]  +  srb2["steel6"][4]  +  srb2["ice6"][4]) * srb2.num, 
                    (srb2["base6"][4]  +  srb2["mul6"][4]  +  srb2["bomb6"][4]  +  srb2["steel6"][4]  +  srb2["ice6"][4]  +  srb2["blank6"][4]) * srb2.num, 
                    (srb2["base6"][4]  +  srb2["mul6"][4]  +  srb2["bomb6"][4]  +  srb2["steel6"][4]  +  srb2["ice6"][4]  +  srb2["blank6"][4]  +  srb2["v6"][4]) * srb2.num
                 }, 
["shootRate6_11"] = {
                    srb2["base6"][5] / 5 * srb2.num, 
                    srb2["base6"][5] * 2 / 5 * srb2.num, 
                    srb2["base6"][5] * 3 / 5 * srb2.num, 
                    srb2["base6"][5] * 4 / 5 * srb2.num, 
                    srb2["base6"][5] * srb2.num, 
                    (srb2["base6"][5]  +  srb2["mul6"][5]) * srb2.num, 
                    (srb2["base6"][5]  +  srb2["mul6"][5]  +  srb2["bomb6"][5]) * srb2.num, 
                    (srb2["base6"][5]  +  srb2["mul6"][5]  +  srb2["bomb6"][5]  +  srb2["steel6"][5]) * srb2.num, 
                    (srb2["base6"][5]  +  srb2["mul6"][5]  +  srb2["bomb6"][5]  +  srb2["steel6"][5]  +  srb2["ice6"][5]) * srb2.num, 
                    (srb2["base6"][5]  +  srb2["mul6"][5]  +  srb2["bomb6"][5]  +  srb2["steel6"][5]  +  srb2["ice6"][5]  +  srb2["blank6"][5]) * srb2.num, 
                    (srb2["base6"][5]  +  srb2["mul6"][5]  +  srb2["bomb6"][5]  +  srb2["steel6"][5]  +  srb2["ice6"][5]  +  srb2["blank6"][5]  +  srb2["v6"][5]) * srb2.num
                 }, 
}

shootTableAlls_up3  =  {
["shootRate1_2"] = {
                    srb3["base1"][1] * srb3.num, 
                    (srb3["base1"][1] + srb3["mul1"][1]) * srb3.num
                 }, 
["shootRate1_3"] = {
                    srb3["base1"][2] / 2 * srb3.num, 
                    srb3["base1"][2] * srb3.num, 
                    (srb3["base1"][2]  +  srb3["mul1"][2]) * srb3.num
                 }, 
["shootRate1_4"] = {
                    srb3["base1"][3] / 3 * srb3.num, 
                    srb3["base1"][3] * 2 / 3 * srb3.num, 
                    srb3["base1"][3] * srb3.num, 
                    (srb3["base1"][3] + srb3["mul1"][3]) * srb3.num
                 }, 
["shootRate1_5"] = {
                    srb3["base1"][4] / 4 * srb3.num, 
                    srb3["base1"][4] * 2 / 4 * srb3.num, 
                    srb3["base1"][4] * 3 / 4 * srb3.num, 
                    srb3["base1"][4] * srb3.num, 
                    (srb3["base1"][4]  +  srb3["mul1"][4]) * srb3.num
                 }, 
["shootRate1_6"] = {
                    srb3["base1"][5] / 5 * srb3.num, 
                    srb3["base1"][5] * 2 / 5 * srb3.num, 
                    srb3["base1"][5] * 3 / 5 * srb3.num, 
                    srb3["base1"][5] * 4 / 5 * srb3.num, 
                    srb3["base1"][5] * srb3.num, 
                    (srb3["base1"][5]  +  srb3["mul1"][5]) * srb3.num
                 }, 
["shootRate2_3"] = {
                    srb3["base2"][1] * srb3.num, 
                    (srb3["base2"][1]  +  srb3["mul2"][1]) * srb3.num, 
                    (srb3["base2"][1]  +  srb3["mul2"][1]  +  srb3["bomb2"][1]) * srb3.num
                 }, 
["shootRate2_4"] = {
                    srb3["base2"][2] / 2 * srb3.num, 
                    srb3["base2"][2] * srb3.num, 
                    (srb3["base2"][2] + srb3["mul2"][2]) * srb3.num, 
                    (srb3["base2"][2] + srb3["mul2"][2]  +  srb3["bomb2"][2]) * srb3.num
                 }, 
["shootRate2_5"] = {
                    srb3["base2"][3] / 3 * srb3.num, 
                    srb3["base2"][3] * 2 / 3 * srb3.num, 
                    srb3["base2"][3] * srb3.num, 
                    (srb3["base2"][3]  +  srb3["mul2"][3]) * srb3.num, 
                    (srb3["base2"][3]  +  srb3["mul2"][3]  +  srb3["bomb2"][3]) * srb3.num
                 }, 
["shootRate2_6"] = {
                    srb3["base2"][4] / 4 * srb3.num, 
                    srb3["base2"][4] * 2 / 4 * srb3.num, 
                    srb3["base2"][4] * 3 / 4 * srb3.num, 
                    srb3["base2"][4] * srb3.num, 
                    (srb3["base2"][4]  +  srb3["mul2"][4]) * srb3.num, 
                    (srb3["base2"][4]  +  srb3["mul2"][4]  +  srb3["bomb2"][4]) * srb3.num
                 }, 
["shootRate2_7"] = {
                    srb3["base2"][5] / 5 * srb3.num, 
                    srb3["base2"][5] * 2 / 5 * srb3.num, 
                    srb3["base2"][5] * 3 / 5 * srb3.num, 
                    srb3["base2"][5] * 4 / 5 * srb3.num, 
                    srb3["base2"][5] * srb3.num, 
                    (srb3["base2"][5]  +  srb3["mul2"][5]) * srb3.num, 
                    (srb3["base2"][5]  +  srb3["mul2"][5]  +  srb3["bomb2"][5]) * srb3.num
                 }, 
["shootRate3_4"] = {
                    srb3["base3"][1] * srb3.num, 
                    (srb3["base3"][1]  +  srb3["mul3"][1]) * srb3.num, 
                    (srb3["base3"][1]  +  srb3["mul3"][1]  +  srb3["bomb3"][1]) * srb3.num, 
                    (srb3["base3"][1]  +  srb3["mul3"][1]  +  srb3["bomb3"][1]  +  srb3["steel3"][1]) * srb3.num
                 }, 
["shootRate3_5"] = {
                    srb3["base3"][2] / 2 * srb3.num, 
                    srb3["base3"][2] * srb3.num, 
                    (srb3["base3"][2]  +  srb3["mul3"][2]) * srb3.num, 
                    (srb3["base3"][2]  +  srb3["mul3"][2]  +  srb3["bomb3"][2]) * srb3.num, 
                    (srb3["base3"][2]  +  srb3["mul3"][2]  +  srb3["bomb3"][2]  +  srb3["steel3"][2]) * srb3.num
                 }, 
["shootRate3_6"] = {
                    srb3["base3"][3] / 3 * srb3.num, 
                    srb3["base3"][3] * 2 / 3 * srb3.num, 
                    srb3["base3"][3] * srb3.num, 
                    (srb3["base3"][3]  +  srb3["mul3"][3]) * srb3.num, 
                    (srb3["base3"][3]  +  srb3["mul3"][3]  +  srb3["bomb3"][3]) * srb3.num, 
                    (srb3["base3"][3]  +  srb3["mul3"][3]  +  srb3["bomb3"][3]  +  srb3["steel3"][3]) * srb3.num
                 }, 
["shootRate3_7"] = {
                    srb3["base3"][4] / 4 * srb3.num, 
                    srb3["base3"][4] * 2 / 4 * srb3.num, 
                    srb3["base3"][4] * 3 / 4 * srb3.num, 
                    srb3["base3"][4] * srb3.num, 
                    (srb3["base3"][4]  +  srb3["mul3"][4]) * srb3.num, 
                    (srb3["base3"][4]  +  srb3["mul3"][4]  +  srb3["bomb3"][4]) * srb3.num, 
                    (srb3["base3"][4]  +  srb3["mul3"][4]  +  srb3["bomb3"][4]  +  srb3["steel3"][4]) * srb3.num
                 }, 
["shootRate3_8"] = {
                    srb3["base3"][5] / 5 * srb3.num, 
                    srb3["base3"][5] * 2 / 5 * srb3.num, 
                    srb3["base3"][5] * 3 / 5 * srb3.num, 
                    srb3["base3"][5] * 4 / 5 * srb3.num, 
                    srb3["base3"][5] * srb3.num, 
                    (srb3["base3"][5]  +  srb3["mul3"][5]) * srb3.num, 
                    (srb3["base3"][5]  +  srb3["mul3"][5]  +  srb3["bomb3"][5]) * srb3.num, 
                    (srb3["base3"][5]  +  srb3["mul3"][5]  +  srb3["bomb3"][5]  +  srb3["steel3"][5]) * srb3.num
                 }, 
["shootRate4_5"] = {
                    srb3["base4"][1] * srb3.num, 
                    (srb3["base4"][1]  +  srb3["mul4"][1]) * srb3.num, 
                    (srb3["base4"][1]  +  srb3["mul4"][1]  +  srb3["bomb4"][1]) * srb3.num, 
                    (srb3["base4"][1]  +  srb3["mul4"][1]  +  srb3["bomb4"][1]  +  srb3["steel4"][1]) * srb3.num, 
                    (srb3["base4"][1]  +  srb3["mul4"][1]  +  srb3["bomb4"][1]  +  srb3["steel4"][1]  +  srb3["ice4"][1]) * srb3.num
                 }, 
["shootRate4_6"] = {
                    srb3["base4"][2] / 2 * srb3.num, 
                    srb3["base4"][2] * srb3.num, 
                    (srb3["base4"][2]  +  srb3["mul4"][2]) * srb3.num, 
                    (srb3["base4"][2]  +  srb3["mul4"][2]  +  srb3["bomb4"][2]) * srb3.num, 
                    (srb3["base4"][2]  +  srb3["mul4"][2]  +  srb3["bomb4"][2]  +  srb3["steel4"][2]) * srb3.num, 
                    (srb3["base4"][2]  +  srb3["mul4"][2]  +  srb3["bomb4"][2]  +  srb3["steel4"][2]  +  srb3["ice4"][2]) * srb3.num
                 }, 
["shootRate4_7"] = {
                    srb3["base4"][3] / 3 * srb3.num, 
                    srb3["base4"][3] * 2 / 3 * srb3.num, 
                    srb3["base4"][3] * srb3.num, 
                    (srb3["base4"][3]  +  srb3["mul4"][3]) * srb3.num, 
                    (srb3["base4"][3]  +  srb3["mul4"][3]  +  srb3["bomb4"][3]) * srb3.num, 
                    (srb3["base4"][3]  +  srb3["mul4"][3]  +  srb3["bomb4"][3]  +  srb3["steel4"][3]) * srb3.num, 
                    (srb3["base4"][3]  +  srb3["mul4"][3]  +  srb3["bomb4"][3]  +  srb3["steel4"][3]  +  srb3["ice4"][3]) * srb3.num
                 }, 
["shootRate4_8"] = {
                    srb3["base4"][4] / 4 * srb3.num, 
                    srb3["base4"][4] * 2 / 4 * srb3.num, 
                    srb3["base4"][4] * 3 / 4 * srb3.num, 
                    srb3["base4"][4] * srb3.num, 
                    (srb3["base4"][4]  +  srb3["mul4"][4]) * srb3.num, 
                    (srb3["base4"][4]  +  srb3["mul4"][4]  +  srb3["bomb4"][4]) * srb3.num, 
                    (srb3["base4"][4]  +  srb3["mul4"][4]  +  srb3["bomb4"][4]  +  srb3["steel4"][4]) * srb3.num, 
                    (srb3["base4"][4]  +  srb3["mul4"][4]  +  srb3["bomb4"][4]  +  srb3["steel4"][4]  +  srb3["ice4"][4]) * srb3.num
                 }, 
["shootRate4_9"] = {
                    srb3["base4"][5] / 5 * srb3.num, 
                    srb3["base4"][5] * 2 / 5 * srb3.num, 
                    srb3["base4"][5] * 3 / 5 * srb3.num, 
                    srb3["base4"][5] * 4 / 5 * srb3.num, 
                    srb3["base4"][5] * srb3.num, 
                    (srb3["base4"][5]  +  srb3["mul4"][5]) * srb3.num, 
                    (srb3["base4"][5]  +  srb3["mul4"][5]  +  srb3["bomb4"][5]) * srb3.num, 
                    (srb3["base4"][5]  +  srb3["mul4"][5]  +  srb3["bomb4"][5]  +  srb3["steel4"][5]) * srb3.num, 
                    (srb3["base4"][5]  +  srb3["mul4"][5]  +  srb3["bomb4"][5]  +  srb3["steel4"][5]  +  srb3["ice4"][4]) * srb3.num
                 }, 
["shootRate5_6"] = {
                    srb3["base5"][1] * srb3.num, 
                    (srb3["base5"][1]  +  srb3["mul5"][1]) * srb3.num, 
                    (srb3["base5"][1]  +  srb3["mul5"][1]  +  srb3["bomb5"][1]) * srb3.num, 
                    (srb3["base5"][1]  +  srb3["mul5"][1]  +  srb3["bomb5"][1]  +  srb3["steel5"][1]) * srb3.num, 
                    (srb3["base5"][1]  +  srb3["mul5"][1]  +  srb3["bomb5"][1]  +  srb3["steel5"][1]  +  srb3["ice5"][1]) * srb3.num, 
                    (srb3["base5"][1]  +  srb3["mul5"][1]  +  srb3["bomb5"][1]  +  srb3["steel5"][1]  +  srb3["ice5"][1]  +  srb3["blank5"][1]) * srb3.num
                 }, 
["shootRate5_7"] = {
                    srb3["base5"][2] / 2 * srb3.num, 
                    srb3["base5"][2] * srb3.num, 
                    (srb3["base5"][2]  +  srb3["mul5"][2]) * srb3.num, 
                    (srb3["base5"][2]  +  srb3["mul5"][2]  +  srb3["bomb5"][2]) * srb3.num, 
                    (srb3["base5"][2]  +  srb3["mul5"][2]  +  srb3["bomb5"][2]  +  srb3["steel5"][2]) * srb3.num, 
                    (srb3["base5"][2]  +  srb3["mul5"][2]  +  srb3["bomb5"][2]  +  srb3["steel5"][2]  +  srb3["ice5"][2]) * srb3.num, 
                    (srb3["base5"][2]  +  srb3["mul5"][2]  +  srb3["bomb5"][2]  +  srb3["steel5"][2]  +  srb3["ice5"][2]  +  srb3["blank5"][2]) * srb3.num
                 }, 
["shootRate5_8"] = {
                    srb3["base5"][3] / 3 * srb3.num, 
                    srb3["base5"][3] * 2 / 3 * srb3.num, 
                    srb3["base5"][3] * srb3.num, 
                    (srb3["base5"][3]  +  srb3["mul5"][3]) * srb3.num, 
                    (srb3["base5"][3]  +  srb3["mul5"][3]  +  srb3["bomb5"][3]) * srb3.num, 
                    (srb3["base5"][3]  +  srb3["mul5"][3]  +  srb3["bomb5"][3]  +  srb3["steel5"][3]) * srb3.num, 
                    (srb3["base5"][3]  +  srb3["mul5"][3]  +  srb3["bomb5"][3]  +  srb3["steel5"][3]  +  srb3["ice5"][3]) * srb3.num, 
                    (srb3["base5"][3]  +  srb3["mul5"][3]  +  srb3["bomb5"][3]  +  srb3["steel5"][3]  +  srb3["ice5"][3]  +  srb3["blank5"][3]) * srb3.num
                 }, 
["shootRate5_9"] = {
                    srb3["base5"][4] / 4 * srb3.num, 
                    srb3["base5"][4] * 2 / 4 * srb3.num, 
                    srb3["base5"][4] * 3 / 4 * srb3.num, 
                    srb3["base5"][4] * srb3.num, 
                    (srb3["base5"][4]  +  srb3["mul5"][4]) * srb3.num, 
                    (srb3["base5"][4]  +  srb3["mul5"][4]  +  srb3["bomb5"][4]) * srb3.num, 
                    (srb3["base5"][4]  +  srb3["mul5"][4]  +  srb3["bomb5"][4]  +  srb3["steel5"][4]) * srb3.num, 
                    (srb3["base5"][4]  +  srb3["mul5"][4]  +  srb3["bomb5"][4]  +  srb3["steel5"][4]  +  srb3["ice5"][4]) * srb3.num, 
                    (srb3["base5"][4]  +  srb3["mul5"][4]  +  srb3["bomb5"][4]  +  srb3["steel5"][4]  +  srb3["ice5"][4]  +  srb3["blank5"][4]) * srb3.num
                 }, 
["shootRate5_10"] = {
                    srb3["base5"][5] / 5 * srb3.num, 
                    srb3["base5"][5] * 2 / 5 * srb3.num, 
                    srb3["base5"][5] * 3 / 5 * srb3.num, 
                    srb3["base5"][5] * 4 / 5 * srb3.num, 
                    srb3["base5"][5] * srb3.num, 
                    (srb3["base5"][5]  +  srb3["mul5"][5]) * srb3.num, 
                    (srb3["base5"][5]  +  srb3["mul5"][5]  +  srb3["bomb5"][5]) * srb3.num, 
                    (srb3["base5"][5]  +  srb3["mul5"][5]  +  srb3["bomb5"][5]  +  srb3["steel5"][5]) * srb3.num, 
                    (srb3["base5"][5]  +  srb3["mul5"][5]  +  srb3["bomb5"][5]  +  srb3["steel5"][5]  +  srb3["ice5"][5]) * srb3.num, 
                    (srb3["base5"][5]  +  srb3["mul5"][5]  +  srb3["bomb5"][5]  +  srb3["steel5"][5]  +  srb3["ice5"][5]  +  srb3["blank5"][5]) * srb3.num
                 }, 

["shootRate6_7"] = {
                    srb3["base6"][1] * srb3.num, 
                    (srb3["base6"][1]  +  srb3["mul6"][1]) * srb3.num, 
                    (srb3["base6"][1]  +  srb3["mul6"][1]  +  srb3["bomb6"][1]) * srb3.num, 
                    (srb3["base6"][1]  +  srb3["mul6"][1]  +  srb3["bomb6"][1]  +  srb3["steel6"][1]) * srb3.num, 
                    (srb3["base6"][1]  +  srb3["mul6"][1]  +  srb3["bomb6"][1]  +  srb3["steel6"][1]  +  srb3["ice6"][1]) * srb3.num, 
                    (srb3["base6"][1]  +  srb3["mul6"][1]  +  srb3["bomb6"][1]  +  srb3["steel6"][1]  +  srb3["ice6"][1]  +  srb3["blank6"][1]) * srb3.num, 
                    (srb3["base6"][1]  +  srb3["mul6"][1]  +  srb3["bomb6"][1]  +  srb3["steel6"][1]  +  srb3["ice6"][1]  +  srb3["blank6"][1]  +  srb3["v6"][1]) * srb3.num
                 }, 
["shootRate6_8"] = {
                    srb3["base6"][2] / 2 * srb3.num, 
                    srb3["base6"][2] * srb3.num, 
                    (srb3["base6"][2]  +  srb3["mul6"][2]) * srb3.num, 
                    (srb3["base6"][2]  +  srb3["mul6"][2]  +  srb3["bomb6"][2]) * srb3.num, 
                    (srb3["base6"][2]  +  srb3["mul6"][2]  +  srb3["bomb6"][2]  +  srb3["steel6"][2]) * srb3.num, 
                    (srb3["base6"][2]  +  srb3["mul6"][2]  +  srb3["bomb6"][2]  +  srb3["steel6"][2]  +  srb3["ice6"][2]) * srb3.num, 
                    (srb3["base6"][2]  +  srb3["mul6"][2]  +  srb3["bomb6"][2]  +  srb3["steel6"][2]  +  srb3["ice6"][2]  +  srb3["blank6"][2]) * srb3.num, 
                    (srb3["base6"][2]  +  srb3["mul6"][2]  +  srb3["bomb6"][2]  +  srb3["steel6"][2]  +  srb3["ice6"][2]  +  srb3["blank6"][2]  +  srb3["v6"][2]) * srb3.num
                 }, 
["shootRate6_9"] = {
                    srb3["base6"][3] / 3 * srb3.num, 
                    srb3["base6"][3] * 2 / 3 * srb3.num, 
                    srb3["base6"][3] * srb3.num, 
                    (srb3["base6"][3]  +  srb3["mul6"][3]) * srb3.num, 
                    (srb3["base6"][3]  +  srb3["mul6"][3]  +  srb3["bomb6"][3]) * srb3.num, 
                    (srb3["base6"][3]  +  srb3["mul6"][3]  +  srb3["bomb6"][3]  +  srb3["steel6"][3]) * srb3.num, 
                    (srb3["base6"][3]  +  srb3["mul6"][3]  +  srb3["bomb6"][3]  +  srb3["steel6"][3]  +  srb3["ice6"][3]) * srb3.num, 
                    (srb3["base6"][3]  +  srb3["mul6"][3]  +  srb3["bomb6"][3]  +  srb3["steel6"][3]  +  srb3["ice6"][3]  +  srb3["blank6"][3]) * srb3.num, 
                    (srb3["base6"][3]  +  srb3["mul6"][3]  +  srb3["bomb6"][3]  +  srb3["steel6"][3]  +  srb3["ice6"][3]  +  srb3["blank6"][3]  +  srb3["v6"][3]) * srb3.num
                 }, 
["shootRate6_10"] = {
                    srb3["base6"][4] / 4 * srb3.num, 
                    srb3["base6"][4] * 2 / 4 * srb3.num, 
                    srb3["base6"][4] * 3 / 4 * srb3.num, 
                    srb3["base6"][4] * srb3.num, 
                    (srb3["base6"][4]  +  srb3["mul6"][4]) * srb3.num, 
                    (srb3["base6"][4]  +  srb3["mul6"][4]  +  srb3["bomb6"][4]) * srb3.num, 
                    (srb3["base6"][4]  +  srb3["mul6"][4]  +  srb3["bomb6"][4]  +  srb3["steel6"][4]) * srb3.num, 
                    (srb3["base6"][4]  +  srb3["mul6"][4]  +  srb3["bomb6"][4]  +  srb3["steel6"][4]  +  srb3["ice6"][4]) * srb3.num, 
                    (srb3["base6"][4]  +  srb3["mul6"][4]  +  srb3["bomb6"][4]  +  srb3["steel6"][4]  +  srb3["ice6"][4]  +  srb3["blank6"][4]) * srb3.num, 
                    (srb3["base6"][4]  +  srb3["mul6"][4]  +  srb3["bomb6"][4]  +  srb3["steel6"][4]  +  srb3["ice6"][4]  +  srb3["blank6"][4]  +  srb3["v6"][4]) * srb3.num
                 }, 
["shootRate6_11"] = {
                    srb3["base6"][5] / 5 * srb3.num, 
                    srb3["base6"][5] * 2 / 5 * srb3.num, 
                    srb3["base6"][5] * 3 / 5 * srb3.num, 
                    srb3["base6"][5] * 4 / 5 * srb3.num, 
                    srb3["base6"][5] * srb3.num, 
                    (srb3["base6"][5]  +  srb3["mul6"][5]) * srb3.num, 
                    (srb3["base6"][5]  +  srb3["mul6"][5]  +  srb3["bomb6"][5]) * srb3.num, 
                    (srb3["base6"][5]  +  srb3["mul6"][5]  +  srb3["bomb6"][5]  +  srb3["steel6"][5]) * srb3.num, 
                    (srb3["base6"][5]  +  srb3["mul6"][5]  +  srb3["bomb6"][5]  +  srb3["steel6"][5]  +  srb3["ice6"][5]) * srb3.num, 
                    (srb3["base6"][5]  +  srb3["mul6"][5]  +  srb3["bomb6"][5]  +  srb3["steel6"][5]  +  srb3["ice6"][5]  +  srb3["blank6"][5]) * srb3.num, 
                    (srb3["base6"][5]  +  srb3["mul6"][5]  +  srb3["bomb6"][5]  +  srb3["steel6"][5]  +  srb3["ice6"][5]  +  srb3["blank6"][5]  +  srb3["v6"][5]) * srb3.num
                 }, 
}

rateLev = {first = 4, second = 16, third = 30, fourth = 47, fifth = 56, six = 64, con1 = 4, con2 = 5, color = 8}
--4, 16, 30, 47, 56, 64

----特殊球解锁概率
--{解锁等级，概率}
rateSpeUnlock = 
{
    ["bub31"] = {14, 100}, 
    ["bub30"] = {28, 100}, 
    ["bub29"] = {45, 100}, 
    ["bub26"] = {62, 100}, 
    ["bub36"] = {54, 100}
}
unlockNums = 5
--解锁的球
speUnlockBub = {26, 36, 29, 30, 31}
--解锁的等级
speUnlockLev = {62, 54, 45, 28, 14}
